import QtQuick 1.0

Rectangle {
    id: barsClubsDetail
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        barsClubsDetail.state = "";
        barsClubsDetail.state = "hideLeft"
        barsClubsDetail.state = "show"
    }

    function showPageFromRight()
    {
        barsClubsDetail.state = "";
        barsClubsDetail.state = "hideRight"
        barsClubsDetail.state = "show"
    }

    function hidePageToLeft()
    {
        barsClubsDetail.state = "";
        barsClubsDetail.state = "show"
        barsClubsDetail.state = "hideLeft"

        timer.running = false
    }

    function hidePageToRight()
    {
        barsClubsDetail.state = "";
        barsClubsDetail.state = "show"
        barsClubsDetail.state = "hideRight"

        timer.running = false
    }
    //----------------------- End ---------------------------------------

    //------------- Page Data ------------------------------------------
    property string f_title: "";
    property string f_desc: "";
    property string f_thumb: "";
    property string f_apiUrl: "";

    property string f_uid: "";
    property string f_name: "";
    property string f_color: "";
    property string f_address: "";
    property string f_phone: "";
    property string f_url: "";
    property string f_travelInfo: "";
    property string f_openingTimes: "";
    property string f_price: "";
    property string f_description: "";
    property string f_imageUrl: "";
    property string f_lat: "";
    property string f_lng: "";
    property string f_webUrl: "";

    property string f_totalRating: "";
    property string f_foodRating: "";
    property string f_decorRating: "";
    property string f_serviceRating: "";
    property string f_ambienceRating: "";
    property string f_valueRating: "";

    property string f_inAreaRestaurants: "";
    property string f_inAreaBars: "";

    function receiveGeneralData(uid, name, color, address,
                                phone, url, travelInfo, openingTimes,
                                price, description, imageUrl, lat,
                                lng, webUrl, inAreaRestaurants, inAreaBars)
    {
        loadingCover.hideLoadingCover();
        textFlick.opacity = 1;

        console.log("-------------------------" + name)

        f_uid = uid
        f_name = name
        f_color = color
        f_address = address
        f_phone = phone
        f_url = url
        f_travelInfo = travelInfo
        f_openingTimes = openingTimes
        f_price = price
        f_description = description
        f_imageUrl = imageUrl
        f_lat = lat
        f_lng = lng
        f_webUrl = webUrl
        f_inAreaRestaurants = inAreaRestaurants
        f_inAreaBars = inAreaBars

        timer.running = true
    }

    function revceiveRatingsData(rating, name)
    {
        if(name == "total") {
            f_totalRating = rating;
            for(i=0; i<rating; i++)
                topRatingListModel.get(i).image = "images/starOn.png";
        }
        if(name == "Ambience") {
            f_ambienceRating = rating;
            for(i=0; i<rating; i++)
                ambienceRatingListModel.get(i).image = "images/starOn.png";
        }
        if(name == "Decor") {
            f_decorRating = rating;
            for(i=0; i<rating; i++)
                serviceRatingListModel.get(i).image = "images/starOn.png";
        }
        if(name == "Music") {
            f_serviceRating = rating;
            for(i=0; i<rating; i++)
                decorRatingListModel.get(i).image = "images/starOn.png";
        }
        if(name == "Service") {
            f_serviceRating = rating;
            for(i=0; i<rating; i++)
                overallRatingListModel.get(i).image = "images/starOn.png";
        }
    }

    function receiveDetailData(name, detail)
    {
        detailListModel.append({
           "elementName": name,
           "elementDetail": detail
        })
    }

    function resetData()
    {
        f_title = "";
        f_desc = "";
        f_thumb = "";
        f_apiUrl = "";

        f_uid = "";
        f_name = "";
        f_color = "";
        f_address = "";
        f_phone = "";
        f_url = "";
        f_travelInfo = "";
        f_openingTimes = "";
        f_price = "";
        f_description = "";
        f_imageUrl = "";
        f_lat = "";
        f_lng = "";
        f_webUrl = "";

        f_totalRating = "";
        f_foodRating = "";
        f_decorRating = "";
        f_serviceRating = "";
        f_ambienceRating = "";
        f_valueRating = "";

        f_inAreaRestaurants = ""
        f_inAreaBars = ""

        for(i=0; i<7; i++) {
            topRatingListModel.get(i).image = "images/starOff.png";
            overallRatingListModel.get(i).image = "images/starOff.png";
            decorRatingListModel.get(i).image = "images/starOff.png";
            serviceRatingListModel.get(i).image = "images/starOff.png";
            ambienceRatingListModel.get(i).image = "images/starOff.png";
        }

        detailListModel.clear();

        textFlick.opacity = 0;
        textFlick.contentY = 0;
    }

    //-------------- Favourite Infomation Handling ------------------
    signal sendFavouriteInfo(string uid, string title, string desc, string thumb,
                             string apiUrl, string area, string venues);
    function sendFavouriteInfoFn()
    {
        if(f_title != "")
        {
            sql.addFavouriteIoFo(f_uid, f_title, f_desc, f_thumb, f_apiUrl, "BarsClubs", "No", "", "", "");
        }
        else if(f_title == "")
        {
            sql.addFavouriteIoFo(f_uid, f_name, f_description, f_imageUrl, f_apiUrl, "BarsClubs", "No", "", "", "");
        }
    }

    function changeFavouriteButton()
    {
        if(glValue.ifExistFlag == true)
        {
            favouriteButton.source ="images/favouriteButtonOn.png"
        }
        else
        {
            favouriteButton.source ="images/favouriteButton.png"
        }
    }

    signal requireNearbyData(string f_inAreaRestaurants)
    signal requireNearbyBarsClubsData(string f_inAreaBars)

    Timer {
        id: timer
        interval: 50; running: false; repeat: true
        onTriggered: setData()
    }

    function setData()
    {
        detailListView.height = detailListView.contentHeight;

        line_4.y = edit.y + edit.paintedHeight + 10
    }

    Flickable {
        id: textFlick
        width: 360 * glValue.appUIWidth / 360;
        height: barsClubsDetail.height;
        contentWidth: 360 * glValue.appUIWidth / 360;
        contentHeight: overallRating.y + overallRating.height + 15 * glValue.appUIHeight / 640
        flickableDirection: Flickable.VerticalFlick
        clip: true
        opacity: 0

        Text {
            id: titleText
            x: 10 * glValue.appUIWidth / 360
            y: 10 * glValue.appUIHeight / 640
            width: 340 * glValue.appUIWidth / 360
            height: 40 * glValue.appUIHeight / 640
            verticalAlignment: Text.AlignVCenter
            font.pixelSize: 40
            font.bold: true
            wrapMode: "WordWrap"
            text: f_name
        }

        Text {
            id: subTitleText
            x: 10 * glValue.appUIWidth / 360
            y: titleText.paintedHeight + titleText.y
            width: 340 * glValue.appUIWidth / 360
            height: subTitleText.paintedHeight * glValue.appUIHeight / 640
            verticalAlignment: Text.AlignTop
            font.pixelSize: 25
            wrapMode: "WordWrap"
            text: f_address
        }

        Image {
            id: line_1
            x: 8 * glValue.appUIWidth / 360
            y: subTitleText.height + subTitleText.y + 5
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Item {
            id: topStar
            x: 8 * glValue.appUIWidth / 360
            y: line_1.height + line_1.y + 10
            width: 360 * glValue.appUIWidth / 360;
            height: 30 * glValue.appUIHeight / 640

            ListModel {
                id: topRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: topRatingComponent

                Item {
                    id: topRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: topRatingListView
                anchors.fill: parent
                model: topRatingListModel
                delegate: topRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Image {
            x: 280 * glValue.appUIWidth / 360
            y: line_1.height + line_1.y + 3 * glValue.appUIHeight / 640
            width: 73 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/mapButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    loadingCover.showLoadingCover()

                    mapsHomePage.resetData()
                    mapsHomePage.lat = f_lat;
                    mapsHomePage.lng = f_lng;
                    mapsHomePage.zoom = "17";

                    mapsHomePage.showMap();

                    mapsHomePage.showPageFromRight();
                    barsClubsDetail.hidePageToLeft();

                    glValue.homeCurrentPage = "mapsHomePageBarsClubs"
                    glValue.currentPage = "mapsHomePageBarsClubs"
                }
            }
        }

        Image {
            id: mainImage
            x: 0
            y: topStar.y + topStar.height + 8 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: (360/1.6667) * glValue.appUIHeight / 640
            source: f_imageUrl
            state: "hide"

            states:
            [
                State
                {
                    name: "show"
                    PropertyChanges { target: mainImage; opacity: 1 }
                },
                State
                {
                    name: "hide"
                    PropertyChanges { target: mainImage; opacity: 0 }
                }
            ]
            transitions:
            [
                Transition {
                    from: "hide"; to: "show"
                    PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                }
            ]

            onStatusChanged: {
                if(mainImage.status == 2) {
                    mainImageBusy.opacity = 0.8
                    rotation.running = true
                }
                else if(mainImage.status == 1) {
                    mainImageBusy.opacity = 0
                    rotation.running = false
                    mainImage.state = "show"
                }
            }
        }

        Image {
            id: mainImageBusy
            anchors.centerIn: mainImage
            width: 35
            height: 35
            smooth: true
            opacity: 1
            source: "images/busy.png"

            RotationAnimation on rotation {
                id: rotation
                loops: 10000
                from: 0
                to: 360
                duration: 1200
            }
        }

        Image {
            x: 8 * glValue.appUIWidth / 360
            y: mainImage.y + mainImage.height + 10 * glValue.appUIHeight / 640
            width: 29 * glValue.appUIWidth / 360
            height: 35 * glValue.appUIHeight / 640
            source: "images/phoneButton.png"
        }

        Text {
            x: 50 * glValue.appUIWidth / 360
            y: mainImage.y + mainImage.height + 10 * glValue.appUIHeight / 640
            font.pixelSize: 30
            text: f_phone
        }

        Image {
            id: callButton
            x: 240 * glValue.appUIWidth / 360
            y: mainImage.y + mainImage.height + 8 * glValue.appUIHeight / 640
            width: 115 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/callButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    var temp = f_phone.replace(" ", "");
                    temp = temp.replace(" ", "");
                    temp = temp.replace(" ", "");
                    temp = temp.replace(" ", "");
                    temp = temp.replace(" ", "");

                    Qt.openUrlExternally("tel:" + temp + "")
                    console.log("tel:<" + temp + ">")
                }
            }
        }

        Image {
            id: line_2
            x: 8 * glValue.appUIWidth / 360
            y: callButton.height + callButton.y + 8 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Image {
            x: 8 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 10 * glValue.appUIHeight / 640
            width: 34 * glValue.appUIWidth / 360
            height: 34 * glValue.appUIHeight / 640
            source: "images/websiteButton.png"
        }

        Text {
            x: 50 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 10 * glValue.appUIHeight / 640
            font.pixelSize: 30
            text: "Website"
        }

        Image {
            id: viewButton
            x: 240 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 8 * glValue.appUIHeight / 640
            width: 115 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/viewButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    Qt.openUrlExternally(f_webUrl)
                }
            }
        }

        Image {
            id: line_3
            x: 8 * glValue.appUIWidth / 360
            y: viewButton.height + viewButton.y + 8 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: timeoutSays
            x: 8 * glValue.appUIWidth / 360
            y: line_3.height + line_3.y + 8 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 30
            text: "TimeOut Dubai says..."
        }

        TextEdit {
            id: edit
            x: 8 * glValue.appUIWidth / 360
            y: timeoutSays.height + timeoutSays.y
            width: 344 * glValue.appUIWidth / 360
            height: edit.paintedHeight
            wrapMode: TextEdit.Wrap
            text: f_description
            readOnly: true
            font.pixelSize: 25
            focus: false
        }

        Image {
            id: line_4
            x: 8 * glValue.appUIWidth / 360
            y: 0
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: detailsText
            x: 8 * glValue.appUIWidth / 360
            y: line_4.height + line_4.y + 8 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 30
            text: "Details"
        }

        Item {
            id: detailList
            x: 8 * glValue.appUIWidth / 360
            y: detailsText.height + detailsText.y + 10 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: detailListView.contentHeight

            ListModel {
                id: detailListModel
            }

            Component {
                id: detailComponent

                Item {
                    id: detailDelegateItem
                    width: 344 * glValue.appUIWidth / 360
                    height: detailTextDetail.y + detailTextDetail.paintedHeight

                    Text {
                        id: detailTitleText
                        x: 0
                        y: 0
                        width: parent.width
                        font.pixelSize: 25
                        font.bold: true
                        text: elementName
                    }

                    Text {
                        id: detailTextDetail
                        x: 0
                        y: detailTitleText.paintedHeight + 3 * glValue.appUIHeight / 640
                        width: parent.width
                        wrapMode: "WordWrap"
                        font.pixelSize: 25
                        text: elementDetail
                    }
                }
            }

            ListView {
                id: detailListView
                x: 0
                y: 0
                width: parent.width
                height: 0
                model: detailListModel
                delegate: detailComponent
                interactive: false
            }
        }

        Image {
            id: line_5
            x: 8 * glValue.appUIWidth / 360
            y: detailList.height + detailList.y + 8 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Image {
            id: favouriteButton
            x: 10 * glValue.appUIWidth / 360
            y: line_5.height + line_5.y + 8 * glValue.appUIHeight / 640
            width: 160 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: {
                if(glValue.ifExistFlag == false)
                {
                    "images/favouriteButton.png"
                }
                else if(glValue.ifExistFlag == true)
                {
                    "images/favouriteButtonOn.png"
                }
            }

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    if(f_name != "Oops! Sorry...")
                    {
                        if(glValue.ifExistFlag == false)
                        {
                            sendFavouriteInfoFn();
                            favouriteButton.source = "images/favouriteButtonOn.png"
                            glValue.ifExistFlag = true
                        }
                        else if(glValue.ifExistFlag == true)
                        {
                            sql.checkIfFavouritesExisted(f_title, f_desc, f_thumb, f_apiUrl)
                            if(glValue.ifExistFlag == true)
                            {
                                sql.deleteFavouritesExisted(f_title, f_desc, f_thumb, f_apiUrl)
                                favouriteButton.source = "images/favouriteButton.png"
                                glValue.ifExistFlag = false
                            }
                            else if(glValue.ifExistFlag == false)
                            {
                                glValue.ifExistFlag = false
                                favouriteButton.source = "images/favouriteButton.png"
                            }
                        }
                    }
                    else
                    {
                        return;
                    }
                }
            }
        }

        Image {
            id: shareButtonImage
            x: 190 * glValue.appUIWidth / 360
            y: line_5.height + line_5.y + 8 * glValue.appUIHeight / 640
            width: 160 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/shareButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    sharePage.title = f_title;
                    sharePage.url = f_webUrl;

                    sharePage.showsharePage();
                }
            }
        }

        Image {
            id: nearbyButtonImage
            x: 10 * glValue.appUIWidth / 360
            y: shareButtonImage.height + shareButtonImage.y + 8 * glValue.appUIHeight / 640
            width: 160 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/nearbyButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    if(f_name != "Oops! Sorry...")
                    {
                        loadingCover.showLoadingCover();
                        requireNearbyData(f_inAreaRestaurants)
                        requireNearbyBarsClubsData(f_inAreaBars)
                        console.log("----"+f_inAreaBars)
                        barsClubsDetail.hidePageToLeft()
                        nearbyList.showPageFromRight()

                        glValue.currentPage = "nearbyList"
                        glValue.homeCurrentPage = "nearbyList"
                        glValue.nearbySelectedPage = "barsClubsDetail"
                    }
                    else
                    {
                        return;
                    }
                }
            }
        }

        Image {
            id: line_6
            x: 8 * glValue.appUIWidth / 360
            y: nearbyButtonImage.height + nearbyButtonImage.y + 8 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: averageRatingText
            x: 8 * glValue.appUIWidth / 360
            y: line_6.height + line_6.y + 10 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Average user rating(25 ratings)"
        }

        Text {
            id: ambienceRatingText
            x: 8 * glValue.appUIWidth / 360
            y: averageRatingText.height + averageRatingText.y + 10 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Ambience"
        }

        Item {
            id: ambienceRating
            x: 110 * glValue.appUIWidth / 360
            y: averageRatingText.height + averageRatingText.y + 10 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: 30 * glValue.appUIHeight / 640

            ListModel {
                id: ambienceRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: ambienceRatingComponent

                Item {
                    id: ambienceRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: ambienceRatingListView
                anchors.fill: parent
                model:ambienceRatingListModel
                delegate: ambienceRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Text {
            id: serviceRatingText
            x: 8 * glValue.appUIWidth / 360
            y: ambienceRatingText.height + ambienceRatingText.y + 10 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Dector"
        }

        Item {
            id: serviceRating
            x: 110 * glValue.appUIWidth / 360
            y: ambienceRatingText.height + ambienceRatingText.y + 10 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: 30 * glValue.appUIHeight / 640

            ListModel {
                id: serviceRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: serviceRatingComponent

                Item {
                    id: serviceRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: serviceRatingListView
                anchors.fill: parent
                model:serviceRatingListModel
                delegate: serviceRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Text {
            id: decorRatingText
            x: 8 * glValue.appUIWidth / 360
            y: serviceRatingText.height + serviceRatingText.y + 10 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Music"
        }

        Item {
            id: decorRating
            x: 110 * glValue.appUIWidth / 360
            y: serviceRatingText.height + serviceRatingText.y + 10 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: 30 * glValue.appUIHeight / 640

            ListModel {
                id: decorRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: decorRatingComponent

                Item {
                    id: decorRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: decorRatingListView
                anchors.fill: parent
                model:decorRatingListModel
                delegate: decorRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Text {
            id: overallRatingText
            x: 8 * glValue.appUIWidth / 360
            y: decorRatingText.height + decorRatingText.y + 10 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Service"
        }

        Item {
            id: overallRating
            x: 110 * glValue.appUIWidth / 360
            y: decorRatingText.height + decorRatingText.y + 10 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: 30 * glValue.appUIHeight / 640

            ListModel {
                id: overallRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: overallRatingComponent

                Item {
                    id: overallRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: overallRatingListView
                anchors.fill: parent
                model:overallRatingListModel
                delegate: overallRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: barsClubsDetail; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: barsClubsDetail; x: -barsClubsDetail.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: barsClubsDetail; x: barsClubsDetail.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
