import QtQuick 1.0

Rectangle {
    id: blankCover
    color: "black"
    opacity: 0

    MouseArea {
        anchors.fill: parent
        onClicked: {}
    }

    function showPage()
    {
        blankCover.state = "show"
    }

    function hidePage()
    {
        blankCover.state = "hide"
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: blankCover; opacity: 0.5 }
        },
        State
        {
            name: "hide"
            PropertyChanges { target: blankCover; opacity: 0 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hide"
            PropertyAnimation { properties: "opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hide"; to: "show"
            PropertyAnimation { properties: "opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
