import QtQuick 1.0
import "./javascript/APIsRequest.js" as APIsRequest

Rectangle {
    id: cinemaDetail
    state: "hideLeft"

    property int marginSize: 15

    function showPageFromLeft()
    {
        cinemaDetail.state = "";
        cinemaDetail.state = "hideLeft"
        cinemaDetail.state = "show"
    }

    function showPageFromRight()
    {
        cinemaDetail.state = "";
        cinemaDetail.state = "hideRight"
        cinemaDetail.state = "show"
    }

    function hidePageToLeft()
    {
        cinemaDetail.state = "";
        cinemaDetail.state = "show"
        cinemaDetail.state = "hideLeft"
    }

    function hidePageToRight()
    {
        cinemaDetail.state = "";
        cinemaDetail.state = "show"
        cinemaDetail.state = "hideRight"
    }

    property string cinemaType: "";
    property string cinemaUid: "";
    property string cinemaName: "";
    property string cinemaAddress: "";
    property string cinemaPhone: "";
    property string cinemaUrl: "";
    property string cinemaLat: "";
    property string cinemaLng: "";
    property string cinemaWebUrl: "";

    function resetData()
    {
        cinemaUid = "";
        cinemaName = "";
        cinemaAddress = "";
        cinemaPhone = "";
        cinemaUrl = "";
        cinemaLat = "";
        cinemaLng = "";
        cinemaWebUrl = "";
    }

    function getFilmData(uid)
    {
        loadingCover.showLoadingCover();

        function requestCinemaDetail() {}
        requestCinemaDetail.prototype = {
            update: function(status, result)
                    {
                        var root = result.documentElement;

                        if(root == undefined)
                        {
                            loadingCover.hideLoadingCover();

                            return "error";
                        }

                        for(var i_1=0; i_1<root.childNodes.length; i_1++)
                        {
                            if(root.nodeName != "toxml") {
                                //Warning
                            }
                            else
                            {
                                loadingCover.hideLoadingCover();

                                if(root.childNodes[i_1].nodeName == "response")
                                {
                                    var nodesRow = root.childNodes[i_1].childNodes[0];
                                    cinemaType = nodesRow.attributes[0].value;
                                    for(var i_2=0; i_2<nodesRow.childNodes.length; i_2++)
                                    {
                                        if(nodesRow.childNodes[i_2].nodeName == "uid")
                                            cinemaUid = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "name")
                                            cinemaName = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "address")
                                            cinemaAddress = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "phone")
                                            cinemaPhone = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "url")
                                            cinemaUrl = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "lat")
                                            cinemaLat = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "lng")
                                            cinemaLng = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "webUrl")
                                            cinemaWebUrl = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                    }
                                }
                            }
                        }
                    }
        }

        var searchString = "http://www.timeoutdubai.com/webservice/getCinema?uid=" + uid;
        APIsRequest.getWebserviceData(searchString, new requestCinemaDetail());
    }

    Flickable {
        id: flickView
        x: marginSize
        y: 0
        width: parent.width - marginSize * 2
        height: parent.height
        contentWidth: width
        contentHeight: webUrlBG.y + webUrlBG.height + marginSize
        clip: true

        Text {
            id: titleText
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.right: parent.right
            font.pixelSize: 40
            font.bold: true
            wrapMode: "WordWrap"
            text: cinemaName
        }

        Image {
            id: titleUnderline
            anchors.top: titleText.bottom
            anchors.left: titleText.left
            anchors.right: titleText.right
            source: "images/line.png"
        }

        Rectangle {
            id: contactBG
            anchors.top: titleUnderline.bottom
            anchors.topMargin: marginSize
            anchors.left: titleUnderline.left
            anchors.right: titleUnderline.right
            anchors.rightMargin: 1
            height: marginSize * 8
            border.width: 1
            border.color: "#c8c8c8"
            color: "#e6e6e6"
            radius: marginSize / 3 * 2
            smooth: true

            MouseArea {
                x: 0
                y: 0
                width: parent.width
                height: parent.height / 2
                onClicked: {
                    if(cinemaLat != "" && cinemaLng != "")
                    {
                        if(glValue.currentPage == "cinemaDetial")
                        {
                            loadingCover.showLoadingCover();

                            if(cinemaMapLoader.status == Loader.Null)
                                cinemaMapLoader.source = "MapsHomePage.qml"

                            cinemaMapLoader.item.lat = cinemaLat;
                            cinemaMapLoader.item.lng = cinemaLng;
                            cinemaMapLoader.item.zoom = "17";
                            cinemaMapLoader.item.showMap();

                            cinemaMapLoader.item.showPageFromRight();
                            cinemaDetail.hidePageToLeft();

                            glValue.currentPage = "cinemaMap"
                            glValue.homeCurrentPage = "cinemaMap"
                        }
                        else if(glValue.currentPage == "searchPageCinemaDetial")
                        {
                            loadingCover.showLoadingCover();

                            if(searchPageCinemaMapLoader.status == Loader.Null)
                                searchPageCinemaMapLoader.source = "MapsHomePage.qml"

                            searchPageCinemaMapLoader.item.lat = cinemaLat;
                            searchPageCinemaMapLoader.item.lng = cinemaLng;
                            searchPageCinemaMapLoader.item.zoom = "17";
                            searchPageCinemaMapLoader.item.showMap();

                            searchPageCinemaMapLoader.item.showPageFromRight();
                            cinemaDetail.hidePageToLeft();

                            glValue.currentPage = "searchPageCinemaMap"
                            glValue.searchCurrentPage = "searchPageCinemaMap"
                        }
                        else if(glValue.currentPage == "editorialsCinemaDetail")
                        {
                            loadingCover.showLoadingCover();

                            if(editorialsCinemaMapLoader.status == Loader.Null)
                                editorialsCinemaMapLoader.source = "MapsHomePage.qml"

                            editorialsCinemaMapLoader.item.lat = cinemaLat;
                            editorialsCinemaMapLoader.item.lng = cinemaLng;
                            editorialsCinemaMapLoader.item.zoom = "17";
                            editorialsCinemaMapLoader.item.showMap();

                            editorialsCinemaMapLoader.item.showPageFromRight();
                            cinemaDetail.hidePageToLeft();

                            glValue.currentPage = "editorialsCinemaMap"
                            glValue.homeCurrentPage = "editorialsCinemaMap"
                        }
                    }
                }
            }

            MouseArea {
                x: 0
                y: parent.height / 2
                width: parent.width
                height: parent.height / 2
                onClicked: {
                    if(cinemaPhone != "")
                    {
                        var tempPhone = cinemaPhone;
                        for(var i=0; i<10; i++)
                            tempPhone = tempPhone.replace(" ", "");

                        Qt.openUrlExternally("tel:" + tempPhone);
                    }
                }
            }

            Rectangle {
                id: cinemaMidLine
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.verticalCenter: parent.verticalCenter
                height: 2
                color: "#c8c8c8"
            }

            Text {
                id: cinemaAddressText
                x: marginSize
                y: (parent.height / 2 - height) / 2
                elide: Text.ElideRight
                font.pixelSize: 28
                text: cinemaAddress
            }

            Image {
                y: (parent.height / 2 - height) / 2
                anchors.right: parent.right
                anchors.rightMargin: marginSize
                source: "images/arrow.png"
            }

            Image {
                id: phoneIcon
                x: marginSize
                y: (parent.height / 2) + (parent.height / 2 - height) / 2
                source: "images/phoneButton.png"
            }

            Text {
                anchors.verticalCenter: phoneIcon.verticalCenter
                anchors.left: phoneIcon.right
                anchors.leftMargin: marginSize
                anchors.right: parent.right
                anchors.rightMargin: marginSize
                wrapMode: "WordWrap"
                font.pixelSize: 28
                opacity: 0.7
                text: cinemaPhone
            }
        }

        Rectangle {
            id: webUrlBG
            anchors.top: contactBG.bottom
            anchors.topMargin: marginSize
            anchors.left: contactBG.left
            anchors.right: contactBG.right
            anchors.rightMargin: 1
            height: marginSize * 8
            border.width: 1
            border.color: "#c8c8c8"
            color: "#e6e6e6"
            radius: marginSize / 3 * 2
            smooth: true

            MouseArea {
                x: 0
                y: 0
                width: parent.width
                height: parent.height / 2
                onClicked: {
                    if(cinemaUrl != "")
                        Qt.openUrlExternally(cinemaUrl)
                }
            }

            MouseArea {
                x: 0
                y: parent.height / 2
                width: parent.width
                height: parent.height / 2
                onClicked: {
                    if(cinemaWebUrl != "")
                        Qt.openUrlExternally(cinemaWebUrl)
                }
            }

            Rectangle {
                id: webUrlMidLine
                anchors.left: parent.left
                anchors.right: parent.right
                anchors.verticalCenter: parent.verticalCenter
                height: 2
                color: "#c8c8c8"
            }

            Text {
                id: urlText
                x: marginSize
                y: (parent.height / 2 - height) / 2
                elide: Text.ElideRight
                font.pixelSize: 28
                text: "View on cinema website"
            }

            Image {
                y: (parent.height / 2 - height) / 2
                anchors.right: parent.right
                anchors.rightMargin: marginSize
                source: "images/arrow.png"
            }

            Text {
                x: marginSize
                y: parent.height / 2 + (parent.height / 2 - height) / 2
                wrapMode: "WordWrap"
                elide: Text.ElideRight
                font.pixelSize: 28
                text: "View on Timeout website"
            }

            Image {
                y: parent.height / 2 + (parent.height / 2 - height) / 2
                anchors.right: parent.right
                anchors.rightMargin: marginSize
                source: "images/arrow.png"
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: cinemaDetail; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: cinemaDetail; x: -cinemaDetail.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: cinemaDetail; x: cinemaDetail.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
