import QtQuick 1.0

Item {
    id: favouritesPage
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        favouritesPage.state = "";
        favouritesPage.state = "hideLeft"
        favouritesPage.state = "show"
    }

    function showPageFromRight()
    {
        favouritesPage.state = "";
        favouritesPage.state = "hideRight"
        favouritesPage.state = "show"
    }

    function hidePageToLeft()
    {
        favouritesPage.state = "";
        favouritesPage.state = "show"
        favouritesPage.state = "hideLeft"
    }

    function hidePageToRight()
    {
        favouritesPage.state = "";
        favouritesPage.state = "show"
        favouritesPage.state = "hideRight"
    }
    //----------------------- End ---------------------------------------
    property string f_uid: "";
    property string f_title: "";
    property string f_desc: "";
    property string f_thumb: "";
    property string f_apiUrl: "";
    property string f_area: "";
    property string f_venues: "";
    property string f_extra1: "";
    property string f_extra2: "";
    property string f_extra3: "";

    function resetFavouritesInfo()
    {
        favouritesListModel.clear()
        f_uid = ""
        f_title = ""
        f_desc = ""
        f_thumb = ""
        f_apiUrl = ""
        f_area = ""
        f_venues = ""
        f_extra1 = ""
        f_extra2 = ""
        f_extra3 = ""
    }

    property string temp;

    function receiveGeneralData(uid, title, desc, thumb, apiUrl, area, venues, extra1, extra2, extra3)
    {

        f_uid = uid
        f_title = title
        f_desc = desc
        f_thumb = thumb
        f_apiUrl = apiUrl
        f_area = area
        f_venues = venues
        f_extra1 = extra1
        f_extra2 = extra2
        f_extra3 = extra3

        temp = f_desc.substring(0, 30)

        favouritesListModel.append({
                    "elementID": favouritesListModel.count + 1,
                    "elementUid": f_uid,
                    "elementTitle": f_title,
                    "elementDesc": f_desc,
                    "elementDesc2": temp,
                    "elementThumb": f_thumb,
                    "elementApiUrl": f_apiUrl,
                    "elementArea": f_area,
                    "elementVenues": f_venues,
                    "elementExtra1": f_extra1,
                    "elementExtra2": f_extra2,
                    "elementExtra3": f_extra3,
                    "elementDeleteButtonOpacity": "hide",
                    "elementArrowOpacity": "show"
        })

        loadingCover.hideLoadingCover();
    }

    signal requireFavouritesRestaurantDetail(string apiUrl);
    signal requireFavouritesBarsClubsDetail(string apiUrl);
    signal requireFavouritesHotelDetail(string apiUrl);
    signal requireFavouritesNightLifeDetail(string apiUrl);

    //--------------- Delete Favourites -------------------------------------------
    property bool onDeleteState: false

    function showDeleteButton()
    {
        onDeleteState = true;

        /*
        for(i=0; i<favouritesListModel.count; i++) {
            favouritesListModel.get(i).elementDeleteButtonOpacity = "show"
            favouritesListModel.get(i).elementArrowOpacity = "hide"
        }
        */
    }

    function hideDeleteButton()
    {
        onDeleteState = false;
        /*
        console.log(favouritesListModel.count)

        for(i=0; i<favouritesListModel.count; i++) {
            favouritesListModel.get(i).elementDeleteButtonOpacity = "hide"
            favouritesListModel.get(i).elementArrowOpacity = "show"
        }
        */
    }

    Item{
        id: pageContent
        x: 0
        y: 0
        width: parent.width
        height: parent.height

        Item {
            id: listContainer
            x: 14 * glValue.appUIWidth / 360
            y: 80 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: pageContent.height - 80 - 15 * glValue.appUIHeight / 640

            ListModel {
                id: favouritesListModel
            }

            Component {
                id: favouritesComponent

                Item {
                    id: favouritesDelegateItem
                    width: favouritesListView.width
                    height: 70 * glValue.appUIHeight / 640
                    smooth: true

                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            if(onDeleteState == false)
                            {
                                console.log(elementApiUrl)
                                sql.checkIfFavouritesExisted(elementTitle, elementDesc, elementThumb, elementApiUrl)
                                console.log("-----"+glValue.ifExistFlag)
                                glValue.favouritesPageSelection = elementArea;
                                if(elementArea == "Restaurant")
                                {
                                    favouritesRestaurantsDetail.resetData()

                                    loadingCover.showLoadingCover();

                                    favouritesRestaurantsDetail.f_uid = elementUid;
                                    favouritesRestaurantsDetail.f_title = elementTitle;
                                    favouritesRestaurantsDetail.f_desc = elementDesc;
                                    favouritesRestaurantsDetail.f_thumb = elementThumb;
                                    favouritesRestaurantsDetail.f_apiUrl = elementApiUrl;

                                    topBar.showBackButton();

                                    requireFavouritesRestaurantDetail(elementApiUrl);
                                    favouritesRestaurantsDetail.showPageFromRight();
                                    favouritesPage.hidePageToLeft();
                                    favouritesPage.resetFavouritesInfo()

                                    glValue.currentPage = "favouritesRestaurantsDetail"
                                    glValue.favouritesCurrentPage = "favouritesRestaurantsDetail"
                                }

                                else if(elementArea == "BarsClubs")
                                {
                                    favouritesBarsClubsDetail.resetData()

                                    loadingCover.showLoadingCover();

                                    favouritesBarsClubsDetail.f_uid = elementUid;
                                    favouritesBarsClubsDetail.f_title = elementTitle;
                                    favouritesBarsClubsDetail.f_desc = elementDesc;
                                    favouritesBarsClubsDetail.f_thumb = elementThumb;
                                    favouritesBarsClubsDetail.f_apiUrl = elementApiUrl;

                                    topBar.showBackButton();

                                    requireFavouritesBarsClubsDetail(elementApiUrl);
                                    favouritesBarsClubsDetail.showPageFromRight();
                                    favouritesPage.hidePageToLeft();
                                    favouritesPage.resetFavouritesInfo()

                                    glValue.currentPage = "favouritesBarsClubsDetail"
                                    glValue.favouritesCurrentPage = "favouritesBarsClubsDetail"
                                }
                                else if(elementArea == "Hotels")
                                {
                                    favouritesHotelDetail.resetData()

                                    loadingCover.showLoadingCover();

                                    favouritesHotelDetail.f_title = elementTitle;
                                    favouritesHotelDetail.f_desc = elementDesc;
                                    favouritesHotelDetail.f_thumb = elementThumb;
                                    favouritesHotelDetail.f_apiUrl = elementApiUrl;

                                    topBar.showBackButton();

                                    requireFavouritesHotelDetail(elementApiUrl);
                                    favouritesHotelDetail.showPageFromRight();
                                    favouritesPage.hidePageToLeft();
                                    favouritesPage.resetFavouritesInfo()

                                    glValue.currentPage = "favouritesHotelDetail"
                                    glValue.favouritesCurrentPage = "favouritesHotelDetail"
                                }
                                else if(elementArea == "NightLife")
                                {
                                    favouritesNightLifeDetail.resetData()

                                    loadingCover.showLoadingCover();

                                    favouritesNightLifeDetail.f_title = elementTitle;
                                    favouritesNightLifeDetail.f_desc = elementDesc;
                                    favouritesNightLifeDetail.f_thumb = elementThumb;
                                    favouritesNightLifeDetail.f_apiUrl = elementApiUrl;

                                    topBar.showBackButton();

                                    requireFavouritesNightLifeDetail(elementApiUrl);
                                    favouritesNightLifeDetail.showPageFromRight();
                                    favouritesPage.hidePageToLeft();
                                    favouritesPage.resetFavouritesInfo()

                                    glValue.currentPage = "favouritesNightLifeDetail"
                                    glValue.favouritesCurrentPage = "favouritesNightLifeDetail"
                                }

                            }
                        }
                    }

                    Image {
                        anchors.fill: parent
                        source: "images/listBGFull.png"
                    }

                    Image {
                        id: mainImage
                        x: 0
                        y: 0
                        width: 90 * glValue.appUIWidth / 360
                        height: 65 * glValue.appUIHeight / 640
                        fillMode: Image.PreserveAspectCrop
                        clip: true
                        source: elementThumb
                        state: "hide"

                        states:
                        [
                            State
                            {
                                name: "show"
                                PropertyChanges { target: mainImage; opacity: 1 }
                            },
                            State
                            {
                                name: "hide"
                                PropertyChanges { target: mainImage; opacity: 0 }
                            }
                        ]
                        transitions:
                        [
                            Transition {
                                from: "hide"; to: "show"
                                PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                            }
                        ]

                        onStatusChanged: {
                            if(mainImage.status == 2) {
                                mainImageBusy.opacity = 0.8
                                rotation.running = true
                            }
                            else if(mainImage.status == 1) {
                                mainImageBusy.opacity = 0
                                rotation.running = false
                                mainImage.state = "show"
                            }
                        }
                    }

                    Image {
                        id: mainImageBusy
                        anchors.centerIn: mainImage
                        width: 25
                        height: 25
                        smooth: true
                        opacity: 1
                        source: "images/busy.png"

                        RotationAnimation on rotation {
                            id: rotation
                            loops: 10000
                            from: 0
                            to: 360
                            duration: 1200
                        }
                    }

                    Text {
                        x: 100 * glValue.appUIWidth / 360
                        y: 3 * glValue.appUIHeight / 640
                        width: 190 * glValue.appUIWidth / 360
                        height: 35 * glValue.appUIHeight / 640
                        elide: Text.ElideRight
                        color: "white"
                        text: elementTitle
                        font.pixelSize: 25
                        font.bold: true
                        verticalAlignment: Text.AlignVCenter
                    }

                    Text {
                        x: 100 * glValue.appUIWidth / 360
                        y: 30 * glValue.appUIHeight / 640
                        width: 190 * glValue.appUIWidth / 360
                        height: 35 * glValue.appUIHeight / 640
                        color: "white"
                        text: elementDesc2
                        elide: Text.ElideRight
                        font.pixelSize: 20
                        verticalAlignment: Text.AlignVCenter
                    }

                    Image {
                        x: 0
                        y: 65 * glValue.appUIHeight / 640
                        width: parent.width
                        height: 5 * glValue.appUIHeight / 640
                        opacity: 1
                        source: "images/listLine.png"
                    }

                    Image {
                        id: arrowImage
                        x: 300 * glValue.appUIWidth / 360
                        y: 18 * glValue.appUIHeight / 640
                        width: 27 * glValue.appUIWidth / 360
                        height: 32 * glValue.appUIHeight / 640
                        source: "images/arrow.png"
                        state: elementArrowOpacity

                        states:
                        [
                            State
                            {
                                name: "show"
                                PropertyChanges { target: arrowImage; opacity: 1 }
                            },
                            State
                            {
                                name: "hide"
                                PropertyChanges { target: arrowImage; opacity: 0 }
                            }
                        ]
                        transitions:
                        [
                            Transition {
                                from: "show"; to: "hide"
                                PropertyAnimation { properties: "opacity"; duration: 300; easing.type: Easing.InOutQuad }
                            },
                            Transition {
                                from: "hide"; to: "show"
                                PropertyAnimation { properties: "opacity"; duration: 300; easing.type: Easing.InOutQuad }
                            }
                        ]
                    }

                    Image {
                        id: deleteImage
                        x: 290 * glValue.appUIWidth / 360
                        y: 18 * glValue.appUIHeight / 640
                        width: 33 * glValue.appUIWidth / 360
                        height: 31 * glValue.appUIHeight / 640
                        source: "images/SpecialFilterRed.png"
                        state: {
                            if(onDeleteState == true)
                                "show"
                            else
                                "hide"
                        }

                        states:
                        [
                            State
                            {
                                name: "show"
                                PropertyChanges { target: deleteImage; x: 290 * glValue.appUIWidth / 360; opacity: 1 }
                            },
                            State
                            {
                                name: "hide"
                                PropertyChanges { target: deleteImage; x: 400 * glValue.appUIWidth / 360; opacity: 0 }
                            }
                        ]
                        transitions:
                        [
                            Transition {
                                from: "show"; to: "hide"
                                PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
                            },
                            Transition {
                                from: "hide"; to: "show"
                                PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
                            }
                        ]

                        MouseArea {
                            x: -10
                            y: -18
                            width: 53
                            height: 70
                            onClicked: {
                                sql.deleteFavouritesExisted(elementTitle, elementDesc, elementThumb, elementApiUrl);
                                favouritesListModel.remove(index)
                            }
                        }
                    }
                }
            }

            ListView {
                id: favouritesListView
                anchors.fill: parent
                model: favouritesListModel
                delegate: favouritesComponent
            }
        }

        Image {
            x: 0
            y: 0
            width: 360 * glValue.appUIWidth / 360
            height: 80 * glValue.appUIHeight / 640
            source: "images/filtlerBGBG.png"
        }

        Image {
            id: abc
            x: 14 * glValue.appUIWidth / 360
            y: 15 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: 49 * glValue.appUIHeight / 640
            source: "images/filtlerBG.png"

            Text {
                anchors.fill: parent
                anchors.leftMargin: 15 * glValue.appUIWidth / 360
                verticalAlignment: Text.AlignVCenter
                font.pixelSize: 40
                font.bold: true
                color: "white"
                opacity: 0.8
                text: "Favourites"
            }
        }

        Image {
            x: 14 * glValue.appUIWidth / 360
            y: 80 * glValue.appUIHeight / 640
            width: 25 * glValue.appUIWidth / 360
            height: 25 * glValue.appUIHeight / 640
            source: "images/topTenPageImageLeftConner.png"
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: favouritesPage; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: favouritesPage; x: -pageContent.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: favouritesPage; x: pageContent.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
