import QtQuick 1.0

Rectangle {
    id: favouritesPageNightlifeDetailVenuePage
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        favouritesPageNightlifeDetailVenuePage.state = "";
        favouritesPageNightlifeDetailVenuePage.state = "hideLeft"
        favouritesPageNightlifeDetailVenuePage.state = "show"
    }

    function showPageFromRight()
    {
        favouritesPageNightlifeDetailVenuePage.state = "";
        favouritesPageNightlifeDetailVenuePage.state = "hideRight"
        favouritesPageNightlifeDetailVenuePage.state = "show"
    }

    function hidePageToLeft()
    {
        favouritesPageNightlifeDetailVenuePage.state = "";
        favouritesPageNightlifeDetailVenuePage.state = "show"
        favouritesPageNightlifeDetailVenuePage.state = "hideLeft"
    }

    function hidePageToRight()
    {
        favouritesPageNightlifeDetailVenuePage.state = "";
        favouritesPageNightlifeDetailVenuePage.state = "show"
        favouritesPageNightlifeDetailVenuePage.state = "hideRight"
    }

    property string f_name;
    property string f_address;
    property string f_travelInfo;
    property string f_webUrl;
    property string f_lng;
    property string f_lat;

    function receiveGeneralData(name, address, webUrl, lng, lat, travelInfo)
    {
        loadingCover.hideLoadingCover();
        textFlick.opacity = 1;

        f_name = name;
        f_address = address;
        f_webUrl = webUrl;
        f_lng = lng;
        f_lat = lat;
        f_travelInfo = travelInfo
    }

    function resetData()
    {
        f_name = ""
        f_address = ""
        f_travelInfo = ""
        f_webUrl = ""
        f_lng = ""
        f_lat = ""

        textFlick.opacity = 0
    }

    Flickable {
        id: textFlick
        width: 360 * glValue.appUIWidth / 360;
        height: restaurantsDetail.height;
        contentWidth: 360
        contentHeight: viewButton.y + viewButton.height + 15
        flickableDirection: Flickable.VerticalFlick
        clip: true
        opacity: 0

        Text {
            id: titleText
            x: 10 * glValue.appUIWidth / 360
            y: 10
            width: 340 * glValue.appUIWidth / 360
            height: titleText.paintedHeight
            verticalAlignment: Text.AlignVCenter
            font.pixelSize: 40
            font.bold: true
            wrapMode: "WordWrap"
            text: f_name
        }

        Text {
            id: addressText
            x: 10 * glValue.appUIWidth / 360
            y: titleText.y + titleText.paintedHeight
            width: 340 * glValue.appUIWidth / 360
            height: titleText.paintedHeight
            verticalAlignment: Text.AlignVCenter
            font.pixelSize: 25
            font.bold: true
            wrapMode: "WordWrap"
            text: f_address
        }

        Text {
            id: travelInfoText
            x: 10 * glValue.appUIWidth / 360
            y: addressText.y + addressText.paintedHeight
            width: 340 * glValue.appUIWidth / 360
            height: titleText.paintedHeight
            verticalAlignment: Text.AlignVCenter
            font.pixelSize: 25
            font.bold: true
            wrapMode: "WordWrap"
            text: f_travelInfo
        }

        Image {
            id: line_1
            x: 8 * glValue.appUIWidth / 360
            y: travelInfoText.paintedHeight + travelInfoText.y + 5
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Image {
            id: mapButton
            x: 280 * glValue.appUIWidth / 360
            y: line_1.height + line_1.y + 3
            width: 73 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/mapButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    loadingCover.showLoadingCover();
                    mapsFavouritesHotelDetail.resetData()
                    mapsFavouritesHotelDetail.lat = f_lat;
                    mapsFavouritesHotelDetail.lng = f_lng;
                    mapsFavouritesHotelDetail.zoom = "17";

                    mapsFavouritesHotelDetail.showMap();

                    mapsFavouritesHotelDetail.showPageFromRight();
                    favouritesPageNightlifeDetailVenuePage.hidePageToLeft()

                    glValue.favouritesCurrentPage = "mapsFavouritesHotelDetail"
                    glValue.currentPage = "mapsFavouritesHotelDetail"
                    glValue.favouritesPageSelection = "favouritesPageNightlifeDetailVenuePage"
                }
            }
        }

        Image {
            id: line_2
            x: 8 * glValue.appUIWidth / 360
            y: mapButton.paintedHeight + mapButton.y + 5
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Image {
            x: 8 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 10
            width: 34 * glValue.appUIWidth / 360
            height: 34 * glValue.appUIHeight / 640
            source: "images/websiteButton.png"
        }

        Text {
            x: 50 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 15
            font.pixelSize: 25
            text: "Website"
        }

        Image {
            id: viewButton
            x: 240 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 8
            width: 115 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/viewButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    Qt.openUrlExternally(f_webUrl)
                }
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: favouritesPageNightlifeDetailVenuePage; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: favouritesPageNightlifeDetailVenuePage; x: -favouritesPageNightlifeDetailVenuePage.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: favouritesPageNightlifeDetailVenuePage; x: favouritesPageNightlifeDetailVenuePage.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]

}
