import QtQuick 1.0
import "./javascript/APIsRequest.js" as APIsRequest

Rectangle {
    id: filmDetail
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0
    property int marginSize: 10
    property string fromWhichPage: ""

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        filmDetail.state = "";
        filmDetail.state = "hideLeft"
        filmDetail.state = "show"
    }

    function showPageFromRight()
    {
        filmDetail.state = "";
        filmDetail.state = "hideRight"
        filmDetail.state = "show"
    }

    function hidePageToLeft()
    {
        filmDetail.state = "";
        filmDetail.state = "show"
        filmDetail.state = "hideLeft"

        timer.running = false;
    }

    function hidePageToRight()
    {
        filmDetail.state = "";
        filmDetail.state = "show"
        filmDetail.state = "hideRight"

        timer.running = false;
    }
    //----------------------- End ---------------------------------------

    property string f_type: "";
    property string f_uid: "";
    property string f_name: "";
    property string f_cert: "";
    property string f_released: "";
    property string f_duration: "";
    property string f_imdb_code: "";
    property string f_description: "";
    property string f_imageUrl: "";
    property string f_starRating: "";
    property string f_webUrl: "";

    property string f_genre: "";
    property string f_director: "";
    property string f_cast: "";
    property string f_tags: "";
    property string temp_f_director: "";
    property string temp_f_cast: "";

    function receiveGeneralData(uid, name, cert, released,
                                duration, description, imageUrl,
                                starRating, webUrl)
    {
        textFlick.opacity = 1;

        f_uid = uid
        f_name = name
        f_cert = cert
        f_released = released
        f_duration = duration
        f_description = description
        f_imageUrl = imageUrl
        f_starRating = starRating
        f_webUrl = webUrl

        timer.running = true;
    }

    function getFilmData(searchString)
    {
        loadingCover.showLoadingCover();

        function requestFilmsDetail() {}
        requestFilmsDetail.prototype = {
            update: function(status, result)
                    {
                        var root = result.documentElement;

                        if(root == undefined)
                        {
                            loadingCover.hideLoadingCover();

                            return "error";
                        }

                        for(var i_1=0; i_1<root.childNodes.length; i_1++)
                        {
                            if(root.nodeName != "toxml") {
                                //Warning
                            }
                            else
                            {
                                loadingCover.hideLoadingCover();

                                if(root.childNodes[i_1].nodeName == "response")
                                {
                                    var nodesRow = root.childNodes[i_1].childNodes[0];
                                    f_type = nodesRow.attributes[0].value;
                                    for(var i_2=0; i_2<nodesRow.childNodes.length; i_2++)
                                    {
                                        if(nodesRow.childNodes[i_2].nodeName == "uid")
                                            f_uid = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "name")
                                            f_name = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "cert")
                                            f_cert = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "released")
                                            f_released = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "duration")
                                            f_duration = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "imdb_code")
                                            f_imdb_code = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "description")
                                            f_description = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "genre")
                                        {
                                            var nodesTag = nodesRow.childNodes[i_2];
                                            for(var i_3=0; i_3<nodesTag.childNodes.length; i_3++)
                                            {
                                                var tag = nodesTag.childNodes[i_3].childNodes[0].nodeValue;

                                                if(f_genre == "")
                                                    f_genre += tag;
                                                else
                                                    f_genre += "/" + tag;
                                            }
                                        }
                                        else if(nodesRow.childNodes[i_2].nodeName == "director")
                                        {
                                            nodesTag = nodesRow.childNodes[i_2];
                                            for(i_3=0; i_3<nodesTag.childNodes.length; i_3++)
                                            {
                                                tag = nodesTag.childNodes[i_3].childNodes[0].nodeValue;

                                                if(f_director == "")
                                                    f_director += tag;
                                                else
                                                    f_director += "/" + tag;
                                            }
                                        }
                                        else if(nodesRow.childNodes[i_2].nodeName == "cast")
                                        {
                                            nodesTag = nodesRow.childNodes[i_2];
                                            for(i_3=0; i_3<nodesTag.childNodes.length; i_3++)
                                            {
                                                tag = nodesTag.childNodes[i_3].childNodes[0].nodeValue;

                                                if(f_cast == "")
                                                    f_cast += tag;
                                                else
                                                    f_cast += "," + tag;
                                            }
                                        }
                                        else if(nodesRow.childNodes[i_2].nodeName == "imageUrl")
                                            f_imageUrl = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "starRating")
                                            f_starRating = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                        else if(nodesRow.childNodes[i_2].nodeName == "tags")
                                        {
                                            nodesTag = nodesRow.childNodes[i_2];
                                            for(i_3=0; i_3<nodesTag.childNodes.length; i_3++)
                                            {
                                                tag = nodesTag.childNodes[i_3].childNodes[0].nodeValue;

                                                if(f_tags == "")
                                                    f_tags += tag;
                                                else
                                                    f_tags += "/" + tag;
                                            }
                                        }
                                        else if(nodesRow.childNodes[i_2].nodeName == "webUrl")
                                            f_webUrl = nodesRow.childNodes[i_2].childNodes[0].nodeValue;
                                    }
                                }
                            }
                        }

                        textFlick.opacity = 1;
                        timer.running = true;
                    }
        }

        APIsRequest.getWebserviceData(searchString, new requestFilmsDetail());
    }

    Timer {
        id: timer
        interval: 500; running: false; repeat: true
        onTriggered: setData()
    }

    function setData()
    {
        loadingCover.hideLoadingCover();

        if(f_imageUrl == "") {
            mainImage.height = 0;
            mainImageBusy.height = 0;
            rotation.running = false;
        }
        else {
            mainImage.height = (360/1.6667) * glValue.appUIHeight / 640;
            mainImageBusy.height = 35;
            rotation.running = true;
        }

        line_4.y = edit.paintedHeight + edit.y + 8
    }

    function resetData()
    {
        timer.running = false

        textFlick.opacity = 0;
        textFlick.contentY = 0;

        f_type = "";
        f_uid = "";
        f_name = "";
        f_cert = "";
        f_released = "";
        f_duration = "";
        f_imdb_code = "";
        f_description = "";
        f_imageUrl = "";
        f_starRating = "";
        f_webUrl = "";
        f_genre = "";
        f_director = "";
        f_cast = "";
        f_tags = "";
    }

    Flickable {
        id: textFlick
        width: 360 * glValue.appUIWidth / 360;
        height: barsClubsDetail.height;
        contentWidth: 360
        contentHeight: releaseText.y + releaseText.height + 15
        flickableDirection: Flickable.VerticalFlick
        clip: true
        opacity: 0

        Text {
            id: titleText
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.leftMargin: marginSize
            anchors.right: parent.right
            anchors.rightMargin: marginSize
            font.pixelSize: 40
            font.bold: true
            wrapMode: "WordWrap"
            text: f_name
        }

        Text {
            id: subTitleText
            anchors.top: titleText.bottom
            anchors.left: titleText.left
            anchors.right: titleText.right
            font.pixelSize: 25
            wrapMode: "WordWrap"
            text: f_genre
        }

        Image {
            id: line_1
            x: 8 * glValue.appUIWidth / 360
            y: subTitleText.height + subTitleText.y + 5
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Item {
            id: topStar
            x: 8 * glValue.appUIWidth / 360
            y: line_1.height + line_1.y + 10
            width: 360 * glValue.appUIWidth / 360
            height: 30 * glValue.appUIHeight / 640

            ListModel {
                id: topRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: topRatingComponent

                Item {
                    id: topRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        source: {
                            if(index < f_starRating)
                                return "images/starOn.png";
                            else
                                return "images/starOff.png";
                        }
                    }
                }
            }

            ListView {
                id: topRatingListView
                anchors.fill: parent
                model: topRatingListModel
                delegate: topRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Image {
            id: mainImage
            x: 0
            y: topStar.y + topStar.height + 8
            width: 360 * glValue.appUIWidth / 360
            height: (360/1.6667) * glValue.appUIHeight / 640
            source: f_imageUrl
            state: "hide"

            states:
                [
                State
                {
                    name: "show"
                    PropertyChanges { target: mainImage; opacity: 1 }
                },
                State
                {
                    name: "hide"
                    PropertyChanges { target: mainImage; opacity: 0 }
                }
            ]
            transitions:
                [
                Transition {
                    from: "hide"; to: "show"
                    PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                }
            ]

            onStatusChanged: {
                if(mainImage.status == 2) {
                    mainImageBusy.opacity = 0.8
                    rotation.running = true
                }
                else if(mainImage.status == 1) {
                    mainImageBusy.opacity = 0
                    rotation.running = false
                    mainImage.state = "show"
                }
            }
        }

        Image {
            id: mainImageBusy
            anchors.centerIn: mainImage
            width: 35 * glValue.appUIWidth / 360
            height: 35 * glValue.appUIHeight / 640
            smooth: true
            opacity: 1
            source: "images/busy.png"

            RotationAnimation on rotation {
                id: rotation
                loops: 10000
                from: 0
                to: 360
                duration: 1200
            }
        }

        Text {
            id: timeoutSays
            x: 8 * glValue.appUIWidth / 360
            y: mainImage.height + mainImage.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 30
            text: "Now Showing Here"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    if(glValue.currentPage == "filmDetail")
                    {
                        if(filmShowHereLoader.status == Loader.Null)
                            filmShowHereLoader.source = "NowShowingHere.qml"

                        filmShowHereLoader.item.filmName = f_name;
                        filmShowHereLoader.item.filmGenre = f_genre;
                        filmShowHereLoader.item.filmStarRating = f_starRating;
                        filmShowHereLoader.item.filmImageUrl = f_imageUrl;

                        filmShowHereLoader.item.getCinemaData(f_uid);

                        filmDetail.hidePageToLeft();
                        filmShowHereLoader.item.showPageFromRight();

                        glValue.currentPage = "filmShowHere"
                        glValue.homeCurrentPage = "filmShowHere"
                    }
                    else if(glValue.currentPage == "topTenFilmDetail")
                    {
                        if(topTenFilmShowHereLoader.status == Loader.Null)
                            topTenFilmShowHereLoader.source = "NowShowingHere.qml"

                        topTenFilmShowHereLoader.item.filmName = f_name;
                        topTenFilmShowHereLoader.item.filmGenre = f_genre;
                        topTenFilmShowHereLoader.item.filmStarRating = f_starRating;
                        topTenFilmShowHereLoader.item.filmImageUrl = f_imageUrl;

                        topTenFilmShowHereLoader.item.getCinemaData(f_uid);

                        filmDetail.hidePageToLeft();
                        topTenFilmShowHereLoader.item.showPageFromRight();

                        glValue.currentPage = "topTenFilmShowHere"
                        glValue.topTenCurrentPage = "topTenFilmShowHere"
                    }
                    else if(glValue.currentPage == "searchPageFilmDetail")
                    {
                        if(searchPageFilmShowHereLoader.status == Loader.Null)
                            searchPageFilmShowHereLoader.source = "NowShowingHere.qml"

                        searchPageFilmShowHereLoader.item.filmName = f_name;
                        searchPageFilmShowHereLoader.item.filmGenre = f_genre;
                        searchPageFilmShowHereLoader.item.filmStarRating = f_starRating;
                        searchPageFilmShowHereLoader.item.filmImageUrl = f_imageUrl;

                        searchPageFilmShowHereLoader.item.getCinemaData(f_uid);

                        filmDetail.hidePageToLeft();
                        searchPageFilmShowHereLoader.item.showPageFromRight();

                        glValue.currentPage = "searchPageFilmShowHere"
                        glValue.searchCurrentPage = "searchPageFilmShowHere"
                    }
                    else if(glValue.currentPage == "editorialsFilmDetail")
                    {
                        if(editorialsFilmShowHereLoader.status == Loader.Null)
                            editorialsFilmShowHereLoader.source = "NowShowingHere.qml"

                        editorialsFilmShowHereLoader.item.filmName = f_name;
                        editorialsFilmShowHereLoader.item.filmGenre = f_genre;
                        editorialsFilmShowHereLoader.item.filmStarRating = f_starRating;
                        editorialsFilmShowHereLoader.item.filmImageUrl = f_imageUrl;

                        editorialsFilmShowHereLoader.item.getCinemaData(f_uid);

                        filmDetail.hidePageToLeft();
                        editorialsFilmShowHereLoader.item.showPageFromRight();

                        glValue.currentPage = "editorialsFilmShowHere"
                        glValue.homeCurrentPage = "editorialsFilmShowHere"
                    }
                }
            }
        }

        Image {
            anchors.right: line_3_1.right
            anchors.rightMargin: 10
            anchors.verticalCenter: timeoutSays.verticalCenter
            source: "images/arrow.png"
        }

        Image {
            id: line_3_1
            x: 8 * glValue.appUIWidth / 360
            y: timeoutSays.height + timeoutSays.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        TextEdit {
            id: edit
            x: 8 * glValue.appUIWidth / 360
            y: line_3_1.height + line_3_1.y + 15
            width: 344 * glValue.appUIWidth / 360
            height: edit.paintedHeight
            wrapMode: TextEdit.Wrap
            readOnly: true
            focus: false
            font.pixelSize: 25
            text: f_description
        }

        Image {
            id: line_4
            x: 8 * glValue.appUIWidth / 360
            y: edit.paintedHeight + edit.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: detailsText
            x: 8 * glValue.appUIWidth / 360
            y: line_4.height + line_4.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 30
            text: "Details"
        }

        Text {
            id: directorTitleText
            x: 8 * glValue.appUIWidth / 360
            y: detailsText.height + detailsText.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 25
            text: "Director"
        }

        Text {
            id: directorText
            x: 8 * glValue.appUIWidth / 360
            y: directorTitleText.height + directorTitleText.y + 3
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 22
            wrapMode: "WordWrap"
            text: f_director
        }

        Text {
            id: castTitleText
            x: 8 * glValue.appUIWidth / 360
            y: directorText.height + directorText.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 25
            text: "Cast"
        }

        Text {
            id: castText
            x: 8 * glValue.appUIWidth / 360
            y: castTitleText.height + castTitleText.y + 3
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 22
            wrapMode: "WordWrap"
            text: f_cast
        }

        Text {
            id: durationTitleText
            x: 8 * glValue.appUIWidth / 360
            y: castText.height + castText.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 25
            text: "Duration"
        }

        Text {
            id: durationText
            x: 8 * glValue.appUIWidth / 360
            y: durationTitleText.height + durationTitleText.y + 3
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 22
            wrapMode: "WordWrap"
            text: f_duration
        }

        Text {
            id: releaseTitleText
            x: 8 * glValue.appUIWidth / 360
            y: durationText.height + durationText.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 25
            text: "Release"
        }

        Text {
            id: releaseText
            x: 8 * glValue.appUIWidth / 360
            y: releaseTitleText.height + releaseTitleText.y + 3
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 22
            wrapMode: "WordWrap"
            text: f_released
        }
    }

    states:
        [
        State
        {
            name: "show"
            PropertyChanges { target: filmDetail; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: filmDetail; x: -filmDetail.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: filmDetail; x: filmDetail.width; opacity: 1 }
        }
    ]
    transitions:
        [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
