import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.1

Item {
    id: homePageParentFilter
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        homePageParentFilter.state = "";
        homePageParentFilter.state = "hideLeft"
        homePageParentFilter.state = "show"
    }

    function showPageFromRight()
    {
        homePageParentFilter.state = "";
        homePageParentFilter.state = "hideRight"
        homePageParentFilter.state = "show"
    }

    function hidePageToLeft()
    {
        homePageParentFilter.state = "";
        homePageParentFilter.state = "show"
        homePageParentFilter.state = "hideLeft"
    }

    function hidePageToRight()
    {
        homePageParentFilter.state = "";
        homePageParentFilter.state = "show"
        homePageParentFilter.state = "hideRight"
    }
    //----------------------- End ---------------------------------------

    //--------- Append List Model ---------------------------------------
    function clearListModel()
    {
        parentFilterListModel.clear()
    }

    function appendListModelRestaurants()
    {
        parentFilterListModel.append({"elementTitle": "Good For", "elementID": 0, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Cuisines", "elementID": 1, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Licensed", "elementID": 2, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Award Winner", "elementID": 3, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Price Range", "elementID": 4, "elementSelectedOpacity": 0})
    }

    function appendListModelBarsClubs()
    {
        parentFilterListModel.append({"elementTitle": "Good For", "elementID": 0, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Category", "elementID": 1, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Area", "elementID": 2, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Critics' Choice", "elementID": 3, "elementSelectedOpacity": 0})
    }

    function appendListModelNightliseMusic()
    {
        parentFilterListModel.append({"elementTitle": "Category", "elementID": 0, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Area", "elementID": 1, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Critics' Choice", "elementID": 2, "elementSelectedOpacity": 0})
         parentFilterListModel.append({"elementTitle": "Date", "elementID": 3, "elementSelectedOpacity": 0})
    }

    function appendListModelFilm()
    {
        parentFilterListModel.append({"elementTitle": "Language", "elementID": 0, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Genre", "elementID": 1, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Cinema", "elementID": 2, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Certificate", "elementID": 3, "elementSelectedOpacity": 0})
    }

    function appendListModelHotel()
    {
        parentFilterListModel.append({"elementTitle": "Facilities", "elementID": 0, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Good For", "elementID": 1, "elementSelectedOpacity": 0})
        parentFilterListModel.append({"elementTitle": "Rating", "elementID": 2, "elementSelectedOpacity": 0})
    }

    //---------------- Data Communication -------------------------------------
    signal requireSpecialFilters(string filterName, string className);
    function getSpecialFiltersFinished()
    {
        loadingCover.hideLoadingCover();
    }

    Item {
        id: content
        anchors.fill: parent

        ListModel {
            id: parentFilterListModel
        }

        Component {
            id: parentFilterComponent

            Item {
                id: parentFilterDelegateItem
                width: parentFilterListView.width
                height: 70 * glValue.appUIHeight / 640
                smooth: true

                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        //------------- Reset and Highlight UI Selection ----------------------
                        for(i=0; i<parentFilterListModel.count; i++)
                        {
                            parentFilterListModel.get(i).elementSelectedOpacity = 0;
                        }
                        parentFilterListModel.get(elementID).elementSelectedOpacity = 1;

                        if(elementTitle == "Date") {
                            var d = new Date();
                            tDialog.year = d.getFullYear();
                            tDialog.month = d.getMonth() + 1;
                            tDialog.day = d.getDate();
                            tDialog.open();
                        }
                        else {
                            //-------------- Setting Global Value ---------------------------------
                            glValue.secondLevelSelection = elementTitle;
                            glValue.currentPage = "homePageSpecialFilter";
                            glValue.homeCurrentPage = "homePageSpecialFilter";

                            //-------------- Animate UI -------------------------------------------
                            topBar.showBackButton();

                            loadingCover.showLoadingCover();

                            homePageParentFilter.hidePageToLeft();
                            homePageSpecialFilter.showPageFromRight();

                            //-------------- Setting Second Level List Model ----------------------
                            homePageSpecialFilter.resetButtons();
                            homePageSpecialFilter.clearListModel();

                            requireSpecialFilters(glValue.secondLevelSelection, glValue.firstLevelSelection);
                        }
                    }
                }

                Image {
                    anchors.fill: parent
                    source: {
                        if(parentFilterListModel.count == elementID + 1)
                            "images/listBGBottom.png"
                        else
                            "images/listBGFull.png"
                    }
                }

                Image {
                    id: parentFilterSelectedImage
                    x: 0
                    y: 0
                    width: parent.width
                    height: 65 * glValue.appUIHeight / 640
                    opacity: elementSelectedOpacity
                    source: "images/listBGSelected.png"
                }

                Text {
                    anchors.fill: parent
                    anchors.leftMargin: 15 * glValue.appUIWidth / 360
                    color: "white"
                    text: elementTitle
                    font.pixelSize: 40
                    verticalAlignment: Text.AlignVCenter
                }

                Image {
                    x: 300 * glValue.appUIWidth / 360
                    y: 18 * glValue.appUIHeight / 640
                    width: 27 * glValue.appUIWidth / 360
                    height: 32 * glValue.appUIHeight / 640
                    source: "images/arrow.png"
                }

                Image {
                    x: 0
                    y: 65 * glValue.appUIHeight / 640
                    width: parent.width
                    height: 5 * glValue.appUIHeight / 640
                    opacity: {
                        if(parentFilterListModel.count == elementID + 1)
                            0
                        else
                            1
                    }
                    source: "images/listLine.png"
                }
            }
        }

        ListView {
            id: parentFilterListView
            x: 14 * glValue.appUIWidth / 360
            y: 80 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: parent.height - 80 * 2 * glValue.appUIHeight / 640
            model: parentFilterListModel
            delegate: parentFilterComponent
        }

        Image {
            x: 0
            y: 0
            width: 360 * glValue.appUIWidth / 360
            height: 80 * glValue.appUIHeight / 640
            source: "images/filtlerBGBG.png"
        }

        Image {
            x: 14 * glValue.appUIWidth / 360
            y: 15 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: 49 * glValue.appUIHeight / 640
            source: "images/filtlerBG.png"

            Text {
                anchors.fill: parent
                anchors.leftMargin: 15 * glValue.appUIWidth / 360
                verticalAlignment: Text.AlignVCenter
                font.pixelSize: 40
                color: "white"
                opacity: 0.8
                text: "Apply Filters"
            }
        }

        Item {
            id: sponsorBanner
            x: 0
            y: homePageParentFilter.height - 80 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: 80 * glValue.appUIHeight / 640

            Image {
                anchors.fill: parent
                source: "images/topTenPageSponsorBannerBG.png"
            }

            Image {
                x: 14 * glValue.appUIWidth / 360
                y: 0
                width: 332 * glValue.appUIWidth / 360
                height: 80 * glValue.appUIHeight / 640
                opacity: 0.5
                source: "images/listBGFull.png"
            }

            Image {
                x: 14 * glValue.appUIWidth / 360
                y: 15 * glValue.appUIHeight / 640
                width: 332 * glValue.appUIWidth / 360
                height: 49 * glValue.appUIHeight / 640
                source: "images/filtlerBG.png"

                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        homePageSpecialFilter.search();

                        homePageParentFilter.hidePageToLeft();
                        resultListing.showPageFromRight();
                        loadingCover.showLoadingCover();

                        //verson 2.0
                        resultListing.fromWhichPage = "parent"

                        glValue.currentPage = "resultListing"
                        glValue.homeCurrentPage = "resultListing"

                    }
                }

                Text {
                    anchors.centerIn: parent
                    font.pixelSize: 40
                    font.bold: true
                    color: "white"
                    opacity: 0.8
                    text: "Go!"
                }
            }
        }
    }

    DatePickerDialog {
        id: tDialog
        anchors.fill: parent
        anchors.topMargin: -topBar.height
        anchors.bottomMargin: -bottomMenu.height
        titleText: "Date of birth"
        acceptButtonText: "Confirm"
        rejectButtonText: "Clear date"
        onAccepted: addDateFilter()
        onRejected: clearDateFilter()
    }

    function addDateFilter()
    {
        homePageSpecialFilter.nightandmusicYear = tDialog.year;
        homePageSpecialFilter.nightandmusicMonth = tDialog.month;
        homePageSpecialFilter.nightandmusicDay = tDialog.day;
    }

    function clearDateFilter()
    {
        homePageSpecialFilter.nightandmusicYear = "";
        homePageSpecialFilter.nightandmusicMonth = "";
        homePageSpecialFilter.nightandmusicDay = "";
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: homePageParentFilter; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: homePageParentFilter; x: -homePageParentFilter.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: homePageParentFilter; x: homePageParentFilter.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
