import QtQuick 1.0

Item {
    id: homePageSpecialFilter
    state: "hideLeft"

    //------------- State Indicator -----------------------------------
    Image {
        id: a
        state: "show"
    }

    Image {
        id: b
        state: "hide"
    }

    //------------- Internal Globle Variable --------------------------
    property int i: 0
    property int j: 0
    property string tempString: ""
    property string searchString: ""

    //Reset All Selection Values
    function resetAllValues()
    {
        searchString = ""
        resetRestaurantsValues()
        resetBarsandclubsValues()
        resetNightlifeAndMusicValues()
        resetFilmValues()
        resetHotelValues()
    }

    //Restaurants Seletion Values
    property string restaurantsMealDeal: ""
    property string restaurantsGoodFor: ""
    property string restaurantsCuisines: ""
    property string restaurantsLicensed: ""
    property string restaurantsAwardWinner: ""
    property string restaurantsPriceRange: ""

    //--Bars&Clubs Seletion Values----------------  Tao--------------------------------
    property string barsandclubsCategory: ""
    property string barsandclubsGoodFor: ""
    property string barsandclubsLat: ""
    property string barsandclubsLng: ""
    property string barsandclubsCritics: ""
    //---------------------------------------------Tao---------------------------------
    //--Nightlife&Music Seletion Values
    property string nightandmusicCategory: ""
    property string nightandmusicLat: ""
    property string nightandmusicLng: ""
    property string nightandmusicCritics: ""
    property string nightandmusicYear: ""
    property string nightandmusicMonth: ""
    property string nightandmusicDay: ""
    //--Films seletion Values
    property string filmLanguage: ""
    property string filmGenre: ""
    property string filmCinema: ""
    property string filmCertificate: ""
    //---Hotel Seletion Values
    property string hotelFacilities: ""
    property string hotelGoodFor: ""
    property string hotelRating: ""
    //-------------------------------------------------------------------------

    function resetRestaurantsValues()
    {
        restaurantsMealDeal = ""
        restaurantsGoodFor = ""
        restaurantsCuisines = ""
        restaurantsLicensed = ""
        restaurantsAwardWinner = ""
        restaurantsPriceRange = ""
    }
    //--------------------------------------------  Tao--------------------------------------
    function resetBarsandclubsValues()
    {
        barsandclubsCategory = ""
        barsandclubsGoodFor = ""
        barsandclubsLat = ""
        barsandclubsLng = ""
        barsandclubsCritics = ""
    }
    //-----------------------------------------Tao--------------------------------------------
    function resetNightlifeAndMusicValues()
    {
        nightandmusicCategory = ""
        nightandmusicLat = ""
        nightandmusicLng = ""
        nightandmusicCritics = ""
        nightandmusicYear = ""
        nightandmusicMonth = ""
        nightandmusicDay = ""
    }

    function resetFilmValues()
    {
        filmLanguage = ""
        filmGenre = ""
        filmCinema = ""
        filmCertificate = ""
    }

    function resetHotelValues()
    {
        hotelFacilities = ""
        hotelGoodFor = ""
        hotelRating = ""
    }

    //---------------------------------------------------------------------------------------

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        resetButtons();
        homePageSpecialFilter.state = "";
        homePageSpecialFilter.state = "hideLeft"
        homePageSpecialFilter.state = "show"
    }

    function showPageFromRight()
    {
        resetButtons();
        homePageSpecialFilter.state = "";
        homePageSpecialFilter.state = "hideRight"
        homePageSpecialFilter.state = "show"
    }

    function hidePageToLeft()
    {
        homePageSpecialFilter.state = "";
        homePageSpecialFilter.state = "show"
        homePageSpecialFilter.state = "hideLeft"
    }

    function hidePageToRight()
    {
        homePageSpecialFilter.state = "";
        homePageSpecialFilter.state = "show"
        homePageSpecialFilter.state = "hideRight"
    }
    //----------------------- End ---------------------------------------

    //--------------- UI controllers ------------------------------------
    function resetButtons()
    {
 //       for(i=0; i<specialFilterListModel.count; i++)
 //           specialFilterListModel.get(i).elementSelectedOpacity = 0

        moreFiltersButton.source = "images/filtlerBG.png"
        goButton.source = "images/filtlerBG.png"
    }

    //--------- Append List Model ---------------------------------------
    function clearListModel()
    {
        console.log("Clear Spcial Filter List")
        specialFilterListModel.clear()
    }

    function appendCuisinesList(contentId, contentName)
    {
        if(contentId == "finished" && contentName == "finished")
        {
            checkSelected();
            return;
        }

        tempString = contentName
        if(tempString.length > 18)
        {
            tempString  = tempString.substring(0, 16) + "..."
        }

        specialFilterListModel.append({
                                      "elementID": specialFilterListModel.count,
                                      "elementSelectedOpacity": 0,
                                      "elementContentID": contentId,
                                      "elementContentName": contentName,
                                      "elementTitle": tempString,
                                      "elementRedState": b.state,
                                      "elementBlueState": a.state})

        console.log(contentId)
        console.log(contentName)
    }

    function checkSelected()
    {
        if(glValue.firstLevelSelection == "Restaurants")
        {
            console.log("asdasdasdasd")
            console.log(glValue.secondLevelSelection)
            console.log(restaurantsMealDeal)
            if(glValue.secondLevelSelection == "Meal Deal" && restaurantsMealDeal != "")
            {
                console.log("111")
                for(i=0; i<specialFilterListModel.count; i++) {
                    if(specialFilterListModel.get(i).elementContentID == restaurantsMealDeal) {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        console.log("222")

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Good For" && restaurantsGoodFor != "")
            {
                for(i=0; i<specialFilterListModel.count; i++) {
                    if(specialFilterListModel.get(i).elementContentID == restaurantsGoodFor) {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Cuisines" && restaurantsCuisines != "")
            {
                for(i=0; i<specialFilterListModel.count; i++) {
                    if(specialFilterListModel.get(i).elementContentID == restaurantsCuisines) {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Licensed" && restaurantsLicensed != "")
            {
                console.log(glValue.secondLevelSelection)
                for(i=0; i<specialFilterListModel.count; i++) {
                    if(specialFilterListModel.get(i).elementContentID == restaurantsLicensed) {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Award Winner" && restaurantsAwardWinner != "")
            {
                for(i=0; i<specialFilterListModel.count; i++) {
                    if(specialFilterListModel.get(i).elementContentID == restaurantsAwardWinner) {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Price Range" && restaurantsPriceRange != "")
            {
                for(i=0; i<specialFilterListModel.count; i++) {
                    if(specialFilterListModel.get(i).elementContentID == restaurantsPriceRange) {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
        }
        //------------------------------------------------  Tao-------------------------------------
        else if(glValue.firstLevelSelection == "Bars & Clubs")
        {
            if(glValue.secondLevelSelection == "Category" && barsandclubsCategory != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == barsandclubsCategory)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Good For" && barsandclubsGoodFor != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == barsandclubsGoodFor)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Area" && barsandclubsLat != "" && barsandclubsLng != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == barsandclubsLat + "," + barsandclubsLng)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Critics' Choice" && barsandclubsCritics != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == barsandclubsCritics)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
        }

        else if(glValue.firstLevelSelection == "Nightlife & Music")
        {
            if(glValue.secondLevelSelection == "Category" && nightandmusicCategory != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == nightandmusicCategory)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Area" && nightandmusicLat != "" && nightandmusicLng != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == nightandmusicLat + "," + nightandmusicLng)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Critics' Choice" && nightandmusicCritics != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == nightandmusicCritics)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
        }

        else if(glValue.firstLevelSelection == "Films")
        {
            if(glValue.secondLevelSelection == "Language" && filmLanguage != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == filmLanguage)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Genre" && filmGenre != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == filmGenre)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Cinema" && filmCinema != "")
            {
                console.log("1")
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == filmCinema)
                    {
                        console.log("2")

                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Certificate" && filmCertificate != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == filmCertificate)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
        }

        else if(glValue.firstLevelSelection == "Hotels")
        {
            if(glValue.secondLevelSelection == "Facilities" && hotelFacilities != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == hotelFacilities)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Good For" && hotelGoodFor != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == hotelGoodFor)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }
            else if(glValue.secondLevelSelection == "Rating" && hotelRating != "")
            {
                for(i=0; i<specialFilterListModel.count; i++)
                {
                    if(specialFilterListModel.get(i).elementContentID == hotelRating)
                    {
                        specialFilterListModel.get(i).elementBlueState = b.state
                        specialFilterListModel.get(i).elementRedState = a.state

                        for(j=0; j<specialFilterListModel.count; j++)
                        {
                            specialFilterListModel.get(j).elementSelectedOpacity = 0;
                        }
                        specialFilterListModel.get(i).elementSelectedOpacity = 1;
                    }
                }
            }

        }

        //---------------------------------------------------Tao-------------------------------------------
    }

    //----------- Selected Filter Recorder Controller -------------------
    function addFilter(className, content)
    {
        selectedFilterRecorder.append({
                                      "elementID": selectedFilterRecorder.count,
                                      "elementClass": className,
                                      "elementContent": content})
    }

    function removeFilter(className, content)
    {
        for(i=0; i<selectedFilterRecorder.count; i++)
        {
            if(selectedFilterRecorder.get(i).elementClass == className &&
                    selectedFilterRecorder.get(i).elementContent == content)
            {
                selectedFilterRecorder.remove(i)
            }
        }
    }

    //----------- Search Functions --------------------------------------
    signal startSearchRestaurant(string url)
    signal startSearchBarsAndClubs(string url)
    signal startSearchNightlifeAndMusic(string url)
    signal startSearchFilm(string url)
    signal startSearchHotel(string url)
    function search()
    {
        console.log("Start to search: ")
        console.log(searchString)

        if(glValue.firstLevelSelection == "Restaurants")
        {
            searchString = "http://www.timeoutdubai.com/webservice/search?section=restaurants"

            if(restaurantsMealDeal != "")
                searchString = searchString + "&offers=" + restaurantsMealDeal
            if(restaurantsGoodFor != "")
                searchString = searchString + "&goodfor=" + restaurantsGoodFor
            if(restaurantsCuisines != "")
                searchString = searchString + "&cuisine=" + restaurantsCuisines
            if(restaurantsLicensed != "")
                searchString = searchString + "&licensed=" + restaurantsLicensed
            if(restaurantsAwardWinner != "")
                searchString = searchString + "&critics_choice=" + restaurantsAwardWinner
            if(restaurantsPriceRange != "")
                searchString = searchString + "&pricerange=" + restaurantsPriceRange

            startSearchRestaurant(searchString);
        }
        //-----------------------------------------------   Tao-------------------------------------
        else if(glValue.firstLevelSelection == "Bars & Clubs")
        {
            searchString = "http://www.timeoutdubai.com/webservice/search?section=bars-clubs"

            if(barsandclubsCategory != "")
                searchString = searchString + "&subsection=" + barsandclubsCategory
            if(barsandclubsGoodFor != "")
                searchString = searchString + "&goodfor=" + barsandclubsGoodFor
            if(barsandclubsLat != "" && barsandclubsLng != "")
                searchString = searchString +"&lat=" + barsandclubsLat + "&lng=" + barsandclubsLng;
            if(barsandclubsCritics != "")
                searchString = searchString + "&critics_choice=" + barsandclubsCritics

            startSearchBarsAndClubs(searchString);
        }
        //---------------------------------------------------Tao----------------------------------------
        else if(glValue.firstLevelSelection == "Nightlife & Music")
        {
            searchString = "http://www.timeoutabudhabi.com/webservice/search?section=nightlife"

            if(nightandmusicCategory != "")
                searchString = searchString + "&subsection=" + nightandmusicCategory
            if(nightandmusicLat != "" && nightandmusicLng != "")
                searchString = searchString +"&lat=" + nightandmusicLat + "&lng=" + nightandmusicLng;
            if(nightandmusicCritics != "")
                searchString = searchString + "&critics_choice=" + nightandmusicCritics
            if(nightandmusicYear != "" && nightandmusicMonth != "" && nightandmusicDay != "")
                searchString = searchString + "&date=" + nightandmusicYear + "-" + nightandmusicMonth + "-" + nightandmusicDay

            startSearchNightlifeAndMusic(searchString);
        }


        else if(glValue.firstLevelSelection == "Films")
        {
            searchString ="http://www.timeoutdubai.com/webservice/search?section=films"

            if(filmLanguage != "")
                searchString = searchString + "&language=" + filmLanguage
            if(filmGenre != "")
                searchString = searchString + "&genre="+ filmGenre
            if(filmCinema != "")
                searchString = searchString +"&cinema=" +filmCinema
            if(filmCertificate != "")
                searchString = searchString +"&certificate=" +filmCertificate


            startSearchFilm(searchString);
        }

        else if(glValue.firstLevelSelection == "Hotels")
        {
            searchString ="http://www.timeoutdubai.com/webservice/search?section=hotels"

            if(hotelFacilities != "")
                searchString = searchString + "&facility=" + hotelFacilities
            if(hotelGoodFor != "")
                searchString = searchString + "&goodfor="+ hotelGoodFor
            if(hotelRating != "")
                searchString = searchString +"&rating=" +hotelRating

            startSearchHotel(searchString);
        }

    }

    function searchMore(totalNum, nowHave)
    {
        if(nowHave % 10 !== 0)
            return;

        if(nowHave < totalNum)
        {
            searchString = searchString + "&offset=" + (nowHave/10+1)
            console.log("         " + searchString)
            if(glValue.firstLevelSelection == "Restaurants")
            {
                 startSearchRestaurant(searchString);
            }
            else if(glValue.firstLevelSelection == "Bars & Clubs")
            {
                 startSearchBarsAndClubs(searchString);
            }
            else if(glValue.firstLevelSelection == "Nightlife & Music")
            {
                 startSearchNightlifeAndMusic(searchString);
            }
            else if(glValue.firstLevelSelection == "Films")
            {
                 startSearchFilm(searchString);
            }
            else if(glValue.firstLevelSelection == "Hotels")
            {
                 startSearchHotel(searchString);
            }
        }
    }

    Item {
        id: content
        anchors.fill: parent

        ListModel {
            id: selectedFilterRecorder
        }

        ListModel {
            id: specialFilterListModel
        }

        Component {
            id: specialFilterComponent

            Item {
                id: specialFilterDelegateItem
                width: specialFilterListView.width
                height: 70 * glValue.appUIHeight / 640
                smooth: true

                MouseArea {
                    anchors.fill: parent
                    onClicked:
                    {
                        //------------- Reset and Highlight UI Selection ----------------------
                        if(elementSelectedOpacity === 0)
                        {
                            for(i=0; i<specialFilterListModel.count; i++)
                            {
                                specialFilterListModel.get(i).elementSelectedOpacity = 0;
                            }
                            specialFilterListModel.get(elementID).elementSelectedOpacity = 1;

                            if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Meal Deal") {
                                restaurantsMealDeal = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Good For") {
                                restaurantsGoodFor = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Cuisines") {
                                restaurantsCuisines = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Licensed") {
                                restaurantsLicensed = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Award Winner") {
                                restaurantsAwardWinner = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Price Range") {
                                restaurantsPriceRange = specialFilterListModel.get(elementID).elementContentID
                            }


                            //Tao----------------------------------------------------------------------------
                            else if(glValue.firstLevelSelection == "Bars & Clubs" &&
                                    glValue.secondLevelSelection == "Good For") {
                                barsandclubsGoodFor = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Bars & Clubs" &&
                                    glValue.secondLevelSelection == "Area") {
                                var tempElmentID = specialFilterListModel.get(elementID).elementContentID;
                                var tempArray = tempElmentID.split(",");

                                barsandclubsLat = tempArray[0];
                                barsandclubsLng = tempArray[1];
                            }
                            else if(glValue.firstLevelSelection == "Bars & Clubs" &&
                                    glValue.secondLevelSelection == "Category") {
                                 barsandclubsCategory = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Bars & Clubs" &&
                                    glValue.secondLevelSelection == "Critics' Choice") {
                                 barsandclubsCritics = specialFilterListModel.get(elementID).elementContentID
                            }
                            //---------------------------------------------------------------------------------
                            else if(glValue.firstLevelSelection == "Nightlife & Music" &&
                                    glValue.secondLevelSelection == "Area") {
                                tempElmentID = specialFilterListModel.get(elementID).elementContentID;
                                tempArray = tempElmentID.split(",");

                                nightandmusicLat = tempArray[0];
                                nightandmusicLng = tempArray[1];
                            }
                            else if(glValue.firstLevelSelection == "Nightlife & Music" &&
                                    glValue.secondLevelSelection == "Category") {
                                 nightandmusicCategory = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Nightlife & Music" &&
                                    glValue.secondLevelSelection == "Critics' Choice") {
                                 nightandmusicCritics = specialFilterListModel.get(elementID).elementContentID
                            }

                            else if(glValue.firstLevelSelection == "Films" &&
                                    glValue.secondLevelSelection == "Language") {
                                filmLanguage = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Films" &&
                                    glValue.secondLevelSelection == "Genre") {
                                filmGenre = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Films" &&
                                    glValue.secondLevelSelection == "Cinema") {
                                console.log(filmCinema)
                                filmCinema = specialFilterListModel.get(elementID).elementContentID
                                console.log(filmCinema)
                            }
                            else if(glValue.firstLevelSelection == "Films" &&
                                    glValue.secondLevelSelection == "Certificate") {
                                filmCertificate = specialFilterListModel.get(elementID).elementContentID
                            }

                            else if(glValue.firstLevelSelection == "Hotels" &&
                                    glValue.secondLevelSelection == "Facilities") {
                                hotelFacilities = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Hotels" &&
                                    glValue.secondLevelSelection == "Good For") {
                                hotelGoodFor = specialFilterListModel.get(elementID).elementContentID
                            }
                            else if(glValue.firstLevelSelection == "Hotels" &&
                                    glValue.secondLevelSelection == "Rating") {
                                hotelRating = specialFilterListModel.get(elementID).elementContentID
                            }
                        }
                        else
                        {
                            specialFilterListModel.get(elementID).elementSelectedOpacity = 0;

                            if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Meal Deal") {
                                restaurantsMealDeal = ""
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Good For") {
                                restaurantsGoodFor = ""
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Cuisines") {
                                restaurantsCuisines = ""
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Licensed") {
                                restaurantsLicensed = ""
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Award Winner") {
                                restaurantsAwardWinner = ""
                            }
                            else if(glValue.firstLevelSelection == "Restaurants" &&
                                    glValue.secondLevelSelection == "Price Range") {
                                restaurantsPriceRange = ""
                            }
                            //------------------------------    Tao-------------------------------------------
                            else if(glValue.firstLevelSelection == "Bars & Clubs" &&
                                    glValue.secondLevelSelection == "Category")
                            {
                                barsandclubsCategory = ""
                            }
                            else if(glValue.firstLevelSelection == "Bars & Clubs" &&
                                    glValue.secondLevelSelection == "Good For")
                            {
                                barsandclubsGoodFor = ""
                            }
                            else if(glValue.firstLevelSelection == "Bars & Clubs" &&
                                    glValue.secondLevelSelection == "Area")
                            {
                                barsandclubsLat = ""
                                barsandclubsLng = ""
                            }
                            else if(glValue.firstLevelSelection == "Bars & Clubs" &&
                                    glValue.secondLevelSelection == "Critics' Choice")
                            {
                                barsandclubsCritics = ""
                            }
                            //----------------------------------Tao----------------------------------------------
                            else if(glValue.firstLevelSelection == "Nightlife & Music" &&
                                    glValue.secondLevelSelection == "Category")
                            {
                                nightandmusicCategory = ""
                            }
                            else if(glValue.firstLevelSelection == "Nightlife & Music" &&
                                    glValue.secondLevelSelection == "Good For")
                            {
                                nightandmusicGoodFor = ""
                            }
                            else if(glValue.firstLevelSelection == "Nightlife & Music" &&
                                    glValue.secondLevelSelection == "Area")
                            {
                                nightandmusicLat = ""
                                nightandmusicLng = ""
                            }
                            else if(glValue.firstLevelSelection == "Nightlife & Music" &&
                                    glValue.secondLevelSelection == "Critics' Choice")
                            {
                                nightandmusicCritics = ""
                            }

                            else if(glValue.firstLevelSelection == "Films" &&
                                    glValue.secondLevelSelection == "Language")
                            {
                                filmLanguage = ""
                            }
                            else if(glValue.firstLevelSelection == "Films" &&
                                    glValue.secondLevelSelection == "Genre")
                            {
                                filmGenre = ""
                            }
                            else if(glValue.firstLevelSelection == "Films" &&
                                    glValue.secondLevelSelection == "Cinema")
                            {
                                filmCinema = ""
                            }
                            else if(glValue.firstLevelSelection == "Films" &&
                                    glValue.secondLevelSelection == "Certificate")
                            {
                                filmCertificate = ""
                            }

                            else if(glValue.firstLevelSelection == "Hotels" &&
                                    glValue.secondLevelSelection == "Facilities")
                            {
                                hotelFacilities = ""
                            }
                            else if(glValue.firstLevelSelection == "Hotels" &&
                                    glValue.secondLevelSelection == "Good For")
                            {
                                hotelGoodFor = ""
                            }
                            else if(glValue.firstLevelSelection == "Hotels" &&
                                    glValue.secondLevelSelection == "Rating")
                            {
                                hotelRating = ""
                            }
                        }

                        glValue.currentPage = "homePageSpecialFilter"
                        glValue.homeCurrentPage = "homePageSpecialFilter"
                    }
                }

                Image {
                    anchors.fill: parent
                    source: {
                        if(specialFilterListModel.count == elementID + 1)
                            "images/listBGBottom.png"
                        else
                            "images/listBGFull.png"
                    }
                }

                Image {
                    id: specialFilterSelectedImage
                    x: 0
                    y: 0
                    width: parent.width
                    height: 65 * glValue.appUIHeight / 640
                    opacity: elementSelectedOpacity
                    source: "images/listBGSelected.png"
                }

                Text {
                    anchors.fill: parent
                    anchors.leftMargin: 15 * glValue.appUIWidth / 360
                    color: "white"
                    text: elementTitle
                    font.pixelSize: 40
                    verticalAlignment: Text.AlignVCenter
                }

                Image {
                    x: 0
                    y: 65 * glValue.appUIHeight / 640
                    width: parent.width
                    height: 5 * glValue.appUIHeight / 640
                    opacity: {
                        if(specialFilterListModel.count == elementID + 1)
                            0
                        else
                            1
                    }
                    source: "images/listLine.png"
                }
            }
        }

        ListView {
            id: specialFilterListView
            x: 14 * glValue.appUIWidth / 360
            y: 80 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: parent.height - 80 * 2 * glValue.appUIHeight / 640
            model: specialFilterListModel
            delegate: specialFilterComponent
        }

        Image {
            x: 0
            y: 0
            width: 360 * glValue.appUIWidth / 360
            height: 80 * glValue.appUIHeight / 640
            source: "images/filtlerBGBG.png"
        }

        Image {
            x: 14 * glValue.appUIWidth / 360
            y: 15 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: 49 * glValue.appUIHeight / 640
            source: "images/filtlerBG.png"

            Text {
                anchors.fill: parent
                anchors.leftMargin: 15 * glValue.appUIWidth / 360
                verticalAlignment: Text.AlignVCenter
                font.pixelSize: 40
                color: "white"
                opacity: 0.8
                text: "Special Filters"
            }
        }

        Item {
            id: selectionButton
            x: 0
            y: homePageParentFilter.height - 80 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: 80 * glValue.appUIHeight / 640

            Image {
                anchors.fill: parent
                source: "images/topTenPageSponsorBannerBG.png"
            }

            Image {
                x: 14 * glValue.appUIWidth / 360
                y: 0
                width: 332 * glValue.appUIWidth / 360
                height: 80 * glValue.appUIHeight / 640
                opacity: 0.5
                source: "images/listBGFull.png"
            }

            Item {
                x: 14 * glValue.appUIWidth / 360
                y: 15 * glValue.appUIHeight / 640
                width: 332 * glValue.appUIWidth / 360
                height: 49 * glValue.appUIHeight / 640

                Image {
                    id: moreFiltersButton
                    x: 0
                    y: 0
                    width: parent.width / 2 - 3 * glValue.appUIWidth / 320
                    height: parent.height
                    source: "images/filtlerBG.png"

                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            parent.source = "images/listBGBottomSelected.png"

                            glValue.currentPage = "homePageParentFilter";
                            glValue.homeCurrentPage = "homePageParentFilter";

                            homePageSpecialFilter.hidePageToRight()
                            homePageParentFilter.showPageFromLeft()
                        }
                    }

                    Text {
                        anchors.centerIn: parent
                        font.pixelSize: 25
                        font.bold: true
                        color: "white"
                        opacity: 0.8
                        text: "More Filters"
                    }
                }

                Image {
                    id: goButton
                    x: parent.width / 2 + 3 * glValue.appUIWidth / 320
                    y: 0
                    width: parent.width / 2 - 3 * glValue.appUIWidth / 320
                    height: parent.height
                    source: "images/filtlerBG.png"

                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            parent.source = "images/listBGBottomSelected.png"

                            search();

                            homePageSpecialFilter.hidePageToLeft();
                            resultListing.showPageFromRight();
                            loadingCover.showLoadingCover();

                            //verson 2.0
                            resultListing.fromWhichPage = "special"

                            glValue.currentPage = "resultListing"
                            glValue.homeCurrentPage = "resultListing"
                        }
                    }

                    Text {
                        anchors.centerIn: parent
                        font.pixelSize: 25
                        font.bold: true
                        color: "white"
                        opacity: 0.8
                        text: "Go!"
                    }
                }
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: homePageSpecialFilter; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: homePageSpecialFilter; x: -homePageSpecialFilter.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: homePageSpecialFilter; x: homePageSpecialFilter.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
