import QtQuick 1.0

Item {
    id: loadingCover
    state: "hide"

    onStateChanged: {
        if(loadingCover.state == "show")
        {
            rotation.running = true
            textTimer.running = true
        }
        else
        {
            rotation.running = false
            textTimer.running = false
        }
    }

    function showLoadingCover()
    {
        loadingCover.state = "show"
    }

    function hideLoadingCover()
    {
        loadingCover.state = "hide"
    }

    Rectangle {
        anchors.fill: parent
        color: "black"
        opacity: 0.3

        MouseArea {
            anchors.fill: parent
            onClicked: {

            }
        }
    }

    Image {
        id: loadingImage
        smooth: true
        source: "images/loading.png"
        anchors.centerIn: parent
        RotationAnimation on rotation {
            id: rotation
            loops: 10000
            from: 0
            to: 360
            duration: 1000
         }
    }

    Text {
        id: loadingText
        x: (parent.width - loadingText.paintedWidth) /2
        y: (parent.height - loadingText.paintedHeight) / 2 + loadingImage.height
        font.pixelSize: 40
        color: "white"
        text: "Loading ..."
        font.italic: true
    }

    Timer {
        id: textTimer
        interval: 500;
        running: false;
        repeat: true
        onTriggered: {
            if(loadingText.text == "Loading ...")
                loadingText.text = "Loading "
            else if(loadingText.text == "Loading ")
                loadingText.text = "Loading ."
            else if(loadingText.text == "Loading .")
                loadingText.text = "Loading .."
            else if(loadingText.text == "Loading ..")
                loadingText.text = "Loading ..."
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: loadingCover; opacity: 1 }
        },
        State
        {
            name: "hide"
            PropertyChanges { target: loadingCover; opacity: 0 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hide"
            PropertyAnimation { properties: "opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hide"; to: "show"
            PropertyAnimation { properties: "opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
