import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    id: mainWindow
    objectName: "mainWindow"
    orientationLock: PageOrientation.LockPortrait

    GlobalVariable {
        id: glValue
        objectName: "glValue"
    }

    HomePage {
        id: homePage
        objectName: "homePage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    EditorialsPage {
        id: editorialsPage
        objectName: "editorialsPage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    EditorialsDetail {
        id: editorialsDetail
        objectName: "editorialsDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: editorialsFilmDetail
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: editorialsFilmShowHereLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: editorialsCinemaDetailLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: editorialsCinemaMapLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    HomePageParentFilter {
        id: homePageParentFilter
        objectName: "homePageParentFilter"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    HomePageSpecialFilter {
        id: homePageSpecialFilter
        objectName: "homePageSpecialFilter"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    ResultListing {
        id: resultListing
        objectName: "resultListing"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    FavouritesRestaurantsDetail
    {
        id:favouritesRestaurantsDetail
        objectName: "favouritesRestaurantsDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    FavouritesBarsClubsDetail
    {
        id:favouritesBarsClubsDetail
        objectName: "favouritesBarsClubsDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    FavouritesHotelDetail
    {
        id:favouritesHotelDetail
        objectName: "favouritesHotelDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }
    FavouritesNightLifeDetail
    {
        id:favouritesNightLifeDetail
        objectName: "favouritesNightLifeDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }
    FavouritesPageNightLifeDetailVenuePage
    {
        id:favouritesPageNightlifeDetailVenuePage
        objectName: "favouritesPageNightlifeDetailVenuePage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    TopTenHotelDetail
    {
        id:topTenHotelDetail
        objectName: "topTenHotelDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    TopTenBarsClubsDetail
    {
        id:topTenBarsClubsDetail
        objectName: "topTenBarsClubsDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    TopTenRestaurantsDetail
    {
        id:topTenRestaurantsDetail
        objectName: "topTenRestaurantsDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }


    Loader
    {
        id: topTenFilmDetail
        objectName: "topTenFilmDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: topTenFilmShowHereLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    TopTenNightLifeDetail
    {
        id:topTenNightlifeMusicDetail
        objectName: "topTenNightlifeMusicDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }
    TopTenNightlifeDetailVenuePage
    {
        id:topTenNightlifeDetailVenuePage
        objectName: "topTenNightlifeDetailVenuePage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    RestaurantsDetail {
        id: restaurantsDetail
        objectName: "restaurantsDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    BarsClubsDetail {
        id: barsClubsDetail
        objectName: "barsClubsDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    NightlifeMusicDetail {
        id: nightlifeMusicDetail
        objectName: "nightlifeMusicDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }
    NightlifeDetailVenuePage {
        id: nightlifeDetailVenuePage
        objectName: "nightlifeDetailVenuePage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: filmDetail
        objectName: "filmDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: filmShowHereLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: cinemaDetailLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: cinemaMapLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    HotelDetail {
        id: hotelDetail
        objectName: "hotelDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    TopTenPage {
        id: topTenPage
        objectName: "topTenPage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    NearbyList {
        id: nearbyList
        objectName: "nearbyList"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    TopTenNearbyList {
        id: topTenNearbyList
        objectName: "topTenNearbyList"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    SearchPageNearbyList {
        id: searchPageNearbyList
        objectName: "searchPageNearbyList"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    FavouritesPageNearbyList {
        id: favouritesPageNearbyList
        objectName: "favouritesPageNearbyList"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }



    FavouritesPage {
        id: favouritesPage
        objectName: "favouritesPage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    SearchPage {
        id: searchPage
        objectName: "searchPage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }
    SearchPageParenFilter {
        id: searchPageParenFilter
        objectName: "searchPageParenFilter"
        x: 0
        y: 80 * 854 / 640
        width: parent.width
        height: 500 * 854 / 640
    }

    SearchPageResultListing {
        id: searchPageResultListing
        objectName: "searchPageResultListing"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    SearchPageRestaurantsDetail {
        id: searchPageRestaurantsDetail
        objectName: "searchPageRestaurantsDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }
    SearchPageBarsClubsDetail {
        id: searchPageBarsClubsDetail
        objectName: "searchPageBarsClubsDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    SearchPageHotelDetail {
        id: searchPageHotelDetail
        objectName: "searchPageHotelDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: searchPageFilmDetail
        objectName: "searchPageFilmDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: searchPageFilmShowHereLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: searchPageCinemaDetailLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    Loader {
        id: searchPageCinemaMapLoader
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    SearchPageNightLiftDetail {
        id: searchPageNightLifeDetail
        objectName: "searchPageNightLifeDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    SearchPageNightLifeDetailVeneusPage {
        id: searchPageNightlifeDetailVenuePage
        objectName: "searchPageNightlifeDetailVenuePage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    TopBar {
        id: topBar
        objectName: "topBar"
        x: 0
        y: 0
        width: parent.width
        height: 107
    }

    BottomMenu {
        id: bottomMenu
        objectName: "bottomMenu"
        x: 0
        y: 580 * parent.height / 640
        width: parent.width
        height: 60 * parent.height / 640
    }

    BlankCover {
        id: blankCover
        objectName: "blankCover"
        x: 0
        y: 0
        width: parent.width
        height: parent.height
    }

    SharePage {
        id: sharePage
        objectName: "sharePage"
        x: 0
        y: 366 * parent.height / 640
        width: parent.width
        height: 274 * parent.height / 640
    }

    Webbrowser {
        id: webbrowser
        objectName: "webbrowser"
        x: 0
        y: 0
        width: parent.width
        height: parent.height
        clip: true
    }

    WelcomePage {
        id: welcomePage
        objectName: "welcomePage"
        x: 0
        y: 0
        width: parent.width
        height: parent.height
    }

    LoadingCover {
        id: loadingCover
        objectName: "loadingCover"
        x: 0
        y: 0
        width: parent.width
        height: parent.height
    }

    SQL {
        id: sql
        objectName: "sql"
        x: 0
        y: 0
        width: parent.width
        height: parent.height
    }

    MapsHomePage {
        id: mapsHomePage
        objectName: "mapsHomePage"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    MapsTopTenHotelDetail {
        id: mapsTopTenHotelDetail
        objectName: "mapsTopTenHotelDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    MapsFavouritesHotelDetail {
        id: mapsFavouritesHotelDetail
        objectName: "mapsFavouritesHotelDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

    MapsSearchPageHotelDetail {
        id: mapsSearchPageHotelDetail
        objectName: "mapsSearchPageHotelDetail"
        x: 0
        y: 80 * parent.height / 640
        width: parent.width
        height: 500 * parent.height / 640
    }

}
