import QtQuick 1.0

Rectangle {
    id: mapsFavouritesHotelDetail
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        mapsFavouritesHotelDetail.state = "";
        mapsFavouritesHotelDetail.state = "hideLeft"
        mapsFavouritesHotelDetail.state = "show"
    }

    function showPageFromRight()
    {
        mapsFavouritesHotelDetail.state = "";
        mapsFavouritesHotelDetail.state = "hideRight"
        mapsFavouritesHotelDetail.state = "show"
    }

    function hidePageToLeft()
    {
        mapsFavouritesHotelDetail.state = "";
        mapsFavouritesHotelDetail.state = "show"
        mapsFavouritesHotelDetail.state = "hideLeft"
    }

    function hidePageToRight()
    {
        mapsFavouritesHotelDetail.state = "";
        mapsFavouritesHotelDetail.state = "show"
        mapsFavouritesHotelDetail.state = "hideRight"
    }
    //----------------------- End ---------------------------------------

    property string lat: "";
    property string lng: "";
    property string zoom: "";

    function showMap()
    {
        console.log(lat + "   " + lng + "   " + zoom)
        centerMap.source = 'http://m.ovi.me/?c=' + lat + ',' + lng + '&z=' + zoom + '&w=' + 480 + '&h=' + 666 + '&nord';
        loadingCover.hideLoadingCover()
    }

    function hideMap()
    {
        centerMap.source = "";
    }

    function resetData()
    {
        lat = "";
        lng = "";
        zoom = "";
    }

    Image {
        id: centerMap
        x: 0
        y: 0
        width: 480
        height: 666
        source: ""
        state: "hide"

        states:
        [
            State
            {
                name: "show"
                PropertyChanges { target: centerMap; opacity: 1 }
            },
            State
            {
                name: "hide"
                PropertyChanges { target: centerMap; opacity: 0 }
            }
        ]
        transitions:
        [
            Transition {
                from: "hide"; to: "show"
                PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
            }
        ]

        onStatusChanged: {
            if(centerMap.status == 2) {
                mainImageBusy.opacity = 0.8
                rotation.running = true
            }
            else if(centerMap.status == 1) {
                mainImageBusy.opacity = 0
                rotation.running = false
                centerMap.state = "show"
            }
        }
    }

    Image {
        id: mainImageBusy
        anchors.centerIn: centerMap
        width: 50
        height: 50
        smooth: true
        opacity: 1
        source: "images/busy.png"

        RotationAnimation on rotation {
            id: rotation
            loops: 10000
            from: 0
            to: 360
            duration: 1200
        }
    }

    Image {
        id: zoomIn
        x: 420
        y: centerMap.height - 130
        width: 50
        height: 45
        smooth: true
        source: "images/SpecialFilterBlue.png"

        MouseArea {
            anchors.fill: parent
            onClicked: {
                if(zoom < 20) {
                    zoom++;
                    showMap();
                }
            }
        }
    }

    Image {
        id: zoomOut
        x: 420
        y: centerMap.height - 60
        width: 50
        height: 45
        smooth: true
        source: "images/SpecialFilterRed.png"

        MouseArea {
            anchors.fill: parent
            onClicked: {
                if(zoom > 0) {
                    zoom--;
                    showMap();
                }
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: mapsFavouritesHotelDetail; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: mapsFavouritesHotelDetail; x: -mapsFavouritesHotelDetail.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: mapsFavouritesHotelDetail; x: mapsFavouritesHotelDetail.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
