import QtQuick 1.0

Rectangle {
    id: nightlifeMusicDetail
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        nightlifeMusicDetail.state = "";
        nightlifeMusicDetail.state = "hideLeft"
        nightlifeMusicDetail.state = "show"
    }

    function showPageFromRight()
    {
        nightlifeMusicDetail.state = "";
        nightlifeMusicDetail.state = "hideRight"
        nightlifeMusicDetail.state = "show"
    }

    function hidePageToLeft()
    {
        nightlifeMusicDetail.state = "";
        nightlifeMusicDetail.state = "show"
        nightlifeMusicDetail.state = "hideLeft"

        timer.running = false;
    }

    function hidePageToRight()
    {
        nightlifeMusicDetail.state = "";
        nightlifeMusicDetail.state = "show"
        nightlifeMusicDetail.state = "hideRight"

        timer.running = false;
    }

    property string f_title: "";
    property string f_desc: "";
    property string f_thumb: "";
    property string f_apiUrl: "";
    //----------------------- End ---------------------------------------
    property string f_name: "";
    property string f_color: "";
    property string f_venueUid: "";
    property string f_venueName: "";
    property string f_venueAddress: "";
    property string f_venueApiUrl: "";
    property string f_phone: "";
    property string f_url: "";
    property string f_travelInfo: "";
    property string f_openingTimes: "";
    property string f_occuring: "";
    property string f_description: "";
    property string f_lat: "";
    property string f_lng: "";
    property string f_webUrl: "";

    function receiveGeneralData(name, color, venueUid, venueName,
                                venueAddress, venueApiUrl, phone, url,
                                travelInfo, openingTimes, occuring,
                                description, lat, lng, webUrl)
    {
        loadingCover.hideLoadingCover();
        textFlick.opacity = 1;

        f_name = name
        f_color = color
        f_venueUid = venueUid
        f_venueName = venueName
        f_venueAddress = venueAddress
        f_venueApiUrl = venueApiUrl
        f_phone = phone
        f_url = url
        f_travelInfo = travelInfo
        f_openingTimes = openingTimes
        f_occuring = occuring
        f_description = description
        f_lat = lat
        f_lng = lng
        f_webUrl = webUrl

        timer.running = true;
    }

    Timer {
        id: timer
        interval: 100; running: false; repeat: true
        onTriggered: setData()
    }

    function setData()
    {
        line_5.y = edit.paintedHeight + edit.y + 8;
    }

    function resetData()
    {
        textFlick.opacity = 0;

        f_name = "";
        f_color = "";
        f_venueUid = "";
        f_venueName = "";
        f_venueAddress = "";
        f_venueApiUrl = "";
        f_phone = "";
        f_url = "";
        f_travelInfo = "";
        f_openingTimes = "";
        f_occuring = "";
        f_description = "";
        f_lat = "";
        f_lng = "";
        f_webUrl = "";
    }

    function sendFavouriteInfo()
    {
        sql.addFavouriteIoFo("", f_title, f_desc, f_thumb, f_apiUrl, "NightLife", "No", "", "", "");
    }
    function changeFavouriteButton()
    {
        if(glValue.ifExistFlag == true)
        {
            favouriteButton.source ="images/favouriteButtonOn.png"
        }
        else
        {
            favouriteButton.source ="images/favouriteButton.png"
        }
    }

    signal requireDetailOfNightLife(string f_venueApiUrl)

    Flickable {
        id: textFlick
        width: 360 * glValue.appUIWidth / 360;
        height: restaurantsDetail.height;
        contentWidth: 360
        contentHeight: shareButtonImage.y + shareButtonImage.height + 15
        flickableDirection: Flickable.VerticalFlick
        clip: true
        opacity: 0

        Text {
            id: titleText
            x: 10 * glValue.appUIWidth / 360
            y: 10 * glValue.appUIHeight / 640
            width: 340 * glValue.appUIWidth / 360
            height: titleText.paintedHeight
            verticalAlignment: Text.AlignVCenter
            font.pixelSize: 30
            font.bold: true
            wrapMode: "WordWrap"
            text: f_name
        }

        Image {
            id: line_0
            x: 8 * glValue.appUIWidth / 360
            y: titleText.paintedHeight + titleText.y + 13
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Item {
            id: venueTitleItem
            x: 10 * glValue.appUIWidth / 360
            y: line_0.height + line_0.y + 15
            width: 340 * glValue.appUIWidth / 360
            height: venueTitleText.paintedHeight * glValue.appUIHeight / 640

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    loadingCover.showLoadingCover();
                    console.log(f_venueApiUrl)
                    requireDetailOfNightLife(f_venueApiUrl)
                    nightlifeMusicDetail.hidePageToLeft()
                    nightlifeDetailVenuePage.showPageFromRight()

                    glValue.currentPage = "nightlifeDetailVenuePage"
                    glValue.homeCurrentPage = "nightlifeDetailVenuePage"
                }
            }

            Text {
                id: venueTitleText
                anchors.fill: parent
                verticalAlignment: Text.AlignTop
                font.pixelSize: 30
                wrapMode: "WordWrap"
                text: f_venueName
            }

            Image {
                x: 300 * glValue.appUIWidth / 360
                y: (venueTitleItem.height - 31) / 2
                width: 26 * glValue.appUIWidth / 360
                height: 31 * glValue.appUIHeight / 640
                source: "images/arrow.png"
            }
        }

        Image {
            id: line_1
            x: 8 * glValue.appUIWidth / 360
            y: venueTitleItem.height + venueTitleItem.y + 15
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Image {
            id: mapButton
            x: 280 * glValue.appUIWidth / 360
            y: line_1.height + line_1.y + 3
            width: 73 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/mapButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    loadingCover.showLoadingCover();

                    mapsHomePage.resetData()

                    mapsHomePage.lat = f_lat;
                    mapsHomePage.lng = f_lng;
                    mapsHomePage.zoom = "17";

                    mapsHomePage.showMap();

                    mapsHomePage.showPageFromRight();
                    nightlifeMusicDetail.hidePageToLeft();

                    glValue.homeCurrentPage = "mapsHomePageNightLife"
                    glValue.currentPage = "mapsHomePageNightLife"
                }
            }
        }

        Image {
            x: 8 * glValue.appUIWidth / 360
            y: mapButton.y + mapButton.height + 10
            width: 29 * glValue.appUIWidth / 360
            height: 35 * glValue.appUIHeight / 640
            source: "images/phoneButton.png"
        }

        Text {
            x: 50 * glValue.appUIWidth / 360
            y: mapButton.y + mapButton.height + 10
            font.pixelSize: 25
            text: f_phone
        }

        Image {
            id: callButton
            x: 240 * glValue.appUIWidth / 360
            y: mapButton.y + mapButton.height + 8
            width: 115 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/callButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    var temp = f_phone.replace(" ", "");
                    temp = temp.replace(" ", "");
                    temp = temp.replace(" ", "");
                    temp = temp.replace(" ", "");
                    temp = temp.replace(" ", "");

                    Qt.openUrlExternally("tel:<" + temp + ">")
                    console.log("tel:<" + temp + ">")
                }
            }
        }

        Image {
            id: line_2
            x: 8 * glValue.appUIWidth / 360
            y: callButton.height + callButton.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Image {
            x: 8 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 10
            width: 34 * glValue.appUIWidth / 360
            height: 34 * glValue.appUIHeight / 640
            source: "images/websiteButton.png"
        }

        Text {
            x: 50 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 10
            font.pixelSize: 25
            text: "Website"
        }

        Image {
            id: viewButton
            x: 240 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 8
            width: 115 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/viewButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    Qt.openUrlExternally(f_webUrl)
                }
            }
        }

        Image {
            id: line_3
            x: 8 * glValue.appUIWidth / 360
            y: viewButton.height + viewButton.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: timeoutSays
            x: 8 * glValue.appUIWidth / 360
            y: line_3.height + line_3.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 30
            text: "TimeOut Dubai says..."
        }

        TextEdit {
            id: edit
            x: 8 * glValue.appUIWidth / 360
            y: timeoutSays.height + timeoutSays.y
            width: 344 * glValue.appUIWidth / 360
            height: edit.paintedHeight
            wrapMode: TextEdit.Wrap
            readOnly: true
            focus: false
            font.pixelSize: 25
            text: f_description
        }

        Image {
            id: line_5
            x: 8 * glValue.appUIWidth / 360
            y: edit.height + edit.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Image {
            id: favouriteButton
            x: 10 * glValue.appUIWidth / 360
            y: line_5.height + line_5.y + 8
            width: 160 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: {
                if(glValue.ifExistFlag == false)
                {
                    "images/favouriteButton.png"
                }
                else if(glValue.ifExistFlag == true)
                {
                    "images/favouriteButtonOn.png"
                }
            }


            MouseArea {
                anchors.fill: parent
                onClicked: {
                    if(f_name != "Oops! Sorry...")
                    {
                        if(glValue.ifExistFlag == false)
                        {
                            sendFavouriteInfo();
                            favouriteButton.source = "images/favouriteButtonOn.png"
                            glValue.ifExistFlag = true
                        }
                        else if(glValue.ifExistFlag == true)
                        {
                            sql.checkIfFavouritesExisted(f_title, f_desc, f_thumb, f_apiUrl)
                            if(glValue.ifExistFlag == true)
                            {
                                sql.deleteFavouritesExisted(f_title, f_desc, f_thumb, f_apiUrl)
                                favouriteButton.source = "images/favouriteButton.png"
                                glValue.ifExistFlag = false
                            }
                            else if(glValue.ifExistFlag == false)
                            {
                                glValue.ifExistFlag = false
                                favouriteButton.source = "images/favouriteButton.png"
                            }
                        }
                    }
                    else
                    {
                        return;
                    }
                }
            }
        }

        Image {
            id: shareButtonImage
            x: 190 * glValue.appUIWidth / 360
            y: line_5.height + line_5.y + 8
            width: 160 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/shareButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    sharePage.title = f_title;
                    sharePage.url = f_webUrl;

                    sharePage.showsharePage();
                }
            }
        }
    }


    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: nightlifeMusicDetail; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: nightlifeMusicDetail; x: -nightlifeMusicDetail.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: nightlifeMusicDetail; x: nightlifeMusicDetail.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
