import QtQuick 1.0
import "./javascript/APIsRequest.js" as APIsRequest

Rectangle {
    id: nowShowingHerePage
    state: "hideLeft"

    property int marginSize: 15

    function showPageFromLeft()
    {
        nowShowingHerePage.state = "";
        nowShowingHerePage.state = "hideLeft"
        nowShowingHerePage.state = "show"
    }

    function showPageFromRight()
    {
        nowShowingHerePage.state = "";
        nowShowingHerePage.state = "hideRight"
        nowShowingHerePage.state = "show"
    }

    function hidePageToLeft()
    {
        nowShowingHerePage.state = "";
        nowShowingHerePage.state = "show"
        nowShowingHerePage.state = "hideLeft"
    }

    function hidePageToRight()
    {
        nowShowingHerePage.state = "";
        nowShowingHerePage.state = "show"
        nowShowingHerePage.state = "hideRight"
    }

    property string filmName: "";
    property string filmGenre: "";
    property string filmStarRating: "";
    property string filmImageUrl: "";

    property string cinemaUid: "";
    property string cinemaName: "";
    property string cinemaAddress: "";
    property string cinemaLat: "";
    property string cinemaLng: "";
    property string cinemaPhone: "";
    property string cinemaApiUrl: "";
    property string cinemaShowtimes: "";

    function resetData()
    {
        filmName = "";
        filmGenre = "";
        filmStarRating = "";
        filmImageUrl = "";

        cinemaUid = "";
        cinemaName = "";
        cinemaAddress = "";
        cinemaLat = "";
        cinemaLng = "";
        cinemaPhone = "";
        cinemaApiUrl = "";
        cinemaShowtimes = "";

        cinemaListModel.clear();

        cinemaListView.height = 0;
    }

    function getCinemaData(uid)
    {
        loadingCover.showLoadingCover();

        function requestCinemaDetail() {}
        requestCinemaDetail.prototype = {
            update: function(status, result)
                    {
                        var root = result.documentElement;

                        if(root == undefined)
                        {
                            loadingCover.hideLoadingCover();

                            return "error";
                        }

                        for(var i_1=0; i_1<root.childNodes.length; i_1++)
                        {
                            if(root.nodeName != "toxml") {
                                //Warning
                            }
                            else
                            {
                                loadingCover.hideLoadingCover();

                                if(root.childNodes[i_1].nodeName == "response")
                                {
                                    var nodesRoot = root.childNodes[i_1];
                                    for(var i_2=0; i_2<nodesRoot.childNodes.length; i_2++)
                                    {
                                        var nodesRow = nodesRoot.childNodes[i_2];
                                        for(var i_3=0; i_3<nodesRow.childNodes.length; i_3++)
                                        {
                                            if(nodesRow.childNodes[i_3].nodeName == "cinemaUid")
                                                cinemaUid = nodesRow.childNodes[i_3].childNodes[0].nodeValue;
                                            else if(nodesRow.childNodes[i_3].nodeName == "cinemaName")
                                                cinemaName = nodesRow.childNodes[i_3].childNodes[0].nodeValue;
                                            else if(nodesRow.childNodes[i_3].nodeName == "cinemaAddress")
                                                cinemaAddress = nodesRow.childNodes[i_3].childNodes[0].nodeValue;
                                            else if(nodesRow.childNodes[i_3].nodeName == "cinemaLat")
                                                cinemaLat = nodesRow.childNodes[i_3].childNodes[0].nodeValue;
                                            else if(nodesRow.childNodes[i_3].nodeName == "cinemaLng")
                                                cinemaLng = nodesRow.childNodes[i_3].childNodes[0].nodeValue;
                                            else if(nodesRow.childNodes[i_3].nodeName == "cinemaPhone")
                                                cinemaPhone = nodesRow.childNodes[i_3].childNodes[0].nodeValue;
                                            else if(nodesRow.childNodes[i_3].nodeName == "cinemaApiUrl")
                                                cinemaApiUrl = nodesRow.childNodes[i_3].childNodes[0].nodeValue;
                                            else if(nodesRow.childNodes[i_3].nodeName == "Showtimes")
                                            {
                                                var nodesShowTimes = nodesRow.childNodes[i_3];
                                                for(var i_4=0; i_4<nodesShowTimes.childNodes.length; i_4++)
                                                {
                                                    var showTime = nodesShowTimes.childNodes[i_4].childNodes[0].nodeValue;

                                                    if(i_4 < 10)
                                                    {
                                                        if(cinemaShowtimes == "")
                                                            cinemaShowtimes += showTime;
                                                        else
                                                            cinemaShowtimes += " " + showTime;
                                                    }
                                                    else if(i_4 == 10)
                                                        cinemaShowtimes += "..."
                                                }
                                            }
                                        }

                                        cinemaListModel.append({
                                           "eCinemaUid": cinemaUid,
                                           "eCinemaName": cinemaName,
                                           "eCinemaAddress": cinemaAddress,
                                           "eCinemaLat": cinemaLat,
                                           "eCinemaLng": cinemaLng,
                                           "eCinemaPhone": cinemaPhone,
                                           "eCinemaApiUrl": cinemaApiUrl,
                                           "eCinemaShowtimes": cinemaShowtimes,
                                       })

                                        cinemaUid = "";
                                        cinemaName = "";
                                        cinemaAddress = "";
                                        cinemaLat = "";
                                        cinemaLng = "";
                                        cinemaPhone = "";
                                        cinemaApiUrl = "";
                                        cinemaShowtimes = "";
                                    }
                                }
                            }
                        }

                        cinemaListView.height = marginSize * 12 * cinemaListModel.count
                    }
        }

        var searchString = "http://www.timeoutdubai.com/webservice/getFilmShowtimes?uid=" + uid + "&limit=100";
        APIsRequest.getWebserviceData(searchString, new requestCinemaDetail());
    }

    Flickable {
        id: flickView
        x: marginSize
        y: 0
        width: parent.width - marginSize * 2
        height: parent.height
        contentWidth: width
        contentHeight: cinemaListView.y + cinemaListView.height + marginSize
        clip: true

        Text {
            id: titleText
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.right: parent.right
            font.pixelSize: 40
            font.bold: true
            wrapMode: "WordWrap"
            text: filmName
        }

        Text {
            id: subTitleText
            anchors.top: titleText.bottom
            anchors.left: titleText.left
            anchors.right: titleText.right
            font.pixelSize: 25
            wrapMode: "WordWrap"
            text: filmGenre
        }

        Image {
            id: subTitleUnderline
            anchors.top: subTitleText.bottom
            anchors.left: subTitleText.left
            anchors.right: subTitleText.right
            source: "images/line.png"
        }

        Item {
            id: topStarRating
            anchors.top: subTitleUnderline.bottom
            anchors.topMargin: marginSize / 2
            anchors.left: subTitleUnderline.left
            anchors.right: subTitleUnderline.right
            height: 30

            ListModel {
                id: topRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: topRatingComponent

                Item {
                    id: topRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        source: {
                            if(index < filmStarRating)
                                return "images/starOn.png";
                            else
                                return "images/starOff.png";
                        }
                    }
                }
            }

            ListView {
                id: topRatingListView
                anchors.fill: parent
                model: topRatingListModel
                delegate: topRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Image {
            id: mainImage
            anchors.top: topStarRating.bottom
            anchors.topMargin: marginSize / 2
            anchors.left: topStarRating.left
            anchors.right: topStarRating.right
            height: (360/1.6667) * glValue.appUIHeight / 640
            source: filmImageUrl
            state: "hide"

            states:
            [
                State
                {
                    name: "show"
                    PropertyChanges { target: mainImage; opacity: 1 }
                },
                State
                {
                    name: "hide"
                    PropertyChanges { target: mainImage; opacity: 0 }
                }
            ]
            transitions:
            [
                Transition {
                    from: "hide"; to: "show"
                    PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                }
            ]

            onStatusChanged: {
                if(mainImage.status == 2) {
                    mainImageBusy.opacity = 0.8
                    rotation.running = true
                }
                else if(mainImage.status == 1) {
                    mainImageBusy.opacity = 0
                    rotation.running = false
                    mainImage.state = "show"
                }
            }
        }

        Image {
            id: mainImageBusy
            anchors.centerIn: mainImage
            width: 35
            height: 35
            smooth: true
            opacity: 1
            source: "images/busy.png"

            RotationAnimation on rotation {
                id: rotation
                loops: 10000
                from: 0
                to: 360
                duration: 1200
            }
        }

        ListModel {
            id: cinemaListModel
        }

        Component {
            id: cinemaComponent

            Item {
                id: cinemaDelegateItem
                width: parent.width
                height: marginSize * 12

                MouseArea {
                    x: 0
                    y: 0
                    width: parent.width
                    height: parent.height / 2
                    onClicked: {
                        if(glValue.currentPage == "filmShowHere")
                        {
                            if(cinemaDetailLoader.status == Loader.Null)
                                cinemaDetailLoader.source = "CinemaDetail.qml"

                            cinemaDetailLoader.item.getFilmData(eCinemaUid);

                            cinemaDetailLoader.item.showPageFromRight();
                            nowShowingHerePage.hidePageToLeft();

                            glValue.currentPage = "cinemaDetial"
                            glValue.homeCurrentPage = "cinemaDetial"
                        }
                        else if(glValue.currentPage == "searchPageFilmShowHere")
                        {
                            if(searchPageCinemaDetailLoader.status == Loader.Null)
                                searchPageCinemaDetailLoader.source = "CinemaDetail.qml"

                            searchPageCinemaDetailLoader.item.getFilmData(eCinemaUid);

                            searchPageCinemaDetailLoader.item.showPageFromRight();
                            nowShowingHerePage.hidePageToLeft();

                            glValue.currentPage = "searchPageCinemaDetial"
                            glValue.searchCurrentPage = "searchPageCinemaDetial"
                        }
                        else if(glValue.currentPage == "editorialsFilmShowHere")
                        {
                            if(editorialsCinemaDetailLoader.status == Loader.Null)
                                editorialsCinemaDetailLoader.source = "CinemaDetail.qml"

                            editorialsCinemaDetailLoader.item.getFilmData(eCinemaUid);

                            editorialsCinemaDetailLoader.item.showPageFromRight();
                            nowShowingHerePage.hidePageToLeft();

                            glValue.currentPage = "editorialsCinemaDetail"
                            glValue.homeCurrentPage = "editorialsCinemaDetail"
                        }
                    }
                }

                MouseArea {
                    x: 0
                    y: parent.height / 2
                    width: parent.width
                    height: parent.height / 2
                    onClicked: {
                        if(eCinemaPhone != "")
                        {
                            var tempPhone = eCinemaPhone;
                            for(var i=0; i<10; i++)
                                tempPhone = tempPhone.replace(" ", "");

                            Qt.openUrlExternally("tel:" + tempPhone);
                        }
                    }
                }

                Rectangle {
                    id: cinemaBG
                    anchors.fill: parent
                    anchors.rightMargin: 1
                    border.width: 1
                    border.color: "#c8c8c8"
                    color: "#e6e6e6"
                    radius: marginSize / 3 * 2
                    smooth: true

                    Rectangle {
                        id: cinemaMidLine
                        anchors.left: parent.left
                        anchors.right: parent.right
                        anchors.verticalCenter: parent.verticalCenter
                        height: 2
                        color: "#c8c8c8"
                    }

                    Text {
                        id: cinemaNameText
                        x: marginSize
                        y: marginSize / 2
                        width: parent.width - marginSize * 3
                        elide: Text.ElideRight
                        font.pixelSize: 30
                        text: eCinemaName
                    }

                    Text {
                        id: cinemaAddressText
                        anchors.top: cinemaNameText.bottom
                        anchors.left: cinemaNameText.left
                        anchors.right: cinemaNameText.right
                        elide: Text.ElideRight
                        font.pixelSize: 25
                        opacity: 0.7
                        text: eCinemaAddress
                    }

                    Image {
                        y: (parent.height / 2 - height) / 2
                        anchors.right: parent.right
                        anchors.rightMargin: marginSize
                        source: "images/arrow.png"
                    }

                    Image {
                        id: phoneIcon
                        x: marginSize / 3 * 2
                        y: (parent.height / 2) + (parent.height / 2 - height) / 2
                        source: "images/phoneButton.png"
                    }

                    Text {
                        anchors.verticalCenter: phoneIcon.verticalCenter
                        anchors.left: phoneIcon.right
                        anchors.leftMargin: marginSize
                        anchors.right: parent.right
                        anchors.rightMargin: marginSize
                        wrapMode: "WordWrap"
                        font.pixelSize: 20
                        opacity: 0.7
                        text: eCinemaShowtimes
                    }
                }
            }
        }

        ListView {
            id: cinemaListView
            anchors.top: mainImage.bottom
            anchors.topMargin: marginSize
            anchors.left: mainImage.left
            anchors.right: mainImage.right
            height: 0
            model: cinemaListModel
            delegate: cinemaComponent
            spacing: 30
            interactive: false
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: nowShowingHerePage; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: nowShowingHerePage; x: -nowShowingHerePage.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: nowShowingHerePage; x: nowShowingHerePage.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
