import QtQuick 1.0

Item {
    id: sql

    function createTable()
    {
        var db = openDatabaseSync("ScheduleDB", "1.0", "ScheduleDB QML SQL", 1000000);

        db.transaction (
            function(tx) {
                tx.executeSql('CREATE TABLE IF NOT EXISTS FavouriteIoFo(uid TEXT, title TEXT, desc TEXT, thumb TEXT, apiUrl TEXT, area TEXT, venues TEXT, extra1 TEXT, extra2 TEXT, extra3 TEXT)');
            }
        )
    }

    function addFavouriteIoFo(uid, title, desc, thumb, apiUrl,
                              area, venues, extra1, extra2, extra3)
        {
            var db = openDatabaseSync("ScheduleDB", "1.0", "ScheduleDB QML SQL", 1000000);

            db.transaction(
                function(tx)
                {
                    tx.executeSql('CREATE TABLE IF NOT EXISTS FavouriteIoFo(uid TEXT, title TEXT, desc TEXT, thumb TEXT, apiUrl TEXT, area TEXT, venues TEXT, extra1 TEXT, extra2 TEXT, extra3 TEXT)');

                    checkIfExisted(uid, title, desc, thumb, apiUrl, area, venues, extra1, extra2, extra3)
                    if(glValue.ifExistFlag == false)
                    {

                         tx.executeSql('INSERT INTO FavouriteIoFo VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [ uid, title, desc, thumb, apiUrl, area, venues, extra1, extra2, extra3 ]);

                         var rs = tx.executeSql('SELECT * FROM FavouriteIoFo');
                         for(var i = 0; i < rs.rows.length; i++)
                         {
                            console.log("in add: " + rs.rows.item(i).uid)
                         }
                   }
                }
                          )
        }



   function checkIfExisted(uid, title, desc, thumb, apiUrl, area, venues, extra1, extra2, extra3)

    {

        var db = openDatabaseSync("ScheduleDB", "1.0", "ScheduleDB QML SQL", 1000000);

        db.transaction(
        function(tx)
        {
            var rs = tx.executeSql('SELECT * FROM FavouriteIoFo');
                        if(rs.rows.length === 0)
                        {
                            glValue.ifExistFlag = false;
                            return;
                        }

            for(var i = 0; i < rs.rows.length; i++)
            {

                if(uid == rs.rows.item(i).uid && title == rs.rows.item(i).title && desc == rs.rows.item(i).desc && thumb == rs.rows.item(i).thumb && apiUrl == rs.rows.item(i).apiUrl &&
                   area == rs.rows.item(i).area && venues == rs.rows.item(i).venues && extra1 == rs.rows.item(i).extra1 && extra2 == rs.rows.item(i).extra2 && extra3 == rs.rows.item(i).extra3)
                {
                    glValue.ifExistFlag = true

                    console.log("-----------------------------++++++++++existed "+ rs.rows.item(i).uid)
                }
            }

        }
                      )

    }

    function sendFavouritesInfo()
    {
        var db = openDatabaseSync("ScheduleDB", "1.0", "ScheduleDB QML SQL", 1000000);

        db.transaction(
        function(tx)
        {
            var rs = tx.executeSql('SELECT * FROM FavouriteIoFo');
                        if(rs.rows.length === 0)
                        {
                            loadingCover.hideLoadingCover();
                            return;
                        }

            for(var i = 0; i < rs.rows.length; i++)
            {
                favouritesPage.receiveGeneralData(rs.rows.item(i).uid, rs.rows.item(i).title, rs.rows.item(i).desc, rs.rows.item(i).thumb, rs.rows.item(i).apiUrl,
                                                  rs.rows.item(i).area, rs.rows.item(i).venues, rs.rows.item(i).extra1, rs.rows.item(i).extra2, rs.rows.item(i).extra3)

                console.log("----------------------------------already send FavouritesInFo")
            }

        }
                      )
    }


    function checkIfFavouritesExisted(title, desc, thumb, apiUrl)
    {
        var db = openDatabaseSync("ScheduleDB", "1.0", "ScheduleDB QML SQL", 1000000);
        db.transaction(
        function(tx)
        {
            var rs = tx.executeSql('SELECT * FROM FavouriteIoFo');
                        if(rs.rows.length === 0)
                        {
                            glValue.ifExistFlag = false;
                            if(glValue.firstLevelSelection == "Restaurants" && glValue.currentPage == "resultListing")
                            {
                                restaurantsDetail.changeFavouriteButton();
                            }
                            else if(glValue.firstLevelSelection == "Bars & Clubs" && glValue.currentPage == "resultListing")
                            {
                                barsClubsDetail.changeFavouriteButton();
                            }
                            else if(glValue.firstLevelSelection == "Nightlife & Music" && glValue.currentPage == "resultListing")
                            {
                                nightlifeMusicDetail.changeFavouriteButton()
                            }
                            else if(glValue.firstLevelSelection == "Hotels" && glValue.currentPage == "resultListing")
                            {
                                hotelDetail.changeFavouriteButton();
                            }
                            else if(glValue.topTenPageSelection == "restaurants" && glValue.currentPage == "topTen")
                            {
                                topTenRestaurantsDetail.changeFavouriteButton();
                            }
                            else if(glValue.topTenPageSelection == "barsclubs" && glValue.currentPage == "topTen")
                            {
                                topTenBarsClubsDetail.changeFavouriteButton();
                            }
                            else if(glValue.topTenPageSelection == "nightlife" && glValue.currentPage == "topTen")
                            {
                                topTenNightlifeMusicDetail.changeFavouriteButton()
                            }
                            else if(glValue.topTenPageSelection == "hotels" && glValue.currentPage == "topTen")
                            {
                                topTenHotelDetail.changeFavouriteButton();
                            }
                            else if(glValue.searchPageSelection == "Restaurants" && glValue.currentPage == "searchPageResultListing")
                            {
                                searchPageRestaurantsDetail.changeFavouriteButton();
                            }
                            else if(glValue.searchPageSelection == "Hotels" && glValue.currentPage == "searchPageResultListing")
                            {
                                searchPageHotelDetail.changeFavouriteButton();
                            }
                            else if(glValue.searchPageSelection == "Bars & Clubs" && glValue.currentPage == "searchPageResultListing")
                            {
                                searchPageBarsClubsDetail.changeFavouriteButton();
                            }
                            else if(glValue.searchPageSelection == "Nightlife & Music" && glValue.currentPage == "searchPageResultListing")
                            {
                                searchPageNightLifeDetail.changeFavouriteButton()
                            }
                            else if(glValue.favouritesPageSelection == "Restaurant" && glValue.currentPage == "favourites")
                            {
                                favouritesRestaurantsDetail.changeFavouriteButton()
                            }
                            else if(glValue.favouritesPageSelection == "BarsClubs" && glValue.currentPage == "favourites")
                            {
                                favouritesBarsClubsDetail.changeFavouriteButton()
                            }
                            else if(glValue.favouritesPageSelection == "Hotels" && glValue.currentPage == "favourites")
                            {
                                favouritesHotelDetail.changeFavouriteButton()
                            }
                            else if(glValue.favouritesPageSelection == "NightLife" && glValue.currentPage == "favourites")
                            {
                                favouritesNightLifeDetail.changeFavouriteButton()
                            }
                            return;
                        }


            for(var i = 0; i < rs.rows.length; i++)
            {

                if(title == rs.rows.item(i).title && desc == rs.rows.item(i).desc && thumb == rs.rows.item(i).thumb && apiUrl == rs.rows.item(i).apiUrl)
                {
                    glValue.ifExistFlag = true
                    if(glValue.firstLevelSelection == "Restaurants" && glValue.currentPage == "resultListing")
                    {
                        restaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.firstLevelSelection == "Bars & Clubs" && glValue.currentPage == "resultListing")
                    {
                        barsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.firstLevelSelection == "Nightlife & Music" && glValue.currentPage == "resultListing")
                    {
                        nightlifeMusicDetail.changeFavouriteButton()
                    }
                    else if(glValue.firstLevelSelection == "Hotels" && glValue.currentPage == "resultListing")
                    {
                        hotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenPageSelection == "restaurants" && glValue.currentPage == "topTen")
                    {
                        topTenRestaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenPageSelection == "barsclubs" && glValue.currentPage == "topTen")
                    {
                        topTenBarsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenPageSelection == "nightlife" && glValue.currentPage == "topTen")
                    {
                        topTenNightlifeMusicDetail.changeFavouriteButton()
                    }
                    else if(glValue.topTenPageSelection == "hotels" && glValue.currentPage == "topTen")
                    {
                        topTenHotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchPageSelection == "Restaurants" && glValue.currentPage == "searchPageResultListing")
                    {
                        searchPageRestaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchPageSelection == "Hotels" && glValue.currentPage == "searchPageResultListing")
                    {
                        searchPageHotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchPageSelection == "Bars & Clubs" && glValue.currentPage == "searchPageResultListing")
                    {
                        searchPageBarsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchPageSelection == "Nightlife & Music" && glValue.currentPage == "searchPageResultListing")
                    {
                        searchPageNightLifeDetail.changeFavouriteButton()
                    }
                    else if(glValue.favouritesPageSelection == "Restaurant" && glValue.currentPage == "favourites")
                    {
                        favouritesRestaurantsDetail.changeFavouriteButton()
                    }
                    else if(glValue.favouritesPageSelection == "BarsClubs" && glValue.currentPage == "favourites")
                    {
                        favouritesBarsClubsDetail.changeFavouriteButton()
                    }
                    else if(glValue.favouritesPageSelection == "Hotels" && glValue.currentPage == "favourites")
                    {
                        favouritesHotelDetail.changeFavouriteButton()
                    }
                    else if(glValue.favouritesPageSelection == "NightLife" && glValue.currentPage == "favourites")
                    {
                        favouritesNightLifeDetail.changeFavouriteButton()
                    }

                    console.log("---------------------------------existed "+ title)
                    console.log("---------------------------------glValue.ifExistFlag = "+glValue.ifExistFlag)
                    return ;
                }
                else
                {
                    glValue.ifExistFlag = false
                    if(glValue.firstLevelSelection == "Restaurants" && glValue.currentPage == "resultListing")
                    {
                        restaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.firstLevelSelection == "Bars & Clubs" && glValue.currentPage == "resultListing")
                    {
                        barsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.firstLevelSelection == "Nightlife & Music" && glValue.currentPage == "resultListing")
                    {
                        nightlifeMusicDetail.changeFavouriteButton()
                    }
                    else if(glValue.firstLevelSelection == "Hotels" && glValue.currentPage == "resultListing")
                    {
                        hotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenPageSelection == "restaurants" && glValue.currentPage == "topTen")
                    {
                        topTenRestaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenPageSelection == "barsclubs" && glValue.currentPage == "topTen")
                    {
                        topTenBarsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenPageSelection == "nightlife" && glValue.currentPage == "topTen")
                    {
                        topTenNightlifeMusicDetail.changeFavouriteButton()
                    }
                    else if(glValue.topTenPageSelection == "hotels" && glValue.currentPage == "topTen")
                    {
                        topTenHotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchPageSelection == "Restaurants" && glValue.currentPage == "searchPageResultListing")
                    {
                        searchPageRestaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchPageSelection == "Hotels" && glValue.currentPage == "searchPageResultListing")
                    {
                        searchPageHotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchPageSelection == "Bars & Clubs" && glValue.currentPage == "searchPageResultListing")
                    {
                        searchPageBarsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchPageSelection == "Nightlife & Music" && glValue.currentPage == "searchPageResultListing")
                    {
                        searchPageNightLifeDetail.changeFavouriteButton()
                    }
                    else if(glValue.favouritesPageSelection == "Restaurant" && glValue.currentPage == "favourites")
                    {
                        favouritesRestaurantsDetail.changeFavouriteButton()
                    }
                    else if(glValue.favouritesPageSelection == "BarsClubs" && glValue.currentPage == "favourites")
                    {
                        favouritesBarsClubsDetail.changeFavouriteButton()
                    }
                    else if(glValue.favouritesPageSelection == "Hotels" && glValue.currentPage == "favourites")
                    {
                        favouritesHotelDetail.changeFavouriteButton()
                    }
                    else if(glValue.favouritesPageSelection == "NightLife" && glValue.currentPage == "favourites")
                    {
                        favouritesNightLifeDetail.changeFavouriteButton()
                    }
                    console.log("---------------------------------not "+ title + " found")
                    console.log("-------------------------------glValue.ifExistFlag = "+glValue.ifExistFlag)
                }
            }

        }
                      )
    }


    function checkNearbyPageIfExisted(title, apiUrl)
    {
        var db = openDatabaseSync("ScheduleDB", "1.0", "ScheduleDB QML SQL", 1000000);
        db.transaction(
        function(tx)
        {
            var rs = tx.executeSql('SELECT * FROM FavouriteIoFo');
                        if(rs.rows.length === 0)
                        {
                            glValue.ifExistFlag = false;
                            if(glValue.firstLevelSelection == "Restaurants")
                            {
                                restaurantsDetail.changeFavouriteButton();
                            }
                            else if(glValue.firstLevelSelection == "Bars & Clubs")
                            {
                                barsClubsDetail.changeFavouriteButton();
                            }
                            else if(glValue.firstLevelSelection == "Nightlife & Music")
                            {
                                nightlifeMusicDetail.changeFavouriteButton();
                            }

                            else if(glValue.firstLevelSelection == "Hotels")
                            {
                                hotelDetail.changeFavouriteButton();
                            }
                            else if(glValue.topTenCurrentPage == "topTenRestaurantsDetail")
                            {
                                topTenRestaurantsDetail.changeFavouriteButton();
                            }
                            else if(glValue.topTenCurrentPage == "topTenBarsClubsDetail")
                            {
                                topTenBarsClubsDetail.changeFavouriteButton();
                            }
                            else if(glValue.topTenCurrentPage == "topTenHotelDetail")
                            {
                                topTenHotelDetail.changeFavouriteButton();
                            }
                            else if(glValue.topTenCurrentPage == "topTenNightlifeMusicDetail")
                            {
                                topTenNightlifeMusicDetail.changeFavouriteButton()
                            }
                            else if(glValue.searchCurrentPage == "searchPageRestaurantsDetail")
                            {
                                searchPageRestaurantsDetail.changeFavouriteButton();
                            }
                            else if(glValue.searchCurrentPage == "searchPageHotelDetail")
                            {
                                searchPageHotelDetail.changeFavouriteButton();
                            }
                            else if(glValue.searchCurrentPagee == "searchPageBarsClubsDetail")
                            {
                                searchPageBarsClubsDetail.changeFavouriteButton();
                            }
                            else if(glValue.searchCurrentPagee == "searchPageNightLifeDetail")
                            {
                                searchPageNightLifeDetail.changeFavouriteButton()
                            }
                            return;
                        }


            for(var i = 0; i < rs.rows.length; i++)
            {

                if(title == rs.rows.item(i).title && apiUrl == rs.rows.item(i).apiUrl)
                {
                    glValue.ifExistFlag = true
                    if(glValue.firstLevelSelection == "Restaurants")
                    {
                        restaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.firstLevelSelection == "Bars & Clubs")
                    {
                        barsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.firstLevelSelection == "Nightlife & Music")
                    {
                        nightlifeMusicDetail.changeFavouriteButton();
                    }

                    else if(glValue.firstLevelSelection == "Hotels")
                    {
                        hotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenCurrentPage == "topTenRestaurantsDetail")
                    {
                        topTenRestaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenCurrentPage == "topTenBarsClubsDetail")
                    {
                        topTenBarsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenCurrentPage == "topTenHotelDetail")
                    {
                        topTenHotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenCurrentPage == "topTenNightLifeDetail")
                    {
                        topTenNightlifeMusicDetail.changeFavouriteButton()
                    }

                    else if(glValue.searchCurrentPage == "searchPageRestaurantsDetail")
                    {
                        searchPageRestaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchCurrentPage == "searchPageHotelDetail")
                    {
                        searchPageHotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchCurrentPage == "searchPageBarsClubsDetail")
                    {
                        searchPageBarsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchCurrentPage == "searchPageNightLifeDetail")
                    {
                        searchPageNightLifeDetail.changeFavouriteButton();
                    }

                    console.log("---------------------------------existed "+ title)
                    console.log("---------------------------------glValue.ifExistFlag = "+glValue.ifExistFlag)
                    return ;
                }
                else
                {
                    glValue.ifExistFlag = false
                    if(glValue.firstLevelSelection == "Restaurants")
                    {
                        restaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.firstLevelSelection == "Bars & Clubs")
                    {
                        barsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.firstLevelSelection == "Nightlife & Music")
                    {
                        nightlifeMusicDetail.changeFavouriteButton()
                    }

                    else if(glValue.firstLevelSelection == "Hotels")
                    {
                        hotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenCurrentPage == "topTenRestaurantsDetail")
                    {
                        topTenRestaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenCurrentPage == "topTenBarsClubsDetail")
                    {
                        topTenBarsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenCurrentPage == "topTenHotelDetail")
                    {
                        topTenHotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.topTenCurrentPage == "topTenNightLifeDetail")
                    {
                        topTenNightlifeMusicDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchCurrentPage == "searchPageRestaurantsDetail")
                    {
                        searchPageRestaurantsDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchCurrentPage == "searchPageHotelDetail")
                    {
                        searchPageHotelDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchCurrentPage == "searchPageBarsClubsDetail")
                    {
                        searchPageBarsClubsDetail.changeFavouriteButton();
                    }
                    else if(glValue.searchCurrentPage == "searchPageNightLifeDetail")
                    {
                        searchPageNightLifeDetail.changeFavouriteButton()
                    }
                    console.log("---------------------------------not "+ title + " found")
                    console.log("-------------------------------glValue.ifExistFlag = "+glValue.ifExistFlag)
                }
            }

        }
                      )
    }


    function deleteFavouritesExisted(title, desc, thumb, apiUrl)
    {
        var db = openDatabaseSync("ScheduleDB", "1.0", "ScheduleDB QML SQL", 1000000);

        db.transaction(
        function(tx)
        {
            var rs = tx.executeSql('SELECT * FROM FavouriteIoFo');

            for(var i = 0; i < rs.rows.length; i++)
            {

                if(title == rs.rows.item(i).title && desc == rs.rows.item(i).desc && thumb == rs.rows.item(i).thumb && apiUrl == rs.rows.item(i).apiUrl)
                {
                    tx.executeSql("DELETE FROM FavouriteIoFo WHERE title = '"+title+"' AND desc = '"+desc+"' AND thumb = '"+thumb+"' AND apiUrl = '"+apiUrl+"'")
                    console.log("----------------------------------delete "+title)
                }
            }

        }
                      )
    }



}




