import QtQuick 1.0

Item {
    id: searchPage
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        searchPage.state = "";
        searchPage.state = "hideLeft"
        searchPage.state = "show"
    }

    function showPageFromRight()
    {
        searchPage.state = "";
        searchPage.state = "hideRight"
        searchPage.state = "show"
    }

    function hidePageToLeft()
    {
        searchPage.state = "";
        searchPage.state = "show"
        searchPage.state = "hideLeft"
    }

    function hidePageToRight()
    {
        searchPage.state = "";
        searchPage.state = "show"
        searchPage.state = "hideRight"
    }
    //----------------------- End ---------------------------------------

    Item {
        id: search
        x: 0
        y: 0
        width: parent.width
        height: parent.height


        Image {
            x: 14 * glValue.appUIWidth / 360
            y: 15 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: 49 * glValue.appUIHeight / 640
            source: "images/filtlerBG.png"

            Text {
                anchors.fill: parent
                anchors.leftMargin: 15 * glValue.appUIWidth / 360
                font.pixelSize: 40
                font.bold: true
                verticalAlignment: Text.AlignVCenter
                color: "white"
                opacity: 0.8
                text: "Search"
            }
        }
    }

    Item {
        id: pageContent
        x: 0
        y: 70 * glValue.appUIHeight / 640
        width: parent.width
        height: parent.height

        ListModel {
            id: searchPageListModel

            ListElement {
                elementID: 0
                elementName: "Restaurants"
                elementImage: "images/listBGTop.png"
                elementLineOpacity: 1
                elementSelectedOpacity: 0
            }
            ListElement {
                elementID: 1
                elementName: "Bars & Clubs"
                elementImage: "images/listBGFull.png"
                elementLineOpacity: 1
                elementSelectedOpacity: 0
            }
            ListElement {
                elementID: 2
                elementName: "Nightlife & Music"
                elementImage: "images/listBGFull.png"
                elementLineOpacity: 1
                elementSelectedOpacity: 0
            }
            ListElement {
                elementID: 3
                elementName: "Films"
                elementImage: "images/listBGFull.png"
                elementLineOpacity: 1
                elementSelectedOpacity: 0
            }
            ListElement {
                elementID: 4
                elementName: "Hotels"
                elementImage: "images/listBGBottom.png"
                elementLineOpacity: 0
                elementSelectedOpacity: 0
            }
        }

        Component {
            id: searchPageComponent

            Item {
                id: searchPageDelegateItem
                width: searchPageListView.width
                height: 70 * glValue.appUIHeight / 640
                smooth: true

                MouseArea{
                    anchors.fill: parent
                    onClicked: {
                        if(elementName == "Restaurants")
                        {
                            topBar.showBackButton();

                            searchPage.hidePageToLeft()
                            searchPageParenFilter.showPageFromRight()

                            glValue.currentPage = "searchPageParenFilter"
                            glValue.searchCurrentPage = "searchPageParenFilter"
                            glValue.searchPageSelection = "Restaurants"

                        }
                        if(elementName == "Bars & Clubs")
                        {
                            topBar.showBackButton();

                            searchPage.hidePageToLeft()
                            searchPageParenFilter.showPageFromRight()

                            glValue.currentPage = "searchPageParenFilter"
                            glValue.searchCurrentPage = "searchPageParenFilter"
                            glValue.searchPageSelection = "Bars & Clubs"
                        }
                        if(elementName == "Nightlife & Music")
                        {

                            topBar.showBackButton();
                            searchPage.hidePageToLeft()
                            searchPageParenFilter.showPageFromRight()

                            glValue.currentPage = "searchPageParenFilter"
                            glValue.searchCurrentPage = "searchPageParenFilter"
                            glValue.searchPageSelection = "Nightlife & Music"
                        }
                        if(elementName == "Films")
                        {
                            topBar.showBackButton();
                            searchPage.hidePageToLeft()
                            searchPageParenFilter.showPageFromRight()

                            glValue.currentPage = "searchPageParenFilter"
                            glValue.searchCurrentPage = "searchPageParenFilter"
                            glValue.searchPageSelection = "Films"
                        }
                        if(elementName == "Hotels")
                        {
                            topBar.showBackButton();
                            searchPage.hidePageToLeft()
                            searchPageParenFilter.showPageFromRight()

                            glValue.currentPage = "searchPageParenFilter"
                            glValue.searchCurrentPage = "searchPageParenFilter"
                            glValue.searchPageSelection = "Hotels"
                        }

                    }
                }

                Image {
                    anchors.fill: parent
                    source: elementImage
                }

                Text {
                    anchors.fill: parent
                    anchors.leftMargin: 20 * glValue.appUIWidth / 360
                    verticalAlignment: Text.AlignVCenter
                    font.pixelSize: 40
                    color: "white"
                    opacity: 0.9
                    text: elementName
                }

                Image {
                    x: 0
                    y: 60 * glValue.appUIHeight / 640
                    width: parent.width
                    height: 5 * glValue.appUIHeight / 640
                    opacity: elementLineOpacity
                    source: "images/listLine.png"
                }

                Image {
                    x: 290 * glValue.appUIWidth / 360
                    y: 18 * glValue.appUIHeight / 640
                    width: 27 * glValue.appUIWidth / 360
                    height: 32 * glValue.appUIHeight / 640
                    source: "images/arrow.png"
                }
            }
        }

        ListView {
            id: searchPageListView
            anchors.fill: parent
            anchors.leftMargin: 15
            anchors.rightMargin: 15
            boundsBehavior: Flickable.StopAtBounds
            model: searchPageListModel
            delegate: searchPageComponent
            clip: true
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: searchPage; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: searchPage; x: -pageContent.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: searchPage; x: pageContent.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
