import QtQuick 1.0
import com.nokia.meego 1.0

Item {
    id:searchPageParenFilter
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        searchPageParenFilter.state = "";
        searchPageParenFilter.state = "hideLeft"
        searchPageParenFilter.state = "show"
    }

    function showPageFromRight()
    {
        searchPageParenFilter.state = "";
        searchPageParenFilter.state = "hideRight"
        searchPageParenFilter.state = "show"
    }

    function hidePageToLeft()
    {
        searchPageParenFilter.state = "";
        searchPageParenFilter.state = "show"
        searchPageParenFilter.state = "hideLeft"
    }

    function hidePageToRight()
    {
        searchPageParenFilter.state = "";
        searchPageParenFilter.state = "show"
        searchPageParenFilter.state = "hideRight"
    }



    function searchMore(totalNum, nowHave)
    {
        if(nowHave % 10 !== 0)
            return;
        if(nowHave < totalNum)
        {

            searchString = searchString + "&offset=" + (nowHave/10+1)
            console.log("         " + searchString)
            if(glValue.searchPageSelection == "Restaurants")
            {
                 startSearchRestaurants(searchString)
            }
            else if(glValue.searchPageSelection == "Bars & Clubs")
            {
                 startSearchBarsClubs(searchString);
            }
            else if(glValue.searchPageSelection == "Nightlife & Music")
            {
                 startSearchNightLife(searchString);
            }
            else if(glValue.searchPageSelection == "Films")
            {
                 startSearchFilms(searchString);
            }
            else if(glValue.searchPageSelection == "Hotels")
            {
                 startSearchHotel(searchString);
            }
        }
    }

    //----------------------- End ---------------------------------------
    property string searchString: ""
    signal startSearchRestaurants(string url)
    signal startSearchBarsClubs(string url)
    signal startSearchNightLife(string url)
    signal startSearchFilms(string url)
    signal startSearchHotel(string url)

    function search()
    {
        if(glValue.searchPageSelection == "Restaurants")
        {
            searchString = "http://www.timeoutdubai.com/webservice/search?section=restaurants&q="
            if(searchTextInput.text != "")
            {
                searchString += searchTextInput.text
            }
            startSearchRestaurants(searchString)
        }
        else if(glValue.searchPageSelection == "Bars & Clubs")
        {
            searchString ="http://www.timeoutdubai.com/webservice/search?section=bars-clubs&q="
            if(searchTextInput.text != "")
            {
                searchString += searchTextInput.text
            }
            startSearchBarsClubs(searchString)
        }
        else if(glValue.searchPageSelection == "Nightlife & Music")
        {
            searchString ="http://www.timeoutdubai.com/webservice/search?section=nightlife&q="
            if(searchTextInput.text != "")
            {
                searchString += searchTextInput.text
            }
            startSearchNightLife(searchString)
        }
        else if(glValue.searchPageSelection == "Films")
        {
            searchString ="http://www.timeoutdubai.com/webservice/search?section=films&q="
            if(searchTextInput.text != "")
            {
                searchString += searchTextInput.text
            }
            startSearchFilms(searchString)
        }
        else if(glValue.searchPageSelection == "Hotels")
        {
            searchString ="http://www.timeoutdubai.com/webservice/search?section=hotels&q="
            if(searchTextInput.text != "")
            {
                searchString += searchTextInput.text
            }
            startSearchHotel(searchString)
        }

    }

    Item {
        id: pageContent
        x: 0
        y: 0
        width: 480
        height: 854

        MouseArea {
            anchors.fill: parent
            onPressed: searchTextInput.focus = false
        }

        Image {
            x: 19
            y: 20
            width: 443
            height: 65
            source: "images/filtlerBG.png"

            Text {
                anchors.fill: parent
                anchors.leftMargin: 20
                verticalAlignment: Text.AlignVCenter
                font.pixelSize: 35
                font.bold: true
                color: "white"
                opacity: 0.8
                text: "Search"
            }
        }
/*
        Image {
            x: 14* glValue.appUIWidth / 360
            y: 80* glValue.appUIHeight / 640
            width: 332* glValue.appUIWidth / 360
            height: 49* glValue.appUIHeight / 640
            source: "images/filtlerBG.png"

            Text {
                id: searchBGText
                anchors.fill: parent
                anchors.leftMargin: 20
                verticalAlignment: Text.AlignVCenter
                font.pixelSize: 35
                font.bold: true
                color: "white"
                opacity: 0.8
                state: "show"

                text: {
                    if(searchTextInput.text == "")
                        "Enter text here..."
                    else
                        ""
                }

                states:
                [
                    State
                    {
                        name: "show"
                        PropertyChanges { target: searchBGText; opacity: 0.8 }
                    },
                    State
                    {
                        name: "hide"
                        PropertyChanges { target: searchBGText; opacity: 0.5 }
                    }
                ]
                transitions:
                [
                    Transition {
                        from: "show"; to: "hide"
                        PropertyAnimation { properties: "opacity"; duration: 300; easing.type: Easing.InOutQuad }
                    },
                    Transition {
                        from: "hide"; to: "show"
                        PropertyAnimation { properties: "opacity"; duration: 300; easing.type: Easing.InOutQuad }
                    }
                ]
            }

            TextInput {
                id: searchTextInput
                anchors.fill: parent
                anchors.topMargin: 5
                anchors.leftMargin: 20
                anchors.rightMargin: 20
                font.pixelSize: 35
                color: "white"
                text: ""

                onFocusChanged: {
                    if(searchTextInput.focus == true)
                        searchBGText.state = "hide"
                    else
                        searchBGText.state = "show"
                }
            }
        }
*/
        //version 1.2
        TextField {
            id: searchTextInput
            x: 14* glValue.appUIWidth / 360
            y: 80* glValue.appUIHeight / 640
            width: 332* glValue.appUIWidth / 360
            height: 49* glValue.appUIHeight / 640

            Keys.onPressed: {
                console.log(event.key)
                if(event.key == 16777220)
                {
                    closeSoftwareInputPanel();

                    search();

                    topBar.showBackButton();
                    searchPageParenFilter.hidePageToLeft()
                    searchPageResultListing.showPageFromRight()
                    loadingCover.showLoadingCover();

                    glValue.currentPage = "searchPageResultListing"
                    glValue.searchCurrentPage = "searchPageResultListing"

                    if(searchTextInput.text != "")
                        console.log("QML: Search for \"" + searchTextInput.text + "\"")
                }
            }
        }

        Image {
            x: 14 * glValue.appUIWidth / 360
            y: 145 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: 150 * glValue.appUIHeight / 640
            source: "images/filtlerBG.png"

            Text {
                anchors.fill: parent
                anchors.topMargin: 10
                anchors.leftMargin: 20
                font.pixelSize: 30
                color: "white"
                text: "Intructions"
            }
            Text {
                anchors.fill: parent
                anchors.topMargin: 50
                anchors.leftMargin: 20
                font.pixelSize: 25
                wrapMode: "WordWrap"
                color: "white"
                opacity: 0.8
                text: "Enter any keywords and hit search. Venues, events, areas, activity types, cuisines, etc ..."
            }
        }

        Image {
            x: 14 * glValue.appUIWidth / 360
            y: 310 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: 49 * glValue.appUIHeight / 640
            source: "images/filtlerBG.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    search()

                    topBar.showBackButton();
                    searchPageParenFilter.hidePageToLeft()
                    searchPageResultListing.showPageFromRight()
                    loadingCover.showLoadingCover();

                    glValue.currentPage = "searchPageResultListing"
                    glValue.searchCurrentPage = "searchPageResultListing"

                    if(searchTextInput.text != "")
                        console.log("QML: Search for \"" + searchTextInput.text + "\"")
                }
            }

            Text {
                anchors.centerIn: parent
                font.pixelSize: 35
                font.bold: true
                color: "white"
                text: "GO!"
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: searchPageParenFilter; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: searchPageParenFilter; x: -pageContent.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: searchPageParenFilter; x: pageContent.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
