import QtQuick 1.0

Item {
    id:searchPageResultListing
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0
    property int inLoadingMoreStage: 0
    property int totalNumberOfResult: 0
    property string tempString: ""

    property string resultType: "";

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        searchPageResultListing.state = "";
        searchPageResultListing.state = "hideLeft"
        searchPageResultListing.state = "show"
    }

    function showPageFromRight()
    {
        searchPageResultListing.state = "";
        searchPageResultListing.state = "hideRight"
        searchPageResultListing.state = "show"
    }

    function hidePageToLeft()
    {
        searchPageResultListing.state = "";
        searchPageResultListing.state = "show"
        searchPageResultListing.state = "hideLeft"
    }

    function hidePageToRight()
    {
        searchPageResultListing.state = "";
        searchPageResultListing.state = "show"
        searchPageResultListing.state = "hideRight"
    }
    //----------------------- End ---------------------------------------
    //------------ Data Mainpulation ------------------------------------
    function resetAllData()
    {
        tempModel.clear();
        searchPageResultListingListModel.clear()
        totalNumberOfResult = 0
        inLoadingMoreStage = 0
    }

    ListModel {
        id: tempModel
    }

    function appendListModelsearchPageResultListing(numFound, title, desciption, imageUrl, apiUrl)
    {
        totalNumberOfResult = numFound

        tempModel.append({
                "elementID": tempModel.count,
                "elementImage": imageUrl,
                "elementTitle": title,
                "elementDescription": desciption,
                "elementApiUrl": apiUrl,
                "elementLoadingOpacity": 0
        })

        var array = new Array();
        for(var i=0; i<tempModel.count; i++) {
            array.push(tempModel.get(i).elementTitle);
        }

        searchPageResultListingListModel.clear();
        array.sort();

        for(i=0; i<array.length; i++)
        {
            for(var j=0; j<tempModel.count; j++)
            {
                if(tempModel.get(j).elementTitle == array[i])
                {
                    searchPageResultListingListModel.append({
                        "elementID": searchPageResultListingListModel.count,
                        "elementImage": tempModel.get(j).elementImage,
                        "elementTitle": tempModel.get(j).elementTitle,
                        "elementDescription": tempModel.get(j).elementDescription,
                        "elementApiUrl": tempModel.get(j).elementApiUrl,
                        "elementLoadingOpacity": 0
                    })

                    break;
                }
            }
        }

        delete array;
    }

    function searchFinished()
    {
        loadingCover.hideLoadingCover()
    }

    function appendFinished()
    {
        var temp;
        if((searchPageResultListingListModel.count-1) % 10 === 0) {
            temp = (10 + 1);
        }
        else {
            temp = ((searchPageResultListingListModel.count-1) % 10 + 1)
        }
        searchPageResultListingListModel.remove(searchPageResultListingListModel.count - temp);
        inLoadingMoreStage = 0;
    }

    //------------ End Data Mainpulation ----------------------------------

    signal requireSearchPageRestaurantsDetail(string apiUrl);
    signal requireSearchPageBarsAndClubsDetail(string apiUrl);
    signal requireSearchPageNightlifeMusicDetail(string apiUrl);
    signal requireSearchPageFilmDetail(string apiUrl);
    signal requireSearchPageHotelDetail(string apiUrl);

    Item {
        id: pageContent
        x: 0
        y: 0
        width: parent.width
        height: parent.height

        Item {
            id: listContainer
            x: 14 * glValue.appUIWidth / 360
            y: 80 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: pageContent.height - (80*2 + 15) * glValue.appUIHeight / 640

            ListModel {
                id: searchPageResultListingListModel
            }

            Component {
                id: searchPageResultListingComponent

                Item {
                    id: searchPageResultListingDelegateItem
                    width: searchPageResultListingListView.width
                    height: 70 * glValue.appUIHeight / 640
                    smooth: true

                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            if(elementLoadingOpacity === 0)
                            {
                                //Version 1.2
                                if(elementApiUrl === "") {
                                    console.log("empty URL")
                                    return;
                                }

                                sql.checkIfFavouritesExisted(elementTitle, elementDescription, elementImage, elementApiUrl)

                                if(glValue.searchPageSelection == "Restaurants")
                                {
                                    searchPageRestaurantsDetail.resetData()

                                    searchPageRestaurantsDetail.f_title = elementTitle;
                                    searchPageRestaurantsDetail.f_desc = elementDescription;
                                    searchPageRestaurantsDetail.f_thumb = elementImage;
                                    searchPageRestaurantsDetail.f_apiUrl = elementApiUrl;


                                    topBar.showBackButton();
                                    loadingCover.showLoadingCover();

                                    requireSearchPageRestaurantsDetail(elementApiUrl);
                                    searchPageRestaurantsDetail.showPageFromRight();
                                    searchPageResultListing.hidePageToLeft();

                                    glValue.currentPage = "searchPageRestaurantsDetail"
                                    glValue.searchCurrentPage = "searchPageRestaurantsDetail"

                                }

                                else if(glValue.searchPageSelection == "Bars & Clubs")
                                {
                                    searchPageBarsClubsDetail.resetData()

                                    topBar.showBackButton();
                                    loadingCover.showLoadingCover();

                                    searchPageBarsClubsDetail.f_title = elementTitle;
                                    searchPageBarsClubsDetail.f_desc = elementDescription;
                                    searchPageBarsClubsDetail.f_thumb = elementImage;
                                    searchPageBarsClubsDetail.f_apiUrl = elementApiUrl;

                                    requireSearchPageBarsAndClubsDetail(elementApiUrl);
                                    searchPageBarsClubsDetail.showPageFromRight();
                                    searchPageResultListing.hidePageToLeft();

                                    glValue.currentPage = "searchPageBarsClubsDetail"
                                    glValue.searchCurrentPage = "searchPageBarsClubsDetail"

                                }

                                else if(glValue.searchPageSelection == "Nightlife & Music")
                                {
                                    searchPageNightLifeDetail.resetData()

                                    topBar.showBackButton();
                                    loadingCover.showLoadingCover();

                                    searchPageNightLifeDetail.f_title = elementTitle;
                                    searchPageNightLifeDetail.f_desc = elementDescription;
                                    searchPageNightLifeDetail.f_thumb = elementImage;
                                    searchPageNightLifeDetail.f_apiUrl = elementApiUrl;

                                    requireSearchPageNightlifeMusicDetail(elementApiUrl);
                                    searchPageNightLifeDetail.showPageFromRight();
                                    searchPageResultListing.hidePageToLeft();

                                    glValue.currentPage = "searchPageNightLifeDetail"
                                    glValue.searchCurrentPage = "searchPageNightLifeDetail"
                                }
                                else if(glValue.searchPageSelection == "Films")
                                {
                                    if(searchPageFilmDetail.status == Loader.Null)
                                        searchPageFilmDetail.source = "FilmDetail.qml"

                                    searchPageFilmDetail.item.resetData()

                                    topBar.showBackButton();
                                    loadingCover.showLoadingCover();

                                    //requireSearchPageFilmDetail(elementApiUrl);
                                    searchPageFilmDetail.item.showPageFromRight();
                                    searchPageResultListing.hidePageToLeft();

                                    searchPageFilmDetail.item.getFilmData(elementApiUrl);

                                    glValue.currentPage = "searchPageFilmDetail"
                                    glValue.searchCurrentPage = "searchPageFilmDetail"
                                }
                                else if(glValue.searchPageSelection == "Hotels")
                                {
                                    searchPageHotelDetail.resetData()

                                    topBar.showBackButton();
                                    loadingCover.showLoadingCover();

                                    searchPageHotelDetail.f_title = elementTitle;
                                    searchPageHotelDetail.f_desc = elementDescription;
                                    searchPageHotelDetail.f_thumb = elementImage;
                                    searchPageHotelDetail.f_apiUrl = elementApiUrl;

                                    requireSearchPageHotelDetail(elementApiUrl);
                                    console.log(elementApiUrl)
                                    console.log("---------------required")
                                    searchPageHotelDetail.showPageFromRight();
                                    searchPageResultListing.hidePageToLeft();

                                    glValue.currentPage = "searchPageHotelDetail"
                                    glValue.searchCurrentPage = "searchPageHotelDetail"
                                }
                            }
                        }
                    }

                    Image {
                        anchors.fill: parent
                        source: "images/listBGFull.png"
                    }

                    Image {
                        id: mainImage
                        x: 0
                        y: 0
                        width: 90 * glValue.appUIWidth / 360
                        height: 65 * glValue.appUIHeight / 640
                        fillMode: Image.PreserveAspectCrop
                        clip: true
                        source: elementImage
                        state: "hide"

                        states:
                        [
                            State
                            {
                                name: "show"
                                PropertyChanges { target: mainImage; opacity: 1 }
                            },
                            State
                            {
                                name: "hide"
                                PropertyChanges { target: mainImage; opacity: 0 }
                            }
                        ]
                        transitions:
                        [
                            Transition {
                                from: "hide"; to: "show"
                                PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                            }
                        ]

                        onStatusChanged: {
                            if(mainImage.status == 2) {
                                mainImageBusy.opacity = 0.8
                                rotation2.running = true
                            }
                            else if(mainImage.status == 1) {
                                mainImageBusy.opacity = 0
                                rotation2.running = false
                                mainImage.state = "show"
                            }
                            else {
                                mainImageBusy.opacity = 0
                                rotation2.running = false
                            }
                        }
                    }

                    //version 1.2
                    Image {
                        id: mainImageBusy
                        anchors.centerIn: mainImage
                        width: 25
                        height: 25
                        smooth: true
                        opacity: {
                            if(elementApiUrl == "") {
                                0
                            }
                            else {
                                if(elementLoadingOpacity == 1)
                                    0
                                else
                                    1
                            }
                        }
                        source: "images/busy.png"

                        RotationAnimation on rotation {
                            id: rotation2
                            loops: 10000
                            from: 0
                            to: 360
                            duration: 1200
                        }
                    }

                    //version 1.2
                    Text {
                        x: {
                            if(elementApiUrl == "") {
                                20 * glValue.appUIWidth / 360
                            }
                            else
                                100 * glValue.appUIWidth / 360
                        }
                        y: 3 * glValue.appUIHeight / 640
                        width: {
                            if(elementApiUrl == "") {
                                275 * glValue.appUIWidth / 360
                            }
                            else
                                195 * glValue.appUIWidth / 360
                        }
                        height: 35 * glValue.appUIHeight / 640
                        elide: Text.ElideRight
                        color: "white"
                        text: elementTitle
                        font.pixelSize: 25
                        font.bold: true
                        verticalAlignment: Text.AlignVCenter
                    }

                    //version 1.2
                    Text {
                        x: {
                            if(elementApiUrl == "") {
                                20 * glValue.appUIWidth / 360
                            }
                            else
                                100 * glValue.appUIWidth / 360
                        }
                        y: 30 * glValue.appUIHeight / 640
                        width: {
                            if(elementApiUrl == "") {
                                275 * glValue.appUIWidth / 360
                            }
                            else
                                195 * glValue.appUIWidth / 360
                        }
                        height: 35 * glValue.appUIHeight / 640
                        color: "white"
                        text: elementDescription
                        elide: Text.ElideRight
                        font.pixelSize: 20
                        verticalAlignment: Text.AlignVCenter
                    }

                    Image {
                        x: 300 * glValue.appUIWidth / 360
                        y: 18 * glValue.appUIHeight / 640
                        width: 27 * glValue.appUIWidth / 360
                        height: 32 * glValue.appUIHeight / 640
                        opacity: !elementLoadingOpacity
                        source: "images/arrow.png"
                    }

                    Image {
                        x: 0
                        y: 65 * glValue.appUIHeight / 640
                        width: parent.width
                        height: 5 * glValue.appUIHeight / 640
                        opacity: !elementLoadingOpacity
                        source: "images/listLine.png"
                    }

                    Image {
                        anchors.centerIn: parent
                        smooth: true
                        opacity: elementLoadingOpacity
                        source: "images/loading.png"

                        RotationAnimation on rotation {
                            id: rotation
                            loops: 10000
                            running: {
                                if(inLoadingMoreStage)
                                    true
                                else
                                    false
                            }

                            from: 0
                            to: 360
                            duration: 1000
                        }
                    }
/*
                    ListView.onAdd: SequentialAnimation {
                        PropertyAction { target: searchPageResultListingDelegateItem; property: "height"; value: 0 }
                        NumberAnimation { target: searchPageResultListingDelegateItem; property: "height"; to: 70; duration: 250; easing.type: Easing.InOutQuad }
                    }
                    ListView.onRemove: SequentialAnimation
                    {
                        PropertyAction { target: searchPageResultListingDelegateItem; property: "ListView.delayRemove"; value: true }
                        NumberAnimation { target: searchPageResultListingDelegateItem; property: "height"; to: 0; duration: 250; easing.type: Easing.InOutQuad }

                        // Make sure delayRemove is set back to false so that the item can be destroyed
                        PropertyAction { target: searchPageResultListingDelegateItem; property: "ListView.delayRemove"; value: false }
                    }
                */
                }
            }

            ListView {
                id: searchPageResultListingListView
                anchors.fill: parent
                model: searchPageResultListingListModel
                delegate: searchPageResultListingComponent

                onContentYChanged: {
                    if(searchPageResultListingListModel.count >= 10)
                    {
                        if(contentY >= contentHeight - 70 * glValue.appUIHeight / 640 * 5
                                && inLoadingMoreStage == 0)
                        {
                            inLoadingMoreStage = 1
                            console.log("read more")

                            searchPageParenFilter.searchMore(totalNumberOfResult, searchPageResultListingListModel.count)

                            if(searchPageResultListingListModel.count >= totalNumberOfResult-10){}
                            else
                            searchPageResultListingListModel.append({
                                    "elementID": searchPageResultListingListModel.count,
                                    "elementImage": "",
                                    "elementTitle": "",
                                    "elementDescription": "",
                                    "elementApiUrl": "",
                                    "elementLoadingOpacity": 1})
                        }
                    }
                }
            }
        }

        Image {
            x: 0
            y: 0
            width: 360 * glValue.appUIWidth / 360
            height: 80 * glValue.appUIHeight / 640
            source: "images/filtlerBGBG.png"
        }

        Image {
            id: abc
            x: 14 * glValue.appUIWidth / 360
            y: 15 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: 49 * glValue.appUIHeight / 640
            source: "images/filtlerBG.png"

            Text {
                anchors.fill: parent
                anchors.leftMargin: 15 * glValue.appUIWidth / 360
                verticalAlignment: Text.AlignVCenter
                font.pixelSize: 30
                font.bold: true
                color: "white"
                opacity: 0.8
                text: "Result Listing"
            }
        }

        Image {
            x: 14 * glValue.appUIWidth / 360
            y: 80 * glValue.appUIHeight / 640
            width: 25 * glValue.appUIWidth / 360
            height: 25 * glValue.appUIHeight / 640
            source: "images/topTenPageImageLeftConner.png"
        }

        Item {
            id: sponsorBanner
            x: 0
            y: pageContent.height - 80 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: 80 * glValue.appUIHeight / 640
            opacity: 1

            Image {
                anchors.fill: parent
                source: "images/topTenPageSponsorBannerBG.png"
            }

            Image {
                id: mainImage
                x: 10 * glValue.appUIWidth / 360
                y: 10 * glValue.appUIHeight / 640
                width: 340 * glValue.appUIWidth / 360
                height: 57 * glValue.appUIHeight / 640
                smooth: true
                source: glValue.adImageUrl
                state: "hide"

                states:
                [
                    State
                    {
                        name: "show"
                        PropertyChanges { target: mainImage; opacity: 1 }
                    },
                    State
                    {
                        name: "hide"
                        PropertyChanges { target: mainImage; opacity: 0 }
                    }
                ]
                transitions:
                [
                    Transition {
                        from: "hide"; to: "show"
                        PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                    }
                ]

                onStatusChanged: {
                    if(mainImage.status == 2) {
                        mainImageBusy.opacity = 0.8
                        rotation.running = true
                    }
                    else if(mainImage.status == 1) {
                        mainImageBusy.opacity = 0
                        rotation.running = false
                        mainImage.state = "show"
                    }
                }

                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        Qt.openUrlExternally(glValue.adApiUrl);
                    }
                }
            }

            Image {
                id: mainImageBusy
                anchors.centerIn: mainImage
                width: 25
                height: 25
                smooth: true
                opacity: 1
                source: "images/busy.png"

                RotationAnimation on rotation {
                    id: rotation
                    loops: 10000
                    from: 0
                    to: 360
                    duration: 1200
                }
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: searchPageResultListing; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: searchPageResultListing; x: -pageContent.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: searchPageResultListing; x: pageContent.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}

