import QtQuick 1.0

Rectangle {
    id: sharePage
    state: "hide"

    function showsharePage()
    {
        sharePage.state = "show"
        blankCover.showPage();

        viaEmail.source = "images/shareTop.png"
        viaFacebook.source = "images/shareMid.png"
        viaTwitter.source = "images/shareBottom.png"

        byEmail = false;
        byFacebook = false;
        byTwitter = false;
    }

    function hidesharePage()
    {
        sharePage.state = "hide"
        blankCover.hidePage();
    }

    property bool byEmail: false
    property bool byFacebook: false
    property bool byTwitter: false

    property string url: "";
    property string title: "";

    Image {
        id: viaEmail
        x: 0
        y: 0
        width: parent.width
        height: 98 * glValue.appUIHeight / 640
        source: "images/shareTop.png"

        MouseArea {
            x: 0
            y: 42 * glValue.appUIHeight / 640
            width: parent.width
            height: 56 * glValue.appUIHeight / 640

            onClicked: {
                viaEmail.source = "images/shareTopOn.png"
                viaFacebook.source = "images/shareMid.png"
                viaTwitter.source = "images/shareBottom.png"

                byEmail = true;
            }
        }
    }

    Image {
        id: viaFacebook
        x: 0
        y: 98 * glValue.appUIHeight / 640
        width: parent.width
        height: 52 * glValue.appUIHeight / 640
        source: "images/shareMid.png"

        MouseArea {
            anchors.fill: parent
            onClicked: {
                viaEmail.source = "images/shareTop.png"
                viaFacebook.source = "images/shareMidOn.png"
                viaTwitter.source = "images/shareBottom.png"

                byFacebook = true;
            }
        }
    }

    Image {
        id: viaTwitter
        x: 0
        y: 150 * glValue.appUIHeight / 640
        width: parent.width
        height: 124 * glValue.appUIHeight / 640
        source: "images/shareBottom.png"

        MouseArea {
            x: 0
            y: 0
            width: parent.width
            height: 63 * glValue.appUIHeight / 640
            onClicked: {
                viaEmail.source = "images/shareTop.png"
                viaFacebook.source = "images/shareMid.png"
                viaTwitter.source = "images/shareBottomOn.png"

                byTwitter = true;
            }
        }

        MouseArea {
            x: 0
            y: 63 * glValue.appUIHeight / 640
            width: parent.width / 2
            height: 61 * glValue.appUIHeight / 640
            onClicked: {
                if(byEmail == true)
                {
                    console.log("email")
                    Qt.openUrlExternally("mailto:?subject=TimeOut&body=" + title + "\n" + url);
                }
                else if(byFacebook == true)
                {
                    console.log("facebook")
                    var tempTitle = title;
                    for(var j=0; j<100; j++)
                        tempTitle = tempTitle.replace(" ", "+");

                    var temp = "http://www.facebook.com/sharer.php?u=" + url + "&t=" + tempTitle;
                    console.log(temp)

                    Qt.openUrlExternally(temp)
                }
                else if(byTwitter == true)
                {
                    console.log("twitter")
                    tempTitle = title;
                    for(var j=0; j<100; j++)
                        tempTitle = tempTitle.replace(" ", "+");
                    temp = "http://twitter.com/share?url=" + url + "&text=" + tempTitle
                    console.log(temp)
                    Qt.openUrlExternally(temp)
                }

                sharePage.hidesharePage();
            }
        }

        MouseArea {
            x: parent.width / 2
            y: 63 * glValue.appUIHeight / 640
            width: parent.width / 2
            height: 61 * glValue.appUIHeight / 640
            onClicked: {
                sharePage.hidesharePage();
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: sharePage; y: 366 * glValue.appUIHeight / 640; opacity: 1 }
        },
        State
        {
            name: "hide"
            PropertyChanges { target: sharePage; y: glValue.appUIHeight; opacity: 0 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hide"
            PropertyAnimation { properties: "y, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hide"; to: "show"
            PropertyAnimation { properties: "y, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
