import QtQuick 1.0

Rectangle {

    id: topTenFilmDetail
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        topTenFilmDetail.state = "";
        topTenFilmDetail.state = "hideLeft"
        topTenFilmDetail.state = "show"
    }

    function showPageFromRight()
    {
        topTenFilmDetail.state = "";
        topTenFilmDetail.state = "hideRight"
        topTenFilmDetail.state = "show"
    }

    function hidePageToLeft()
    {
        topTenFilmDetail.state = "";
        topTenFilmDetail.state = "show"
        topTenFilmDetail.state = "hideLeft"

        timer.running = false
    }

    function hidePageToRight()
    {
        topTenFilmDetail.state = "";
        topTenFilmDetail.state = "show"
        topTenFilmDetail.state = "hideRight"

        timer.running = false
    }
    //----------------------- End ---------------------------------------

    property string f_uid: "";
    property string f_name: "";
    property string f_cert: "";
    property string f_released: "";
    property string f_duration: "";
    property string f_description: "";
    property string f_imageUrl: "";
    property string f_starRating: "";
    property string f_webUrl: "";

    property string f_genre: "";
    property string f_director: "";
    property string f_cast: "";
    property string temp_f_director: "";
    property string temp_f_cast: "";

    function receiveGeneralData(uid, name, cert, released,
                                duration, description, imageUrl,
                                starRating, webUrl)
    {
        textFlick.opacity = 1;

        f_uid = uid
        f_name = name
        f_cert = cert
        f_released = released
        f_duration = duration
        f_description = description
        f_imageUrl = imageUrl
        f_starRating = starRating
        f_webUrl = webUrl

        timer.running = true;
    }

    Timer {
        id: timer
        interval: 500; running: false; repeat: true
        onTriggered: setData()
    }

    function setData()
    {
        loadingCover.hideLoadingCover();

        f_director = temp_f_director
        f_cast = temp_f_cast

        if(f_imageUrl == "") {
            mainImage.height = 0;
            mainImageBusy.height = 0;
            rotation.running = false;
        }
        else {
            mainImage.height = (360/1.6667) * glValue.appUIHeight / 640;
            mainImageBusy.height = 35;
            rotation.running = true;
        }

        line_4.y = edit.paintedHeight + edit.y + 8
    }

    function receiveGenreData(genre)
    {
        if(f_genre == "") {
            f_genre = genre;
        }
        else {
            f_genre = f_genre + genre;
        }
    }

    function receiveDirectorData(director)
    {
        if(temp_f_director == "") {
            temp_f_director = director;
        }
        else {
            temp_f_director = temp_f_director + director;
        }
    }

    function receiveCastData(cast)
    {
        if(temp_f_cast == "") {
            temp_f_cast = cast;
        }
        else {
            temp_f_cast = temp_f_cast + cast;
        }
    }

    function resetData()
    {
        timer.running = false

        textFlick.opacity = 0;
        textFlick.contentY = 0;

        f_uid = "";
        f_name = "";
        f_cert = "";
        f_released = "";
        f_duration = "";
        f_description = "";
        f_imageUrl = "";
        f_starRating = "";
        f_webUrl = "";
        f_genre = "";
        f_director = "";
        f_cast = "";
    }


    Flickable {
        id: textFlick
        width: 360 * glValue.appUIWidth / 360;
        height: barsClubsDetail.height;
        contentWidth: 360
        contentHeight: releaseText.y + releaseText.height + 15
        flickableDirection: Flickable.VerticalFlick
        clip: true
        opacity: 0

        Text {
            id: titleText
            x: 10 * glValue.appUIWidth / 360
            y: 10
            width: 340 * glValue.appUIWidth / 360
            height: titleText.paintedHeight
            verticalAlignment: Text.AlignVCenter
            font.pixelSize: 40
            font.bold: true
            wrapMode: "WordWrap"
            text: f_name
        }

        Text {
            id: subTitleText
            x: 10 * glValue.appUIWidth / 360
            y: titleText.height + titleText.y
            width: 340 * glValue.appUIWidth / 360
            height: subTitleText.paintedHeight * glValue.appUIHeight / 640
            verticalAlignment: Text.AlignTop
            font.pixelSize: 25
            wrapMode: "WordWrap"
            text: f_genre
        }

        Image {
            id: line_1
            x: 8 * glValue.appUIWidth / 360
            y: subTitleText.height + subTitleText.y + 5
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Item {
            id: topStar
            x: 8 * glValue.appUIWidth / 360
            y: line_1.height + line_1.y + 10
            width: 360
            height: 30

            ListModel {
                id: topRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: topRatingComponent

                Item {
                    id: topRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: topRatingListView
                anchors.fill: parent
                model: topRatingListModel
                delegate: topRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Image {
            id: mainImage
            x: 0
            y: topStar.y + topStar.height + 8
            width: 360 * glValue.appUIWidth / 360
            height: (360/1.6667) * glValue.appUIHeight / 640
            source: f_imageUrl
            state: "hide"

            states:
            [
                State
                {
                    name: "show"
                    PropertyChanges { target: mainImage; opacity: 1 }
                },
                State
                {
                    name: "hide"
                    PropertyChanges { target: mainImage; opacity: 0 }
                }
            ]
            transitions:
            [
                Transition {
                    from: "hide"; to: "show"
                    PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                }
            ]

            onStatusChanged: {
                if(mainImage.status == 2) {
                    mainImageBusy.opacity = 0.8
                    rotation.running = true
                }
                else if(mainImage.status == 1) {
                    mainImageBusy.opacity = 0
                    rotation.running = false
                    mainImage.state = "show"
                }
            }
        }

        Image {
            id: mainImageBusy
            anchors.centerIn: mainImage
            width: 35
            height: 35
            smooth: true
            opacity: 1
            source: "images/busy.png"

            RotationAnimation on rotation {
                id: rotation
                loops: 10000
                from: 0
                to: 360
                duration: 1200
            }
        }

        Text {
            id: timeoutSays
            x: 8 * glValue.appUIWidth / 360
            y: mainImage.height + mainImage.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 30
            text: "Now Showing Here"
        }

        TextEdit {
            id: edit
            x: 8 * glValue.appUIWidth / 360
            y: timeoutSays.height + timeoutSays.y
            width: 344 * glValue.appUIWidth / 360
            height: edit.paintedHeight
            wrapMode: TextEdit.Wrap
            readOnly: true
            focus: false
            font.pixelSize: 25
            text: f_description
        }

        Image {
            id: line_4
            x: 8 * glValue.appUIWidth / 360
            y: edit.paintedHeight + edit.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: detailsText
            x: 8 * glValue.appUIWidth / 360
            y: line_4.height + line_4.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 30
            text: "Details"
        }

        Text {
            id: directorTitleText
            x: 8 * glValue.appUIWidth / 360
            y: detailsText.height + detailsText.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 25
            text: "Director"
        }

        Text {
            id: directorText
            x: 8 * glValue.appUIWidth / 360
            y: directorTitleText.height + directorTitleText.y + 3
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 22
            wrapMode: "WordWrap"
            text: f_director
        }

        Text {
            id: castTitleText
            x: 8 * glValue.appUIWidth / 360
            y: directorText.height + directorText.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 25
            text: "Cast"
        }

        Text {
            id: castText
            x: 8 * glValue.appUIWidth / 360
            y: castTitleText.height + castTitleText.y + 3
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 22
            wrapMode: "WordWrap"
            text: f_cast
        }

        Text {
            id: durationTitleText
            x: 8 * glValue.appUIWidth / 360
            y: castText.height + castText.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 25
            text: "Duration"
        }

        Text {
            id: durationText
            x: 8 * glValue.appUIWidth / 360
            y: durationTitleText.height + durationTitleText.y + 3
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 22
            wrapMode: "WordWrap"
            text: f_duration
        }

        Text {
            id: releaseTitleText
            x: 8 * glValue.appUIWidth / 360
            y: durationText.height + durationText.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 25
            text: "Release"
        }

        Text {
            id: releaseText
            x: 8 * glValue.appUIWidth / 360
            y: releaseTitleText.height + releaseTitleText.y + 3
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 22
            wrapMode: "WordWrap"
            text: f_released
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: topTenFilmDetail; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: topTenFilmDetail; x: -topTenFilmDetail.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: topTenFilmDetail; x: topTenFilmDetail.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]

}
