import QtQuick 1.0

Rectangle {

    id: topTenHotelDetail
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        topTenHotelDetail.state = "";
        topTenHotelDetail.state = "hideLeft"
        topTenHotelDetail.state = "show"
    }

    function showPageFromRight()
    {
        topTenHotelDetail.state = "";
        topTenHotelDetail.state = "hideRight"
        topTenHotelDetail.state = "show"

    }

    function hidePageToLeft()
    {
        topTenHotelDetail.state = "";
        topTenHotelDetail.state = "show"
        topTenHotelDetail.state = "hideLeft"

        timer.running = false
    }

    function hidePageToRight()
    {
        topTenHotelDetail.state = "";
        topTenHotelDetail.state = "show"
        topTenHotelDetail.state = "hideRight"

        timer.running = false
    }
    //----------------------- End ---------------------------------------

    //------------- Page Data ------------------------------------------
    property string f_title: "";
    property string f_desc: "";
    property string f_thumb: "";
    property string f_apiUrl: "";

    property string f_type: "";
    property string f_name: "";
    property string f_address: "";
    property string f_phone: "";
    property string f_url: "";
    property string f_travelInfo: "";
    property string f_lat: "";
    property string f_lng: "";
    property string f_imageUrl: "";
    property string f_webUrl: "";

    property string f_totalRating: "";
    property string f_foodRating: "";
    property string f_decorRating: "";
    property string f_serviceRating: "";
    property string f_ambienceRating: "";
    property string f_valueRating: "";


    function receiveDetailData(detailName, detailDetail)
    {
        detailListModel.append({
           "elementName": detailName,
           "elementDetail": detailDetail
        })
    }

    function receiveFacilitiesData(facilityName, facilityDetail)
    {
        facilitiesListModel.append({
           "elementName": facilityName,
           "elementDetail": facilityDetail
        })
    }

    function receiveRatingData(rating, name)
    {
        if(name == "Overall") {
            f_totalRating = rating;
            for(i=0; i<rating; i++)
                topRatingListModel.get(i).image = "images/starOn.png";
        }
        if(name == "Value") {
            f_foodRating = rating;
            for(i=0; i<rating; i++)
                foodRatingListModel.get(i).image = "images/starOn.png";
        }
        if(name == "Service") {
            f_decorRating = rating;
            for(i=0; i<rating; i++)
                decorRatingListModel.get(i).image = "images/starOn.png";
        }
        if(name == "Rooms") {
            f_serviceRating = rating;
            for(i=0; i<rating; i++)
                serviceRatingListModel.get(i).image = "images/starOn.png";
        }
        if(name == "Facilities") {
            f_ambienceRating = rating;
            for(i=0; i<rating; i++)
                ambienceRatingListModel.get(i).image = "images/starOn.png";
        }
        if(name == "Ambience") {
            f_valueRating = rating;
            for(i=0; i<rating; i++)
                valueRatingListModel.get(i).image = "images/starOn.png";
        }
    }

    function receiveEventData(eventsType, eventsUid, eventsName,
                              eventsAddress, eventsApiUrl, eventsWebUrl)
    {
        outletsListModel.append({
           "elementName": eventsName,
           "elementApiUrl": eventsApiUrl
        })
    }

    function receiveGeneralData(type, name, address,
                                phone, url, travelInfo,
                                lat, lng, imageUrl, webUrl)
    {
        loadingCover.hideLoadingCover();
        textFlick.opacity = 1;

        f_type = type;
        f_name = name;
        f_address = address;
        f_phone = phone;
        f_url = url;
        f_travelInfo = travelInfo;
        f_lat = lat;
        f_lng = lng;
        f_imageUrl = imageUrl;
        f_webUrl = webUrl;

        timer.running = true;
    }

    Timer {
        id: timer
        interval: 50; running: false; repeat: true
        onTriggered: setData()
    }

    function setData()
    {
        if(f_imageUrl == "") {
            mainImage.height = 0;
            mainImageBusy.height = 0;
            rotation.running = false;
        }
        else {
            mainImage.height = (360/1.6667) * glValue.appUIHeight / 640;
            mainImageBusy.height = 35;
            rotation.running = true;
        }

        detailListView.height = detailListView.contentHeight;
        outletsListView.height = outletsListModel.count * 50;
        facilitiesListView.height = facilitiesListView.contentHeight;

    }

    function resetData()
    {
        f_title = "";
        f_desc = "";
        f_thumb = "";
        f_apiUrl = "";

        f_type = "";
        f_name = "";
        f_address = "";
        f_phone = "";
        f_url = "";
        f_travelInfo = "";
        f_lat = "";
        f_lng = "";
        f_imageUrl = "";
        f_webUrl = "";

        f_totalRating = "";
        f_foodRating = "";
        f_decorRating = "";
        f_serviceRating = "";
        f_ambienceRating = "";
        f_valueRating = "";

        for(i=0; i<7; i++) {
            topRatingListModel.get(i).image = "images/starOff.png";
            foodRatingListModel.get(i).image = "images/starOff.png";
            decorRatingListModel.get(i).image = "images/starOff.png";
            serviceRatingListModel.get(i).image = "images/starOff.png";
            ambienceRatingListModel.get(i).image = "images/starOff.png";
            valueRatingListModel.get(i).image = "images/starOff.png";
        }

        detailListModel.clear();
        facilitiesListModel.clear();
        outletsListModel.clear();

        textFlick.opacity = 0;
        textFlick.contentY = 0;

    }

    function sendFavouriteInfoFn()
    {
        sql.addFavouriteIoFo("", f_title, f_desc, f_thumb, f_apiUrl, "Hotels", "No", "", "", "");
    }

    function changeFavouriteButton()
    {
        if(glValue.ifExistFlag == true)
        {
            favouriteButton.source ="images/favouriteButtonOn.png"
        }
        else
        {
            favouriteButton.source ="images/favouriteButton.png"
        }
    }

    signal requireRestaurantsDetailOfHotel(string elementApiUrl);
    signal requireBarsClubsDetailOfHotel(string elementApiUrl);
    property string searchUrl: "";

    Flickable {
        id: textFlick
        width: 360 * glValue.appUIWidth / 360;
        height: restaurantsDetail.height;
        contentWidth: 360
        contentHeight: foodRating.height + foodRating.y + 15
        flickableDirection: Flickable.VerticalFlick
        clip: true
        opacity: 0

        Text {
            id: titleText
            x: 10 * glValue.appUIWidth / 360
            y: 10 * glValue.appUIHeight / 640
            width: 340 * glValue.appUIWidth / 360
            height: 40 * glValue.appUIHeight / 640
            verticalAlignment: Text.AlignVCenter
            font.pixelSize: 40
            font.bold: true
            wrapMode: "WordWrap"
            text: f_name
        }

        Text {
            id: subTitleText
            x: 10 * glValue.appUIWidth / 360
            y: titleText.paintedHeight + titleText.y
            width: 340 * glValue.appUIWidth / 360
            height: subTitleText.paintedHeight * glValue.appUIHeight / 640
            verticalAlignment: Text.AlignTop
            font.pixelSize: 25
            wrapMode: "WordWrap"
            text: f_address
        }

        Image {
            id: line_1
            x: 8 * glValue.appUIWidth / 360
            y: subTitleText.height + subTitleText.y + 5
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Item {
            id: topStar
            x: 8 * glValue.appUIWidth / 360
            y: line_1.height + line_1.y + 10
            width: 360 * glValue.appUIWidth / 360
            height: 30 * glValue.appUIHeight / 640

            ListModel {
                id: topRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: topRatingComponent

                Item {
                    id: topRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: topRatingListView
                anchors.fill: parent
                model: topRatingListModel
                delegate: topRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Image {
            x: 280 * glValue.appUIWidth / 360
            y: line_1.height + line_1.y + 3
            width: 73 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/mapButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    loadingCover.showLoadingCover();
                    mapsTopTenHotelDetail.resetData()
                    mapsTopTenHotelDetail.lat = f_lat;
                    mapsTopTenHotelDetail.lng = f_lng;
                    mapsTopTenHotelDetail.zoom = "17";

                    mapsTopTenHotelDetail.showMap();

                    mapsTopTenHotelDetail.showPageFromRight();
                    topTenHotelDetail.hidePageToLeft();

                    glValue.topTenCurrentPage = "mapsTopTenHotelDetail"
                    glValue.currentPage = "mapsTopTenHotelDetail"
                }
            }
        }

        Image {
            id: mainImage
            x: 0
            y: topStar.y + topStar.height + 8
            width: 360 * glValue.appUIWidth / 360
            height: (360/1.6667) * glValue.appUIHeight / 640
            source: f_imageUrl
            state: "hide"

            states:
            [
                State
                {
                    name: "show"
                    PropertyChanges { target: mainImage; opacity: 1 }
                },
                State
                {
                    name: "hide"
                    PropertyChanges { target: mainImage; opacity: 0 }
                }
            ]
            transitions:
            [
                Transition {
                    from: "hide"; to: "show"
                    PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                }
            ]

            onStatusChanged: {
                if(mainImage.status == 2) {
                    mainImageBusy.opacity = 0.8
                    rotation.running = true
                }
                else if(mainImage.status == 1) {
                    mainImageBusy.opacity = 0
                    rotation.running = false
                    mainImage.state = "show"
                }
            }
        }

        Image {
            id: mainImageBusy
            anchors.centerIn: mainImage
            width: 35 * glValue.appUIWidth / 360
            height: 35 * glValue.appUIHeight / 640
            smooth: true
            opacity: 1
            source: "images/busy.png"

            RotationAnimation on rotation {
                id: rotation
                loops: 10000
                from: 0
                to: 360
                duration: 1200
            }
        }

        Image {
            x: 8 * glValue.appUIWidth / 360
            y: mainImage.y + mainImage.height + 10
            width: 29 * glValue.appUIWidth / 360
            height: 35 * glValue.appUIHeight / 640
            source: "images/phoneButton.png"
        }

        Text {
            x: 50 * glValue.appUIWidth / 360
            y: mainImage.y + mainImage.height + 10
            font.pixelSize: 25
            text: f_phone
        }

        Image {
            id: callButton
            x: 240 * glValue.appUIWidth / 360
            y: mainImage.y + mainImage.height + 8
            width: 115 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/callButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    var temp = f_phone.replace(" ", "");
                    temp = temp.replace(" ", "");
                    temp = temp.replace(" ", "");
                    temp = temp.replace(" ", "");
                    temp = temp.replace(" ", "");

                    Qt.openUrlExternally("tel:" + temp)
                }
            }
        }

        Image {
            id: line_2
            x: 8 * glValue.appUIWidth / 360
            y: callButton.height + callButton.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Image {
            x: 8 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 10
            width: 34 * glValue.appUIWidth / 360
            height: 34 * glValue.appUIHeight / 640
            source: "images/websiteButton.png"
        }

        Text {
            x: 50 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 10
            font.pixelSize: 25
            text: "Website"
        }

        Image {
            id: viewButton
            x: 240 * glValue.appUIWidth / 360
            y: line_2.y + line_2.height + 8
            width: 115 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/viewButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    Qt.openUrlExternally(f_webUrl)
                }
            }
        }

        Image {
            id: line_3
            x: 8 * glValue.appUIWidth / 360
            y: viewButton.height + viewButton.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: detailsText
            x: 8 * glValue.appUIWidth / 360
            y: line_3.height + line_3.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 30
            text: "Details"
        }

        Item {
            id: detailList
            x: 8 * glValue.appUIWidth / 360
            y: detailsText.height + detailsText.y + 10
            width: 360 * glValue.appUIWidth / 360
            height: detailListView.contentHeight

            ListModel {
                id: detailListModel
            }

            Component {
                id: detailComponent

                Item {
                    id: detailDelegateItem
                    width: 344 * glValue.appUIWidth / 360
                    height: detailTextDetail.y + detailTextDetail.paintedHeight

                    Text {
                        id: detailTitleText
                        x: 0
                        y: 0
                        width: parent.width
                        font.pixelSize: 25
                        font.bold: true
                        text: elementName
                    }

                    Text {
                        id: detailTextDetail
                        x: 0
                        y: detailTitleText.paintedHeight + 3
                        width: parent.width
                        wrapMode: "WordWrap"
                        font.pixelSize: 25
                        text: elementDetail
                    }
                }
            }

            ListView {
                id: detailListView
                x: 0
                y: 0
                width: parent.width
                height: 0
                model: detailListModel
                delegate: detailComponent
                interactive: false
            }
        }

        Image {
            id: line_4
            x: 8 * glValue.appUIWidth / 360
            y: detailList.height + detailList.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: outletsText
            x: 8 * glValue.appUIWidth / 360
            y: line_4.height + line_4.y + 8 * glValue.appUIHeight / 640
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 30
            text: "Outlets in the hotel"
        }

        Item {
            id: outletsList
            x: 8 * glValue.appUIWidth / 360
            y: outletsText.height + outletsText.y + 10 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: outletsListView.height

            ListModel {
                id: outletsListModel
            }

            Component {
                id: outletsComponent

                Item {
                    id: outletsDelegateItem
                    width: 344 * glValue.appUIWidth / 360
                    height: 50 * glValue.appUIHeight / 640

                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            loadingCover.showLoadingCover();
                            console.log(elementApiUrl)
                            searchUrl = elementApiUrl

                            if(searchUrl.indexOf("getRestaurant") != -1)
                            {
                                topTenRestaurantsDetail.resetData()
                                console.log("-----------topTenRestaurantsDetail")
                                requireRestaurantsDetailOfHotel(elementApiUrl)
                                topTenHotelDetail.hidePageToLeft()
                                topTenRestaurantsDetail.showPageFromRight()
                                topTenHotelDetail.resetData()

                                glValue.currentPage = "topTenRestaurantsDetail"
                                glValue.topTenCurrentPage= "topTenRestaurantsDetail"
                            }
                            else if(searchUrl.indexOf("getBar") != -1)
                            {
                                topTenBarsClubsDetail.resetData()
                                console.log("-----------topTenBarsClubsDetail")
                                requireBarsClubsDetailOfHotel(elementApiUrl)
                                topTenHotelDetail.hidePageToLeft()
                                topTenBarsClubsDetail.showPageFromRight()
                                topTenHotelDetail.resetData()

                                glValue.currentPage = "topTenBarsClubsDetail"
                                glValue.topTenCurrentPage= "topTenBarsClubsDetail"
                            }
                        }
                    }

                    Image {
                        x: 0
                        y: 0
                        width: 340 * glValue.appUIWidth / 360
                        height: 2 * glValue.appUIHeight / 640
                        source: "images/line.png"
                    }

                    Text {
                        anchors.fill: parent
                        anchors.topMargin: 13
                        font.bold: true
                        font.pixelSize: 25
                        text: elementName
                    }

                    Image {
                        x: 300 * glValue.appUIWidth / 360
                        y: 13 * glValue.appUIHeight / 640
                        width: 26 * glValue.appUIWidth / 360
                        height: 31 * glValue.appUIHeight / 640
                        source: "images/arrow.png"
                    }
                }
            }

            ListView {
                id: outletsListView
                x: 0
                y: 0
                width: parent.width
                height: 0
                model: outletsListModel
                delegate: outletsComponent
                interactive: false
            }
        }

        Image {
            id: line_5
            x: 8 * glValue.appUIWidth / 360
            y: outletsList.y + outletsList.height + 30
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: facilitiesText
            x: 8 * glValue.appUIWidth / 360
            y: line_5.height + line_5.y + 8
            width: 344 * glValue.appUIWidth / 360
            font.bold: true
            font.pixelSize: 25
            text: "Facilities"
        }

        Item {
            id: facilitiesList
            x: 8 * glValue.appUIWidth / 360
            y: facilitiesText.height + facilitiesText.y + 10
            width: 360 * glValue.appUIWidth / 360
            height:facilitiesListView.contentHeight

            ListModel {
                id: facilitiesListModel
            }

            Component {
                id: facilitiesComponent

                Item {
                    id: facilitiesDelegateItem
                    width: 344 * glValue.appUIWidth / 360
                    height: facilitiesTextDetail.y + facilitiesTextDetail.paintedHeight

                    Text {
                        id: facilitiesTitleText
                        x: 0
                        y: 0
                        width: parent.width
                        font.pixelSize: 25
                        font.bold: true
                        text: elementName
                    }

                    Text {
                        id: facilitiesTextDetail
                        x: 0
                        y: facilitiesTitleText.paintedHeight + 3
                        width: parent.width
                        wrapMode: "WordWrap"
                        font.pixelSize: 25
                        text: elementDetail
                    }
                }
            }

            ListView {
                id: facilitiesListView
                x: 0
                y: 0
                width: parent.width
                height: 0
                model: facilitiesListModel
                delegate: facilitiesComponent
                interactive: false
            }
        }

        Image {
            id: line_6
            x: 8 * glValue.appUIWidth / 360
            y: facilitiesList.height + facilitiesList.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Image {
            id: favouriteButton
            x: 10 * glValue.appUIWidth / 360
            y: line_6.height + line_6.y + 8
            width: 160 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: {
                if(glValue.ifExistFlag == false)
                {
                    "images/favouriteButton.png"
                }
                else if(glValue.ifExistFlag == true)
                {
                    "images/favouriteButtonOn.png"
                }
            }
            MouseArea {
                anchors.fill: parent
                onClicked: {
                    if(glValue.ifExistFlag == false)
                    {
                        sendFavouriteInfoFn();
                        favouriteButton.source = "images/favouriteButtonOn.png"
                        glValue.ifExistFlag = true
                    }
                    else if(glValue.ifExistFlag == true)
                    {
                        sql.checkIfFavouritesExisted(f_title, f_desc, f_thumb, f_apiUrl)
                        if(glValue.ifExistFlag == true)
                        {
                            sql.deleteFavouritesExisted(f_title, f_desc, f_thumb, f_apiUrl)
                            favouriteButton.source = "images/favouriteButton.png"
                            glValue.ifExistFlag = false
                        }
                        else if(glValue.ifExistFlag == false)
                        {
                            glValue.ifExistFlag = false
                            favouriteButton.source = "images/favouriteButton.png"
                        }
                    }
                }
            }
        }

        Image {
            id: shareButtonImage
            x: 190 * glValue.appUIWidth / 360
            y: line_6.height + line_6.y + 8
            width: 160 * glValue.appUIWidth / 360
            height: 37 * glValue.appUIHeight / 640
            source: "images/shareButton.png"

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    sharePage.title = f_title;
                    sharePage.url = f_webUrl;

                    sharePage.showsharePage();
                }
            }
        }

        Image {
            id: line_7
            x: 8 * glValue.appUIWidth / 360
            y: shareButtonImage.height + shareButtonImage.y + 8
            width: 344 * glValue.appUIWidth / 360
            height: 5 * glValue.appUIHeight / 640
            source: "images/line.png"
        }

        Text {
            id: averageRatingText
            x: 8 * glValue.appUIWidth / 360
            y: line_7.height + line_7.y + 10
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Average user rating(25 ratings)"
        }

        Text {
            id: valueRatingText
            x: 8 * glValue.appUIWidth / 360
            y: averageRatingText.height + averageRatingText.y + 10
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Ambience"
        }

        Item {
            id: valueRating
            x: 110 * glValue.appUIWidth / 360
            y: averageRatingText.height + averageRatingText.y + 10
            width: 360
            height: 30

            ListModel {
                id: valueRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: valueRatingComponent

                Item {
                    id: valueRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: valueRatingListView
                anchors.fill: parent
                model:valueRatingListModel
                delegate: valueRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Text {
            id: ambienceRatingText
            x: 8 * glValue.appUIWidth / 360
            y: valueRatingText.height + valueRatingText.y + 10
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Facilities"
        }

        Item {
            id: ambienceRating
            x: 110 * glValue.appUIWidth / 360
            y: valueRatingText.height + valueRatingText.y + 10
            width: 360
            height: 30

            ListModel {
                id: ambienceRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: ambienceRatingComponent

                Item {
                    id: ambienceRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: ambienceRatingListView
                anchors.fill: parent
                model:ambienceRatingListModel
                delegate: ambienceRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Text {
            id: serviceRatingText
            x: 8 * glValue.appUIWidth / 360
            y: ambienceRatingText.height + ambienceRatingText.y + 10
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Rooms"
        }

        Item {
            id: serviceRating
            x: 110 * glValue.appUIWidth / 360
            y: ambienceRatingText.height + ambienceRatingText.y + 10
            width: 360
            height: 30

            ListModel {
                id: serviceRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: serviceRatingComponent

                Item {
                    id: serviceRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: serviceRatingListView
                anchors.fill: parent
                model:serviceRatingListModel
                delegate: serviceRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Text {
            id: decorRatingText
            x: 8 * glValue.appUIWidth / 360
            y: serviceRatingText.height + serviceRatingText.y + 10
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Service"
        }

        Item {
            id: decorRating
            x: 110 * glValue.appUIWidth / 360
            y: serviceRatingText.height + serviceRatingText.y + 10
            width: 360
            height: 30

            ListModel {
                id: decorRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: decorRatingComponent

                Item {
                    id: decorRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: decorRatingListView
                anchors.fill: parent
                model:decorRatingListModel
                delegate: decorRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }

        Text {
            id: foodRatingText
            x: 8 * glValue.appUIWidth / 360
            y: decorRatingText.height + decorRatingText.y + 10
            width: 344 * glValue.appUIWidth / 360
            font.pixelSize: 25
            text: "Value"
        }

        Item {
            id: foodRating
            x: 110 * glValue.appUIWidth / 360
            y: decorRatingText.height + decorRatingText.y + 10
            width: 360
            height: 30

            ListModel {
                id: foodRatingListModel

                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
                ListElement {image: "images/starOff.png"}
            }

            Component {
                id: foodRatingComponent

                Item {
                    id: foodRatingDelegateItem
                    width: 30 * glValue.appUIWidth / 360
                    height: 26 * glValue.appUIHeight / 640
                    smooth: true

                    Image {
                        anchors.fill: parent
                        smooth: true
                        source: image
                    }
                }
            }

            ListView {
                id: foodRatingListView
                anchors.fill: parent
                model:foodRatingListModel
                delegate: foodRatingComponent
                orientation: ListView.Horizontal
                spacing: 5
                interactive: false
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: topTenHotelDetail; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: topTenHotelDetail; x: -topTenHotelDetail.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: topTenHotelDetail; x: topTenHotelDetail.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
