import QtQuick 1.0

Item {
    id: topTenPage
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0
    property int ifSponsorBannerExist: 1

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        topTenPage.state = "";
        topTenPage.state = "hideLeft"
        topTenPage.state = "show"
    }

    function showPageFromRight()
    {
        topTenPage.state = "";
        topTenPage.state = "hideRight"
        topTenPage.state = "show"
    }

    function hidePageToLeft()
    {
        topTenPage.state = "";
        topTenPage.state = "show"
        topTenPage.state = "hideLeft"
    }

    function hidePageToRight()
    {
        topTenPage.state = "";
        topTenPage.state = "show"
        topTenPage.state = "hideRight"
    }
    //----------------------- End ---------------------------------------
    property string f_uid: "";
    property string f_name: "";
    property string f_section: "";
    property string f_imageUrl: "";
    property string f_apiUrl: "";
    property string f_description: "";

    signal signalRequireTopTen(string apiUrl)

    function receiveGeneralData(uid, name, section,
                                imageUrl, apiUrl, description)
    {
        f_uid =  uid
        f_name = name
        f_section = section
        f_imageUrl = imageUrl
        f_apiUrl = apiUrl
        f_description = description

        topTenPageListModel.append(
                        {"elementUid": f_uid,
                         "elementName": f_name,
                         "elementSection": f_section,
                         "elementImage": f_imageUrl,
                         "elementApiUrl": f_apiUrl,
                         "elementDescription": f_description,
                         "elementRanking": topTenPageListModel.count + 1})

        loadingCover.hideLoadingCover();

    }


    property bool loadAlready: false
    function loadTopTen()
    {
        if(loadAlready == false)
        {
            loadAlready = true;
            loadingCover.showLoadingCover();
            signalRequireTopTen("http://timeout.pm.fabriqate.com/mobile/xml/top10")
            //http://timeout.pm.fabriqate.com/mobile/xml/top10
            //http://timeout.111.gz.cn.fabriqate.com/mobile/xml/top10
        }
    }


    signal requireTopTenRestaurantDetail(string apiUrl);
    signal requireTopTenBarsClubsDetail(string apiUrl);
    signal requireTopTenHotelDetail(string apiUrl);
    signal requireTopTenFilmDetail(string apiUrl);
    signal requireTopTenNightLifeDetail(string apiUrl);

    Item {
        id: pageContent
        x: 0
        y: 0
        width: parent.width
        height: parent.height

        Item {
            id: listContainer
            x: 14 * glValue.appUIWidth / 360
            y: 80 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: pageContent.height - 80*2 * glValue.appUIHeight / 640

            ListModel {
                id: topTenPageListModel
            }

            Component {
                id: topTenPageComponent

                Item {
                    id: topTenPageDelegateItem
                    width: topTenPageListView.width
                    height: 70 * glValue.appUIHeight / 640
                    smooth: true

                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            sql.checkIfFavouritesExisted(elementName, elementDescription, elementImage, elementApiUrl)
                            glValue.topTenPageSelection = elementSection;
                            console.log("-----------------------------"+glValue.topTenPageSelection)
                            if(elementSection == "restaurants")
                            {

                                loadingCover.showLoadingCover();
                                topTenRestaurantsDetail.resetData()

                                topTenRestaurantsDetail.f_title = elementName;
                                topTenRestaurantsDetail.f_desc = elementDescription;
                                topTenRestaurantsDetail.f_thumb = elementImage;
                                topTenRestaurantsDetail.f_apiUrl = elementApiUrl;

                                topBar.showBackButton();

                                requireTopTenRestaurantDetail(elementApiUrl);
                                topTenRestaurantsDetail.showPageFromRight();
                                topTenPage.hidePageToLeft();

                                glValue.currentPage = "topTenRestaurantsDetail"
                                glValue.topTenCurrentPage = "topTenRestaurantsDetail"

                            }

                            else if(elementSection == "barsclubs")
                            {

                                loadingCover.showLoadingCover();
                                topTenBarsClubsDetail.resetData()

                                topTenBarsClubsDetail.f_title = elementName;
                                topTenBarsClubsDetail.f_desc = elementDescription;
                                topTenBarsClubsDetail.f_thumb = elementImage;
                                topTenBarsClubsDetail.f_apiUrl = elementApiUrl;

                                topBar.showBackButton();

                                requireTopTenBarsClubsDetail(elementApiUrl);
                                topTenBarsClubsDetail.showPageFromRight();
                                topTenPage.hidePageToLeft();


                                glValue.currentPage = "topTenBarsClubsDetail"
                                glValue.topTenCurrentPage = "topTenBarsClubsDetail"

                            }

                            else if(elementSection == "hotels")
                            {

                                loadingCover.showLoadingCover();
                                topTenHotelDetail.resetData()

                                topTenHotelDetail.f_title = elementName;
                                topTenHotelDetail.f_desc = elementDescription;
                                topTenHotelDetail.f_thumb = elementImage;
                                topTenHotelDetail.f_apiUrl = elementApiUrl;

                                topBar.showBackButton();

                                requireTopTenHotelDetail(elementApiUrl);
                                topTenHotelDetail.showPageFromRight();
                                topTenPage.hidePageToLeft();

                                glValue.currentPage = "topTenHotelDetail"
                                glValue.topTenCurrentPage = "topTenHotelDetail"

                            }
                            else if(elementSection == "film")
                            {
                                loadingCover.showLoadingCover();

                                if(topTenFilmDetail.status == Loader.Null)
                                    topTenFilmDetail.source = "FilmDetail.qml";

                                topTenFilmDetail.item.resetData()
                                topBar.showBackButton();

                                //requireTopTenFilmDetail(elementApiUrl);
                                topTenFilmDetail.item.showPageFromRight();
                                topTenPage.hidePageToLeft();

                                topTenFilmDetail.item.getFilmData(elementApiUrl);

                                glValue.currentPage = "topTenFilmDetail"
                                glValue.topTenCurrentPage = "topTenFilmDetail"

                            }
                            else if(elementSection == "nightlife")
                            {

                                loadingCover.showLoadingCover();
                                topTenNightlifeMusicDetail.resetData()
                                topBar.showBackButton();

                                topTenNightlifeMusicDetail.f_title = elementName;
                                topTenNightlifeMusicDetail.f_desc = elementDescription;
                                topTenNightlifeMusicDetail.f_thumb = elementImage;
                                topTenNightlifeMusicDetail.f_apiUrl = elementApiUrl;

                                requireTopTenNightLifeDetail(elementApiUrl);
                                topTenNightlifeMusicDetail.showPageFromRight();
                                topTenPage.hidePageToLeft();

                                glValue.currentPage = "topTenNightlifeMusicDetail"
                                glValue.topTenCurrentPage = "topTenNightlifeMusicDetail"

                            }

                        }
                    }

                    Image {
                        anchors.fill: parent
                        source: {
                            if(elementRanking == 10)
                            {
                                "images/listBGBottom.png"
                            }
                            else
                                "images/listBGFull.png"
                        }
                    }

                    Image {
                        id: mainImage
                        x: 0
                        y: 0
                        width: 90 * glValue.appUIWidth / 360
                        height: 65 * glValue.appUIHeight / 640
                        fillMode: Image.PreserveAspectCrop
                        clip: true
                        source: elementImage
                        state: "hide"

                        states:
                        [
                            State
                            {
                                name: "show"
                                PropertyChanges { target: mainImage; opacity: 1 }
                            },
                            State
                            {
                                name: "hide"
                                PropertyChanges { target: mainImage; opacity: 0 }
                            }
                        ]
                        transitions:
                        [
                            Transition {
                                from: "hide"; to: "show"
                                PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                            }
                        ]

                        onStatusChanged: {
                            if(mainImage.status == 2) {
                                mainImageBusy.opacity = 0.8
                                rotation.running = true
                            }
                            else if(mainImage.status == 1) {
                                mainImageBusy.opacity = 0
                                rotation.running = false
                                mainImage.state = "show"
                            }
                        }
                    }

                    Image {
                        id: mainImageBusy
                        anchors.centerIn: mainImage
                        width: 25
                        height: 25
                        smooth: true
                        opacity: 1
                        source: "images/busy.png"

                        RotationAnimation on rotation {
                            id: rotation
                            loops: 10000
                            from: 0
                            to: 360
                            duration: 1200
                        }
                    }

                    Text {
                        x: 95 * glValue.appUIWidth / 360
                        y: 5 * glValue.appUIHeight / 640
                        width: 30 * glValue.appUIWidth / 360
                        height: 50 * glValue.appUIHeight / 640
                        verticalAlignment: Text.AlignVCenter
                        color: "white"
                        font.pixelSize: 45
                        text: elementRanking
                    }

                    Text {
                        x: 145 * glValue.appUIWidth / 360
                        y: 3 * glValue.appUIHeight / 640
                        width: 140 * glValue.appUIWidth / 360
                        height: 35 * glValue.appUIHeight / 640
                        color: "white"
                        text: elementName
                        elide: Text.ElideRight
                        font.pixelSize: 25
                        verticalAlignment: Text.AlignVCenter
                    }

                    Text {
                        x: 145 * glValue.appUIWidth / 360
                        y: 30 * glValue.appUIHeight / 640
                        width: 140 * glValue.appUIWidth / 360
                        height: 35 * glValue.appUIHeight / 640
                        color: "white"
                        text: elementDescription
                        elide: Text.ElideRight
                        font.pixelSize: 20
                        verticalAlignment: Text.AlignVCenter
                    }

                    Image {
                        x: 300 * glValue.appUIWidth / 360
                        y: 18 * glValue.appUIHeight / 640
                        width: 27 * glValue.appUIWidth / 360
                        height: 32 * glValue.appUIHeight / 640
                        source: "images/arrow.png"
                    }

                    Image {
                        x: 0
                        y: 65 * glValue.appUIHeight / 640
                        width: parent.width
                        height: 5 * glValue.appUIHeight / 640
                        opacity: {
                            if(elementRanking == 10)
                                0
                            else
                                1
                        }

                        source: "images/listLine.png"
                    }
                }
            }

            ListView {
                id: topTenPageListView
                anchors.fill: parent
                model: topTenPageListModel
                delegate: topTenPageComponent

            }
        }

        Image {
            x: 0
            y: 0
            width: 360 * glValue.appUIWidth / 360
            height: 80 * glValue.appUIHeight / 640
            source: "images/filtlerBGBG.png"
        }

        Image {
            id: abc
            x: 14 * glValue.appUIWidth / 360
            y: 15 * glValue.appUIHeight / 640
            width: 332 * glValue.appUIWidth / 360
            height: 49 * glValue.appUIHeight / 640
            source: "images/filtlerBG.png"

            Text {
                anchors.fill: parent
                anchors.leftMargin: 15 * glValue.appUIWidth / 360
                verticalAlignment: Text.AlignVCenter
                font.pixelSize: 40
                font.bold: true
                color: "white"
                opacity: 0.8
                text: "Top 10"
            }
        }

        Image {
            x: 14 * glValue.appUIWidth / 360
            y: 80 * glValue.appUIHeight / 640
            width: 25 * glValue.appUIWidth / 360
            height: 25 * glValue.appUIHeight / 640
            source: "images/topTenPageImageLeftConner.png"
        }

        Item {
            id: sponsorBanner
            x: 0
            y: pageContent.height - 80 * glValue.appUIHeight / 640
            width: 360 * glValue.appUIWidth / 360
            height: 80 * glValue.appUIHeight / 640
            opacity: 1

            Image {
                anchors.fill: parent
                source: "images/topTenPageSponsorBannerBG.png"
            }

            Image {
                id: mainImage
                x: 10 * glValue.appUIWidth / 360
                y: 10 * glValue.appUIHeight / 640
                width: 340 * glValue.appUIWidth / 360
                height: 57 * glValue.appUIHeight / 640
                smooth: true
                source: glValue.adImageUrl
                state: "hide"

                states:
                [
                    State
                    {
                        name: "show"
                        PropertyChanges { target: mainImage; opacity: 1 }
                    },
                    State
                    {
                        name: "hide"
                        PropertyChanges { target: mainImage; opacity: 0 }
                    }
                ]
                transitions:
                [
                    Transition {
                        from: "hide"; to: "show"
                        PropertyAnimation { properties: "opacity"; duration: 500; easing.type: Easing.InOutQuad }
                    }
                ]

                onStatusChanged: {
                    if(mainImage.status == 2) {
                        mainImageBusy.opacity = 0.8
                        rotation.running = true
                    }
                    else if(mainImage.status == 1) {
                        mainImageBusy.opacity = 0
                        rotation.running = false
                        mainImage.state = "show"
                    }
                }

                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        Qt.openUrlExternally(glValue.adApiUrl);
                    }
                }
            }

            Image {
                id: mainImageBusy
                anchors.centerIn: mainImage
                width: 25
                height: 25
                smooth: true
                opacity: 1
                source: "images/busy.png"

                RotationAnimation on rotation {
                    id: rotation
                    loops: 10000
                    from: 0
                    to: 360
                    duration: 1200
                }
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: topTenPage; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: topTenPage; x: -pageContent.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: topTenPage; x: pageContent.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
