import QtQuick 1.0
import QtWebKit 1.0

import "content"

Rectangle {
    id: webBrowser
    state: "hideLeft"

    //------------- Internal Globle Variable --------------------------
    property int i: 0

    //------------- Pages Moving Animation Control --------------------
    function showPageFromLeft()
    {
        webBrowser.state = "";
        webBrowser.state = "hideLeft"
        webBrowser.state = "show"
    }

    function showPageFromRight()
    {
        webBrowser.state = "";
        webBrowser.state = "hideRight"
        webBrowser.state = "show"
    }

    function hidePageToLeft()
    {
        webBrowser.state = "";
        webBrowser.state = "show"
        webBrowser.state = "hideLeft"
    }

    function hidePageToRight()
    {
        webBrowser.state = "";
        webBrowser.state = "show"
        webBrowser.state = "hideRight"
    }
    //----------------------- End ---------------------------------------


    property string urlString : ""
    function setUrl(newUrl)
    {
        showPageFromRight();
        urlString = newUrl;
    }

    width: 800; height: 600
    color: "#343434"

    FlickableWebView {
        id: webView
        url: webBrowser.urlString
        onProgressChanged: header.urlChanged = false
        anchors { top: headerSpace.bottom; left: parent.left; right: parent.right; bottom: parent.bottom }
    }

    Item { id: headerSpace; width: parent.width; height: 62 }

    Header {
        id: header
        editUrl: webBrowser.urlString
        width: headerSpace.width; height: headerSpace.height
    }

    ScrollBar {
        scrollArea: webView; width: 8
        anchors { right: parent.right; top: header.bottom; bottom: parent.bottom }
    }

    ScrollBar {
        scrollArea: webView; height: 8; orientation: Qt.Horizontal
        anchors { right: parent.right; rightMargin: 8; left: parent.left; bottom: parent.bottom }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: webBrowser; x: 0; opacity: 1 }
        },
        State
        {
            name: "hideLeft"
            PropertyChanges { target: webBrowser; x: -webBrowser.width; opacity: 1 }
        },
        State
        {
            name: "hideRight"
            PropertyChanges { target: webBrowser; x: webBrowser.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hideLeft"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideLeft"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "show"; to: "hideRight"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hideRight"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 300; easing.type: Easing.InOutQuad }
        }
    ]
}
