import QtQuick 1.0

Rectangle {
    id: welcomePage
    state: "show"

    //---------- Application Initialize Finished -------------------
    function welcomeInitializeFinished()
    {
        console.log("QML: Initialize finished")
        sql.createTable();
        welcomePage.hidePage();
    }

    //------------------ General Functions -------------------------
    function showPage()
    {
        welcomePage.state = "show"
    }

    function hidePage()
    {
        welcomePage.state = "hide"
    }
    //-------- End General Funtions --------------------------------

    Rectangle {
        id: pageContent
        x: 0
        y: 0
        width: parent.width
        height: parent.height
        color: "black"

        Image {
            anchors.fill: parent
            source: "images/welcomeBG.png"

            Image {
                anchors.centerIn: parent
                width: 332
                height: 230
                source: "images/welcomeLogo.png"
            }

            MouseArea {
                anchors.fill: parent
                onClicked: {
                }
            }
        }
    }

    states:
    [
        State
        {
            name: "show"
            PropertyChanges { target: welcomePage; x: 0; opacity: 1 }
        },
        State
        {
            name: "hide"
            PropertyChanges { target: welcomePage; x: -welcomePage.width; opacity: 1 }
        }
    ]
    transitions:
    [
        Transition {
            from: "show"; to: "hide"
            PropertyAnimation { properties: "x, opacity"; duration: 500; easing.type: Easing.InOutQuad }
        },
        Transition {
            from: "hide"; to: "show"
            PropertyAnimation { properties: "x, opacity"; duration: 500; easing.type: Easing.InOutQuad }
        }
    ]
}
